// part of xfxbase;

// XFX LEVEL
import 'dart:typed_data';

import 'package:camera/camera.dart';
import 'package:flutter/material.dart';
import 'package:observable/observable.dart' as Observable;
import 'package:connectivity_plus/connectivity_plus.dart';
import 'package:xfxbase/XAppStateBase.dart';
import 'package:xfxbase/XFDataItem.dart';

import 'XArea.dart';

class XAppState extends XAppStateBase {
  XAppState() {
    _li_XAree.changes.listen((event) {
      notifyListeners();
    });
  }

  Future<ConnectivityResult> get connectivityResult async {
    return await Connectivity().checkConnectivity().then((value) {
      return value.first;
    });
  }

  late List<CameraDescription> cameras = <CameraDescription>[];
  bool isolate_Active = true;
  bool isOwner = false;
  bool isManager = false;
  bool homeLayoutComplex = false;
  bool xLayout_Rounded = false;
  double xLayout_Rounded_Radius = 0;

  bool xSYNC_DataPushing = false; //TODO da finire per il Sync automatico
  bool xSYNC_DataChanged = false; //TODO da finire per il Sync automatico

  String PgName_Login = 'Login';
  XArea _area_Active = XArea("", 0, Container());
  XArea get area_Active => _area_Active;
  set area_Active(XArea? newValue) {
    _area_Active = newValue!;
    notifyListeners();
  }

  BoxDecoration xBox_Decoration(XFDataItem item, {Color? backGround_Color, Color? border_Color, bool border_Visible = false, Color? backGround_Color_ItemSel, Border? border}) {
    return BoxDecoration(
        borderRadius: xLayout_Rounded ? BorderRadius.circular(xLayout_Rounded_Radius == 0 ? 20 : xLayout_Rounded_Radius) : null,
        color: item.isSel && item.isShowDetails == false ? (backGround_Color_ItemSel ?? Colors.grey[700]!.withAlpha(150)) : (backGround_Color ?? Colors.grey[900]),
        border: border_Visible
            ? border ??
                Border(
                  left: item.isShowDetails ? BorderSide(color: border_Color ?? backGround_Color ?? Colors.grey[900]!) : BorderSide.none,
                  right: item.isShowDetails ? BorderSide(color: border_Color ?? backGround_Color ?? Colors.grey[900]!) : BorderSide.none,
                  top: item.isShowDetails ? BorderSide(color: border_Color ?? backGround_Color ?? Colors.grey[900]!) : BorderSide.none,
                  bottom: item.isShowDetails ? BorderSide(color: border_Color ?? backGround_Color ?? Colors.grey[900]!) : BorderSide.none,
                )
            : null);
  }

  GlobalKey<ScaffoldState> scaffoldKey_MainMenu = GlobalKey<ScaffoldState>();

  List<XArea> liXMenuItem = List<XArea>.empty(growable: true);
  List<XAction> liXActions = List<XAction>.empty(growable: true);
  Observable.ObservableList<XArea> _li_XAree = Observable.ObservableList<XArea>();
  Observable.ObservableList<XArea> get li_XAree => _li_XAree;
}

class XAction {
  int? idx;
  String? key;
  String? toolTip;
  dynamic Function(XFDataItem?, void Function(void Function()) parentSetState, BuildContext context)? cmd;
  Color? background_Color;
  IconData? icon;
  Color? icon_Color;
  Uint8List? icon_Image;
  String? label;
  Color? label_Color;
  TextStyle? label_Style;
  bool fastAction;
  bool isVertical_BTN;
  bool autoClose;
  double? width;
  double? height;
  double? icon_Size;

  ///Se Pieno l'action farà vedere questo child
  Widget? child;

  ///true = LEFT e false = RIGHT
  bool leftORright;

  XAction(
    this.key,
    this.idx,
    this.label, {
    this.cmd,
    this.toolTip,
    this.background_Color,
    this.icon,
    this.leftORright = true,
    this.icon_Color,
    this.icon_Image,
    this.label_Color,
    this.width,
    this.height,
    this.icon_Size,
    this.label_Style,
    this.child,
    this.autoClose = false,
    this.fastAction = false,
    this.isVertical_BTN = true,
  });
}
