library xsch;

import 'dart:io';
import 'package:contacts_service/contacts_service.dart';
import 'package:audioplayers/audioplayers.dart';
import 'package:camera/camera.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:collection/collection.dart';
import 'package:date_field/date_field.dart';
import 'package:flutter/services.dart';
import 'package:flutter_keyboard_visibility/flutter_keyboard_visibility.dart';
import 'package:flutter_slidable/flutter_slidable.dart';
import 'package:flutter_sound/flutter_sound.dart';
import 'package:image_picker/image_picker.dart';
import 'package:intl/intl.dart';
import 'package:observable/observable.dart';
import 'package:permission_handler/permission_handler.dart';
import 'package:photo_view/photo_view.dart';
import 'package:photo_view/photo_view_gallery.dart';
import 'package:syncfusion_flutter_gauges/gauges.dart';
import 'package:uuid/uuid.dart';
import 'package:video_player/video_player.dart';
import 'package:xcommonwidgets/XViewWidgets/XResizer.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xfxbase/_XFX/XF_Col.dart';
import 'package:xfxbase/_XFX/XF_View.dart';
import 'package:xfxbase/xfxbase.dart';
import 'package:xfxwidgets/XActionsBase.dart';
import 'package:xfxwidgets/XF_ELENCO/XElencoXMedias.dart';
import 'package:xfxwidgets/XF_MAIN/XApp.dart';
import 'package:xtoolspackage/XLibStorage.dart';
import 'package:video_thumbnail/video_thumbnail.dart' as thumb;
import 'package:flutter/foundation.dart' as found;
import 'package:image/image.dart' as img;
import 'package:xtoolspackage/xtoolspackage.dart';
import '../XF_ELENCO/XPopUpMenuItem.dart';
import '../XF_MAIN/XAppState.dart';
import '../XMediaRecorder.dart';
import '../XTabItem.dart';
import '../xMediaItem.dart';
import '../xfxwidgets.dart';

part 'Xfx_SchComponents.dart';

class XScheda<T extends XFDataItem> extends StatefulWidget {
  //Ci facciamo passare l'oggetto da visualizzare T
  XScheda(
    this.itemInEdit,
    this.xView, {
    this.xApp,
    super.key,
    this.title,
    this.title_BackColor,
    this.title_Color,
    this.title_Widgets,
    this.xSchDialog_BTNok_label = "OK",
    this.xSchDialog_BTNcancel_label,
    this.modeDialog_Active = false,
    this.modePage_Active = true,
    this.editable = true,
    this.decoration,
    this.width,
    this.xCell_borderColor,
    this.xCell_borderColor_Disabled,
    this.xCell_labelColor_Disabled,
    this.xCell_MinHeight = 40,
    this.xHeader_AreaBorder,
    this.complexUI = false,
    this.allowAddDetts = false,
    this.allowViewDettsAlways = false,
    this.xHead_Show = true,
    this.xBottomBar_AddBTN_Detts_Active = true,
    this.xResizer_AddBTN_Detts = true,
    this.xOnBeforeAddDettLayout,
    this.onGetXMedia,
    this.onSetXMedia,
    this.onDelXMedia,
    this.listPoolXMedias_ToTake,
    this.xEditDialog_BTNs_ForEditValue = true,
    this.xIsActive_AddItem_DefaultBL = false,
  }) : super() {
    if (this.title_Widgets == null && modeDialog_Active == true) {
      //gestisco i titoli che verranno messi
      this.title_Widgets = [
        XContainerWithLabel(
          title,
          textStyle: XStyles.xStyTextForSubLabel(textColor: this.title_Color ?? XColors.foregroundLight),
          color: this.title_BackColor ?? XColors.backGroundTitleContainerForScheda_MAIN,
        )
      ];
    }
  }

  ///Oggetto originale della Scheda
  T itemInEdit;

  ///View Principale dell' Header della Scheda
  final XView xView;

  ///Legame della Scheda con XApp di dell'App
  XApp? xApp;

  ///Widgets da visualizzare nel Titolo della Scheda
  late List<Widget>? title_Widgets;

  ///Label dl bottone di Salva della Scheda in modalità Dialog
  String? xSchDialog_BTNok_label;

  bool xIsActive_AddItem_DefaultBL;

  ///Label dl bottone di Cancel della Scheda in modalità Dialog
  String? xSchDialog_BTNcancel_label;

  ///Titolo della Scheda
  String? title;

  ///Colore Background del titolo della Scheda
  Color? title_BackColor;

  ///Colore del titolo della Scheda
  Color? title_Color;

  ///Da Abilitare per avere la Scheda in Modalità Dialog
  bool modeDialog_Active;

  ///Da Abilitare per avere la Scheda in Modalità Pagina
  bool modePage_Active;

  ///Variabile che stabilisce se la Scheda ha modificato i Dati e quindi bisogna abilitare le logiche di Salvataggio
  bool editable;

  ///Abilita per vedere sempre i Tabs dei Dettagli senza avere l'obbligo che i dettagli siano pieni
  bool allowViewDettsAlways;

  ///Abilita per avere la UI formattata per una UI complessa con Widget Custom
  bool complexUI;

  ///Abilita per abilitare l'Aggiunta dei Dettagli nella Scheda
  bool allowAddDetts;

  ///Width dell'intera scheda usata solo se la Scheda è modePage_Active = false && modeDialog_Active = false
  double? width;

  ///Decorations dell'intera Scheda
  Decoration? decoration;

  ///Colore del Bordo delle Celle dell'Head della Scheda
  Color? xCell_borderColor;

  ///Colore del Bordo DISABILITATO delle Celle dell'Head della Scheda
  Color? xCell_borderColor_Disabled;

  ///Colore delle Labels DISABILITATE delle Celle dell'Head della Scheda
  Color? xCell_labelColor_Disabled;

  ///Altezza Minima delle Celle dell'Head della Scheda
  double xCell_MinHeight;

  bool? xHeader_AreaBorder;

  ///Visualizza o no l'Head della Scheda
  bool xHead_Show;

  ///Abilita o no il Bottone di Add dei Dettagli della Scheda dentro alla BottomBar
  bool xBottomBar_AddBTN_Detts_Active;

  ///Abilita o no il Bottone di Add dei Dettagli della Scheda a Destra del titolo che si trova nella Barra di Resize
  bool xResizer_AddBTN_Detts;

  ///Evento che precede l'aggiunta di un nuovo dettaglio
  Future Function(XView xView, XFDataItem item, void Function(void Function()) setState)? xOnBeforeAddDettLayout;

  ///Evento da riempire con l'evento di Get (API) dell' XMedia
  Future<XMediaItem?> Function(XMediaItem)? onGetXMedia;

  ///Evento da riempire con l'evento di Delete (API) degli XMedias
  Future Function(XMediaItem)? onDelXMedia;

  ///Evento da riempire con l'evento di Set (API) degli XMedias
  Future Function(XMediaItem)? onSetXMedia;

  ///Lista di XMedias da qui la Scheda puo prendere i Dati
  ObservableList<XMediaItem>? listPoolXMedias_ToTake;

  ///abilita o no per mostrare i Bottoni es. +1,+5 ecc nell'Editor della Cella della Scheda
  bool xEditDialog_BTNs_ForEditValue;
  @override
  State<XScheda<T>> createState() => XSchedaState<T>();
}

class XSchedaState<T extends XFDataItem> extends State<XScheda<T>> with TickerProviderStateMixin {
  //Propietà della Scheda
  ///Controller per il campo dello sconto all'interno dell'Alert, se si trova nella view dell'Header.
  TextEditingController xController_Sconto = TextEditingController();

  ///Controller per lo Scroll della Scheda
  ScrollController xController_Scroll = ScrollController();

  ///Controller per la Gestione dei Tabs princiali dei Detts della Scheda
  late TabController xController_Tab;

  ///Controller per la Gestione dei Tabs Dett dei Sub-Detts dei Dettagli della Scheda
  TabController? xController_Tab_Dett;

  ///Oggetto Clone utilizzato dalla Scheda come oggetto da editare che viene fillato nell'init della Sch e poi prima di spedire i dati della scheda viene copiato e inserito nell'oggetto originale widget.itemInEdit
  late T itemInEdit_Clone;

  ///Lista di appoggio degli items dei dettagli da ELIMINARE
  List<dynamic> liDelItems = List<dynamic>.empty(growable: true);

  ///Valore che gestische se la Scheda è da Salvare o NO
  ValueNotifier<bool> editedPage = ValueNotifier(false);

  ///Utilizzato per le Animazioni degli elenchi di Dettaglo
  TickerProvider? vsync;

  ///Stabilisce se la Scheda deve abilitare il Waiter
  bool isBusy = false;

  ///Stabilisce se l'editabilità deve essere fatta nelle celle della scheda o con un alert
  bool xCells_EditAlert_Active = true;

  ///Index del Tab corrente dei Tab principali non gli xTabs_Dett
  int xTab_CurrentIndex = 0;

  ///Classe dell'xTab Attivo dei Tab principali non gli xTabs_Dett
  XTabItem? xTab_Active = null;

  ///Formato per i DateTime che mostrerà la Scheda nei vari campi
  String xFormat_Date = "dd/MM/yyyy";

  ///Messaggio visualizzato nel Waiter quando la Scheda ha isBusy = true
  String xWaiterMessage = "";

  ///Decide se la Scheda conterrà XMediaItem o no, di conseguenza abilita varie logiche e comportamenti della UI
  bool xMedia_isActive = false;

  ///Variabile di appoggio per la creazione di Audio
  bool? xMedia_CreateAudio = false;

  ///File di appoggio utilizzato per il salvataggio e edit degli XMediaItem
  File? xFileUI;

  //Per far scomparire la UI sotto
  ///Decide se si è in edit o no
  bool enteredInEditOnCell = false;

  ///Bool per far comparire il BTN di save nella Scheda in Modalità AlertDialog
  bool btnUpdateChangesShow = false;

  ///Bool per Abilitare o Disabilitare i Bordi delle Celle
  bool borderColor_Active = false;

  ///Variabile di Titolo all'interno della barra di Resize delle aree della Scheda
  String? xResizable_Title;

  ///Percentuale dell'area ALTA della Scheda default => 0.4
  double xResizable_Percent_TopArea = 0.4;

  ///Percentuale dell'area BASSA della Scheda default => 0.6
  double xResizable_Percent_BottomArea = 0.6;

  //Variabili di Gestione delle XActions
  ///XActions a SINISTRA dell'Header
  List<XAction>? xActions_LEFT = List<XAction>.empty(growable: true);

  ///XActions a DESTRA dell'Header
  List<XAction>? xActions_RIGHT = List<XAction>.empty(growable: true);

  ///XActions nella BottomBar della Scheda
  List<XAction>? xActions_BOTTOMBAR = List<XAction>.empty(growable: true);

  ///XActions nella AppBar nell'Area delle Actions a Destra
  List<XAction>? xActions_APPBAR = List<XAction>.empty(growable: true);

  ///Width dell'Area delle XActions a SINISTRA dell'Header
  double? xActions_LEFT_Width;

  ///Width dell'Area delle XActions a DESTRA dell'Header
  double? xActions_RIGHT_Width;

  //Variabili per la Gestione degli XMedia
  ImagePicker? imagePicker;
  bool isTakingPhoto = false;
  bool isRecording = false;
  bool saving = false;
  List<XFile> _images = [];
  final picker = ImagePicker();

  //Lista degli XMedia a livello di Scheda su cui appoggio tutti i Media dell'Attore della Scheda
  final List<XMediaItem> liMediaRAW = List<XMediaItem>.empty(growable: true);

  //Lista degli XMedia appena ottenuti che verrà pulita una volta usciti dal Dialog dall'aggiunta degli XMedia
  found.ValueListenable<List<XMediaItem>> liXMedias_MediaRecorder = ValueNotifier<List<XMediaItem>>(List<XMediaItem>.empty(growable: true));

  //Variabili per la Gestione degli Audio
  List<AudioPlayer>? audioPlayers;
  int selectedPlayerIdx = 0;
  AudioPlayer get selectedAudioPlayer => audioPlayers![selectedPlayerIdx];
  FlutterSoundRecorder? _audioRecorder = FlutterSoundRecorder();

  ///Per gestire i Tab principali e dei figli
  ValueNotifier<List<XTabItem>> xTabs = ValueNotifier<List<XTabItem>>([]);
  List<XTabItem> xTabs_Detts = List<XTabItem>.empty(growable: true);

  List<XBottomNavigationBarItem> liBottomActions = List<XBottomNavigationBarItem>.empty(growable: true);

  //Variabili per la gestione dell' EditDialog
  List<XProp> xEditDialog_liProps = List<XProp>.empty(growable: true);
  String xEditDialog_EditCell = "";

  ///Massima lunghezza della riga nel caso di Scheda AlertDialog per la lunchezza delle righe nell'Header
  double xLayout_maxRowLen = 0.0;

  //Variabili per la gestione dello Style della Scheda
  ///Altezza dei campi dell'Header in caso siano Flex
  static double heightOfEntryField = 46;
  static Color color_Text = Color.fromARGB(255, 255, 255, 255);
  static Color color_LabelText = Color.fromARGB(255, 255, 255, 255);
  static Color color_HintText = Color.fromARGB(255, 105, 105, 105);
  static Color color_TextDisabled = Color.fromARGB(255, 75, 75, 75);
  static Color color_Border = Colors.grey[600]!; //Color.fromARGB(255, 62, 62, 62);
  static Color color_BorderDisabled = Colors.grey[600]!; // Color.fromARGB(255, 48, 48, 48);
  static Color color_AppBar_Background = Colors.grey[900]!;
  static Color color_BackGround_EditDialog = Color.fromARGB(255, 30, 30, 30);
  static Color? color_CellBackGorundDisabled;

  ///Spaziatura tra i Campi dell'Header
  static double widthBetweenCell = 10;

  void superSetState(VoidCallback fn) => setState(fn);
  bool isKeyboardVisible = false;
  @override
  void initState() {
    widget.xCell_borderColor = XSchedaState.color_Border;
    widget.xCell_borderColor_Disabled = XSchedaState.color_BorderDisabled;
    widget.xCell_labelColor_Disabled = XSchedaState.color_LabelText; //color_TextDisabled;

    if (widget.itemInEdit.id == "") widget.itemInEdit.isNew = true;

    //Inizializzo la Scheda
    init_Sch();

    //Riempio le liste delle Actions se si è aggiunto qualcosa
    xActions_LoadLists();

    //Riempio i Tabs
    _xfillxTabs();

    //Inizializzo la BottomBar
    xBottomBarAction_Fill();

    //Inizializzo le TABS con le liste dei Detts della Scheda
    if (xTabs.value.isNotEmpty) xTab_Active = xTabs.value.first;

    //Inizializzo l'Audio player per la gestione degli Audio
    audioPlayers = [AudioPlayer(playerId: "1")];
    super.initState();
    Future.delayed(
      Duration(milliseconds: 500),
      () async {
        KeyboardVisibilityController().onChange.listen((bool visible) {
          isKeyboardVisible = visible;
        });
      },
    );
  }

  @override
  void dispose() {
    xController_Scroll.dispose();
    if (_audioRecorder != null) {
      _audioRecorder!.closeRecorder();
      _audioRecorder = null;
    }
    super.dispose();
  }

  ///Inizializzo la scheda riempendo l'Item Clone per avere possibilità di fare UNDO
  /// mi cerco in li*Raw i miei dettagli
  init_Sch() {
    itemInEdit_Clone = widget.itemInEdit.getCloneFull() as T;
    xUpdateCaption();
  }

  ///Da Overridare per gestire il salvatggio dei dati su Cloud o DB
  xOnSaveAfter() async {
    throw Exception("DEVI OVERRIDE questo metodo! xOnSaveAfter");
  }

  ///Override per la gestione dei Calcoli di tutta la Scheda
  calcDoc(XCol? xCol, dynamic newValue) {}

  /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T ///
  /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T ///
  /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T ///
  /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T ///
  /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T ///
  /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T /// /// L A Y O U T ///

  ///Da overridare per sovrascrivere il Widget all'interno dell'EdiDialog
  Widget? xEditDialog_Override_Editor(String title, dynamic value, XCol<dynamic> xCol, TextEditingController controller, {dynamic item}) {
    return null;
  }

  ///Da Overridare per gestire gestire i titoli delle sezioni delle celle nell'HEAD
  Widget xLayout_GetTitleWidget(int originY) {
    if (widget.modePage_Active) {
      return Container(width: 0, height: 0);
    } else {
      if (widget.title_Widgets == null || widget.title_Widgets!.isEmpty) {
        return Container(width: 0, height: 0);
      } else {
        var titleIdxFromOriginY = 0;
        if (originY > 0) {
          titleIdxFromOriginY = originY ~/ 2;
          if (titleIdxFromOriginY > widget.title_Widgets!.length - 1) titleIdxFromOriginY = 0;
        }
        return widget.title_Widgets == null ? Container(width: 0, height: 0) : widget.title_Widgets![titleIdxFromOriginY];
      }
    }
  }

  ///Da overridare per aggiungere Widgets nelle Actions dell'AppBar
  List<XAction?> xLayout_AppBar_AdditionalActions() {
    List<XAction?> li = List<XAction?>.empty(growable: true);
    if (widget.itemInEdit.getProp("liXMedia") != null && widget.onGetXMedia != null && widget.onSetXMedia != null && widget.onDelXMedia != null && widget.listPoolXMedias_ToTake != null) {
      li.add(XAction(
        "cantGallery",
        1,
        "Galleria",
        cmd: (item, parentSetState, context) async {
          Navigator.push(
              context,
              MaterialPageRoute(
                  builder: (context) => ElencoXMediaItem<T>(
                        widget.itemInEdit,
                        (p0) async => await widget.onGetXMedia!(p0),
                        (p0) async => await widget.onSetXMedia!(p0),
                        widget.listPoolXMedias_ToTake!,
                        (p0) async => await widget.onDelXMedia!(p0),
                        liToUse: widget.itemInEdit.getProp("liXMedia"),
                        xApp: widget.xApp,
                      )));
        },
        leftORright: false,
        background_Color: const Color.fromARGB(255, 0, 135, 5),
        icon: Icons.photo_album_outlined,
        label_Color: Colors.white,
      ));
    }
    return li;
  }

  ///Da overridare per Modificare la costruzione totale Dell'Item dei dettagli
  Widget? xLayout_ItemWidget(dynamic item) {
    return null;
  }

  ///Da overridare per aggiungere Widgets nel widget XResized prima del titolo
  List<Widget> xLayout_XResizer_AdditionalWidgets_BeforeTitle() {
    return [];
  }

  ///Da overridare per aggiungere Widgets nel widget XResized prima del titolo
  List<Widget> xLayout_XResizer_AdditionalWidgets_AfterTitle() {
    List<Widget> liWidget = List<Widget>.empty(growable: true);
    liWidget.clear();
    if (widget.xResizer_AddBTN_Detts && widget.editable && widget.allowAddDetts) {
      liWidget.add(XActionWidget(XActionsBase.addDett, xApp: widget.xApp, onPressed: () => xCMD_xOnAddDett()));
    }
    return liWidget;
  }

  ///Da overridare per Modificare la costruzione totale del Widget all'interno degli ItemDett delle ROW
  Widget? xTabViewDett_Widget(dynamic d, int idxTab, void Function(void Function()) parentSetState) {
    return null;
  }

  ///Da overridare per Modificare la costruzione totale della Pagina
  Widget? xLayout_BodyBuild() {
    return null;
  }

  // ///Da overridare per Modificare la costruzione totale della Pagina
  Widget xLayout_HeadBuild({XView? xclView}) {
    return StatefulBuilder(builder: (context, setState) {
      return Container(
          child: Scrollbar(
              thumbVisibility: true,
              controller: xController_Scroll,
              child: SingleChildScrollView(
                  controller: xController_Scroll,
                  child: Container(
                    margin: EdgeInsets.only(bottom: 10),
                    decoration: widget.decoration ?? BoxDecoration(),
                    child: Column(crossAxisAlignment: CrossAxisAlignment.start, mainAxisSize: MainAxisSize.min, children: widget.xHead_Show ? xLayout_Render_HeadView(xclView != null ? xclView : widget.xView) : []),
                  ))));
    });
  }

  bool isSchWeb = false;

  ///BUILDER DEI WIDGET EDITABILI///
  Container xLayout_CellWidget_Editable(XCol xCol, dynamic item, BuildContext context, dynamic itemToSet, {bool onBeforeCMD_Active = true, TextEditingController? controller}) {
    late Widget _widgetForCell;
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != bool) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        controller: controller,
        xCol: xCol,
        multiLines: xCol.width >= 200 ? true : false,
        editable: xCol.readOnly,
        borderColor: widget.xCell_borderColor,
        borderColor_Disabled: widget.xCell_borderColor_Disabled,
        labelColor_Disabled: widget.xCell_labelColor_Disabled,
        onSubmitted: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value),
        value: item[xCol.colKey] ?? "",
        onChanged: (value) => xCells_EditAlert_Active ? xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value) : xOnXCell_Edit_OnChanged(item, xCol, value),
        onBefore_Edit: xCells_EditAlert_Active
            ? () {
                if (onBeforeCMD_Active) xOnXCell_Before_Edit(xCol, item[xCol.colKey], itemToSet: itemToSet);
              }
            : null,
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          borderColor: widget.xCell_borderColor,
          borderColor_Disabled: widget.xCell_borderColor_Disabled,
          labelColor_Disabled: widget.xCell_labelColor_Disabled,
          format: xFormat_Date,
          onBefore_Edit: () => xOnXCell_Before_Edit(xCol, item),
          value: item[xCol.colKey] == DateTime(1900, 01, 01) ? null : item[xCol.colKey],
          onDateSelected: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      if (xCol.colKey.startsWith("avanz")) {
        if (xCol.readOnly) {
          _widgetForCell = Stack(alignment: Alignment.center, children: [
            LinearProgressIndicator(
              value: (item[xCol.colKey] / 100) ?? 0.0,
              minHeight: 20.0,
              backgroundColor: Colors.grey[300],
              valueColor: AlwaysStoppedAnimation<Color>(xCol.xmodelXprop.col_Color),
            ),
            Text('${item[xCol.colKey]}%', style: XStyles.xStyTextForLabel(textColor: Colors.black, activeBold: true)),
          ]);
        } else {
          _widgetForCell = StatefulBuilder(builder: (context, setState) {
            return SfLinearGauge(
                animateAxis: false,
                showTicks: false,
                showLabels: false,
                axisTrackStyle: LinearAxisTrackStyle(thickness: 40, color: Colors.grey[700]),
                orientation: LinearGaugeOrientation.horizontal, //
                barPointers: [
                  LinearBarPointer(
                    value: item[xCol.colKey],
                    color: xCol.xmodelXprop.col_Color,
                    thickness: 40,
                    animationDuration: 0,
                  )
                ],
                useRangeColorForAxis: true,
                markerPointers: <LinearMarkerPointer>[
                  LinearWidgetPointer(
                      value: item[xCol.colKey],
                      enableAnimation: false,
                      onChangeEnd: (value) {
                        editedPage.value = true;
                        xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, item[xCol.colKey]);
                      },
                      onChanged: (dynamic value) => setState(() => item[xCol.colKey] = (value as double).roundToDouble()),
                      child: Container(
                          width: 34,
                          height: 34,
                          decoration: BoxDecoration(color: Colors.grey[900], boxShadow: <BoxShadow>[BoxShadow(color: Colors.black54, offset: Offset(0.0, 1.0), blurRadius: 6.0)], shape: BoxShape.circle),
                          child: Center(
                              child: FittedBox(
                                  child: Text(item[xCol.colKey].toStringAsFixed(0) + "",
                                      style: XStyles.xStyTextForLabel(
                                        textColor: xCol.xmodelXprop.col_Color,
                                        activeBold: true,
                                      ))))))
                ]);
          });
        }
      } else {
        _widgetForCell = xSch_TextFormField_Builder(
            context: context,
            selectText: true,
            editable: xCol.readOnly,
            xCol: xCol,
            controller: controller,
            maxLines: 1,
            borderColor: widget.xCell_borderColor,
            borderColor_Disabled: widget.xCell_borderColor_Disabled,
            labelColor_Disabled: widget.xCell_labelColor_Disabled,
            onBefore_Edit: xCells_EditAlert_Active
                ? () {
                    if (onBeforeCMD_Active) xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
                  }
                : null,
            keyboardType: TextInputType.number,
            value: (item[xCol.colKey] == null || item[xCol.colKey].toString() == "0.0") ? "" : XUtils.xFormatDouble(context, item[xCol.colKey]),
            inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
            onSubmitted: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value)),
            onChanged: (value) {
              if (value != "")
                xCells_EditAlert_Active ? xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value)) : xOnXCell_Edit_OnChanged(item, xCol, double.parse(value));
              else
                xCells_EditAlert_Active ? xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, 0.0) : xOnXCell_Edit_OnChanged(item, xCol, 0.0);
            });
      }
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        controller: controller,
        xCol: xCol,
        borderColor: widget.xCell_borderColor,
        borderColor_Disabled: widget.xCell_borderColor_Disabled,
        labelColor_Disabled: widget.xCell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: xCells_EditAlert_Active
            ? () {
                if (onBeforeCMD_Active) xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
              }
            : null,
        onSubmitted: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value),
        value: (item[xCol.colKey] == null || item[xCol.colKey].toString() == "0") ? "" : XUtils.xFormatInt(context, item[xCol.colKey]),
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "")
            xCells_EditAlert_Active ? xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, int.parse(value)) : xOnXCell_Edit_OnChanged(item, xCol, int.parse(value));
          else
            xCells_EditAlert_Active ? xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, 0) : xOnXCell_Edit_OnChanged(item, xCol, 0);
        },
      );
    } else if (xCol.dataType == bool) {
      _widgetForCell = Container(
          child: XCheckBoxWidget(
        verticalCheckBoxWidget: true,
        label: xCol.colCaption,
        label_Color: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
        activeColor: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
        checkColor: XColors.foregroundDark,
        value: (item[xCol.colKey] ?? false),
        onChanged: (value) async => setState(() => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value)),
      ));
    } else {
      //DEVE essere W e H = 0 se no il Wrap fa casino nel gestirlo e va a "un po' a capo" dopo l'ultimo Widget
      return Container(width: 0, height: 0);
    }
    return Container(
      width: xCol.width,
      padding: xCol.dataType == DateTime ? EdgeInsets.only(top: 1 * (XUtils.kforScale)) : null,
      child: _widgetForCell,
    );
  }

  ///BUILDER DEI WIDGET NON EDITABILI///
  Container xLayout_CellWidget(XCol xCol, dynamic item, BuildContext context) {
    if (xCol.colKey.startsWith("li")) return Container();
    late Widget _widgetForCell;
    if (xCol.dataType == DateTime) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        xCol: xCol,
        multiLines: xCol.multilines,
        editable: xCol.allowEditing,
        hintText: "",
        onBefore_Edit: () {},
        value: XUtils.dateToString(item[xCol.colKey] != null ? item[xCol.colKey] : DateTime(1900, 01, 01), noDateLabel: ""),
        onChanged: (value) {},
      );
    } else if (xCol.dataType == bool) {
      _widgetForCell = Container(
          child: XCheckBoxWidget(
        verticalCheckBoxWidget: false,
        label: xCol.colCaption,
        label_Color: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
        activeColor: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
        checkColor: Colors.black,
        value: (item[xCol.colKey] ?? false),
      ));
    } else {
      if (xCol.colKey.startsWith("avanz")) {
        _widgetForCell = Stack(alignment: Alignment.center, children: [
          LinearProgressIndicator(
            value: (item[xCol.colKey] / 100) ?? 0.0,
            minHeight: 20.0,
            backgroundColor: Colors.grey[300],
            valueColor: AlwaysStoppedAnimation<Color>(xCol.xmodelXprop.col_Color),
          ),
          Text('${(item[xCol.colKey] as double).roundToDouble()}%', style: XStyles.xStyTextForLabel(textColor: Colors.black, activeBold: true)),
        ]);
      } else {
        _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          xCol: xCol,
          editable: xCol.allowEditing,
          multiLines: xCol.multilines,
          hintText: "",
          onBefore_Edit: () {},
          value: item[xCol.colKey].toString(),
          onChanged: (value) {},
        );
      }
    }

    //Se la colonna è Width FLEX
    if (xCol.resizeStyle == 0) {
      return Container(constraints: BoxConstraints.tightForFinite(height: XSchedaState.heightOfEntryField), child: Container(margin: EdgeInsets.symmetric(horizontal: 4), child: _widgetForCell));
    }
    //Se la colonna è Width PROPORTIONAL
    else if (xCol.resizeStyle == 1) {
      return Container(width: xCol.width, constraints: BoxConstraints(minHeight: widget.xCell_MinHeight, maxHeight: double.infinity, minWidth: xCol.width * .9, maxWidth: xCol.width * 1.2), margin: EdgeInsets.symmetric(horizontal: 4), child: _widgetForCell);
    }
    //Se la colonna è Width FIX
    else {
      return Container(constraints: BoxConstraints(minHeight: widget.xCell_MinHeight, maxHeight: double.infinity), width: xCol.width, margin: EdgeInsets.symmetric(horizontal: 4), child: _widgetForCell);
    }
  }

  ///Da overridare per modificare il Widget che verrà visualizzato al posto della lista vuota nei Dett della Scheda
  Widget xLayout_Widget_IfEmptyList(XFDataItem dataItem) {
    return Container();
  }

  ///Da overridare per Aggiungere Widgets nella parte bassa del Body della Scheda,posizionati sopra a tutto rispetto all'Asse Y
  List<Widget>? xLayout_BottomArea_OverSch() {
    return null;
  }

  ///Layout della Scheda se è visualizzata come Pagina completa
  Widget xLayout_asPage(BuildContext context) {
    return WillPopScope(
        onWillPop: () async => await xCMD_Back(),
        child: GestureDetector(
            onTap: () => FocusScope.of(context).unfocus(),
            child: Scaffold(
              // resizeToAvoidBottomInset: false,
              appBar: AppBar(toolbarHeight: xLayout_AppBar_AdditionalActions() != [] ? null : 40, iconTheme: IconThemeData(color: widget.title_BackColor ?? XColors.foregroundDark), title: Text(((widget.title ?? "").replaceAll("App", "")), style: XStyles.xStyTextForLabel(textColor: widget.title_BackColor ?? XColors.foregroundDark)), backgroundColor: widget.title_Color, actions: [
                Row(children: [
                  Container(
                      margin: EdgeInsets.only(bottom: 4, top: 5, right: 5),
                      child: Row(
                          children: xLayout_AppBar_AdditionalActions()
                              .map((e) => e != null
                                  ? XActionWidget(e, xApp: widget.xApp) //
                                  : Container())
                              .toList())),
                  editedPage.value
                      ? XActionWidget(XActionsBase.save, xApp: widget.xApp, onPressed: () async {
                          super.setState(() {
                            xWaiterMessage = "Sto salvando i tuoi dati..";
                            isBusy = true;
                          });
                          await xCMD_Save();
                          super.setState(() {
                            xWaiterMessage = "";
                            isBusy = false;
                          });
                        })
                      : Container(),
                ])
              ]),
              body: Stack(children: [
                xLayout_BodyBuild() != null
                    ? xLayout_BodyBuild() ?? Container()
                    : this.xTabs.value.isNotEmpty || widget.allowViewDettsAlways
                        ? XResizableWidget(
                            // key: GlobalKey(),
                            isHorizontalSeparator: true,
                            title: xResizable_Title ?? (this.xTabs.value.length <= 1 && this.xTabs.value.isNotEmpty ? this.xTabs.value.first.caption : ""),
                            separatorColor: (widget.title_Color ?? Colors.grey[700]!),
                            separatorSize: 42,
                            onResized: (infoList) {
                              if (isKeyboardVisible.not()) {
                                xResizable_Percent_TopArea = infoList.first.percentage < 0.1 ? 0.1 : double.parse(infoList.first.percentage.toStringAsFixed(1));
                                xResizable_Percent_BottomArea = infoList.last.percentage < 0.1 ? 0.1 : double.parse(infoList.last.percentage.toStringAsFixed(1));
                              }
                            },
                            xWidgets_BeforeTitle: xLayout_XResizer_AdditionalWidgets_BeforeTitle(),
                            xWidgets_AfterTitle: xLayout_XResizer_AdditionalWidgets_AfterTitle(),
                            percentages: [
                                xResizable_Percent_TopArea == 1.0 ? (xResizable_Percent_TopArea - 0.1) : (xResizable_Percent_TopArea),
                                xResizable_Percent_BottomArea == 1.0 ? (xResizable_Percent_BottomArea - 0.1) : (xResizable_Percent_BottomArea)
                              ],
                            children: [
                                widget.xHead_Show ? xLayout_HeadAreaBuilder(xclView: widget.xView) : Container(),
                                Stack(alignment: Alignment.bottomCenter, children: [
                                  this.xTabs.value.length <= 1
                                      ? this.xTabs.value.isNotEmpty
                                          ? (this.xTabs.value.map((x) => widget.complexUI ? x.content ?? Container() : x.xElencoToView ?? Container()).first)
                                          : Container()
                                      : XfxSchedaTabbed(
                                          margin_Horizontal: 0,
                                          tabs_BackGroundColor: Colors.grey[900],
                                          title_Color: widget.title_Color,
                                          currentTabIdx: ((xTabs.value.isEmpty || xTab_Active == null) ? (xTabs.value.isEmpty ? 0 : xTabs.value.first.idx) : xTab_Active!.idx),
                                          title_Visible: false,
                                          bottomBar_Visible: false,
                                          bottomBar_Children: [],
                                          numberOfTabs: this.xTabs.value.length,
                                          tabBar_OnTap: (idx) => xTab_Active = this.xTabs.value.firstWhere((element) => element.idx == idx),
                                          isScrollableTabs: this.xTabs.value.length >= 4 ? true : false,
                                          children: this.xTabs.value.map((x) => (widget.complexUI ? x.content ?? Container() : x.xElencoToView ?? Container())).toList(),
                                          xTabs: this.xTabs.value,
                                        ),
                                  Column(crossAxisAlignment: CrossAxisAlignment.end, mainAxisAlignment: MainAxisAlignment.end, children: xLayout_BottomArea_OverSch() ?? []),
                                ])
                              ])
                        : widget.xHead_Show
                            ? enteredInEditOnCell
                                ? Container()
                                : xLayout_HeadAreaBuilder(xclView: widget.xView)
                            : Container(),
                isBusy ? Container(color: Colors.black.withAlpha(180)) : Container(),
                isBusy ? XStatefulWidgetBase.LoaderIndicator(isBusy, label: xWaiterMessage) : Container(),
              ]),
              bottomNavigationBar: (liBottomActions.length > 1) && widget.editable
                  ? BottomNavigationBar(
                      key: UniqueKey(),
                      items: liBottomActions,
                      type: BottomNavigationBarType.fixed,
                      currentIndex: 0,
                      onTap: (value) async => await xBottomBarAction_OnTap_INTERNAL(value, setState),
                      enableFeedback: true,
                      showUnselectedLabels: true,
                      selectedFontSize: 15,
                      selectedLabelStyle: XStyles.xStyleText(fontSize: 14, colorText: XColors.foregroundLight),
                      backgroundColor: Colors.grey[900],
                      unselectedItemColor: XColors.foregroundLight,
                      unselectedFontSize: 10,
                      useLegacyColorScheme: false,
                      unselectedLabelStyle: XStyles.xStyleText(fontSize: 14, colorText: XColors.foregroundLight),
                      iconSize: 20,
                    )
                  : null,
              floatingActionButton: widget.editable
                  ? xLayout_FloatingAddBTN_Widget() == null
                      ? (liBottomActions.length == 1 ? xLayout_FloatingAddBTN(liBottomActions[0]) : null)
                      : xLayout_FloatingAddBTN_Widget()
                  : null,
            )));
  }

  ///Da overridare per Modificare il Widget nel FloatingActionButton della Scheda
  Widget? xLayout_FloatingAddBTN_Widget() {
    return null;
  }

  ///Da overridare per Modificare il Widget del Bottone di Add che si trova nel FloatingActionButton della Scheda
  Widget xLayout_FloatingAddBTN(XBottomNavigationBarItem xbtnBarItem) {
    return XBtnbase(
      margin: EdgeInsets.only(bottom: 20),
      width: 50,
      height: 50,
      radiusBorder: 10,
      toolTip_Message: "${xbtnBarItem.label}",
      icon_Widget: xbtnBarItem.icon,
      icon_WidthArea: 50,
      icon_Color: xbtnBarItem.backgroundColor ?? widget.title_Color,
      backGroundColor: Colors.grey[800]!.withAlpha(150),
      onPressed: () async => xBottomBarAction_OnTap_INTERNAL(0, setState),
    );
  }

  ///Widget che torna il Widget dell'Header della Scheda con anche gli slider a destra e sinistra con le azioni
  Widget xLayout_HeadAreaBuilder({XView? xclView}) {
    return widget.xHead_Show
        ? enteredInEditOnCell
            ? Container()
            : Container(
                alignment: Alignment.topCenter,
                child: Slidable(
                    key: ValueKey(0),
                    startActionPane: xActions_LEFT == null || xActions_LEFT!.isEmpty
                        ? null
                        : ActionPane(motion: ScrollMotion(), extentRatio: xActions_LEFT_Width ?? (xActions_LEFT!.length > 1 ? 0.5 : 0.3), dragDismissible: false, children: [
                            Container(
                                alignment: Alignment.topCenter,
                                child: Wrap(
                                    spacing: 3,
                                    runSpacing: 3,
                                    direction: Axis.vertical,
                                    children: xActions_LEFT!
                                        .map((xclAction) => XSlidableAction(
                                              flex: 1,
                                              autoClose: xclAction.autoClose,
                                              margin: EdgeInsets.only(bottom: 3),
                                              width: xclAction.width,
                                              height: xclAction.height,
                                              label_Style: xclAction.label_Style,
                                              isVertical_BTN: xclAction.isVertical_BTN,
                                              toolTip: xclAction.toolTip,
                                              action_Child: xclAction.child,
                                              onPressed: (context) async => await xclAction.cmd!(itemInEdit_Clone, setState, context),
                                              backgroundColor: xclAction.background_Color ?? Colors.grey[900]!,
                                              foregroundColor: xclAction.label_Color ?? xclAction.icon_Color ?? Colors.white,
                                              icon: xclAction.icon ?? null,
                                              icon_Image: xclAction.icon_Image ?? null,
                                              label: xclAction.label ?? "",
                                            ))
                                        .toList()))
                          ]),
                    endActionPane: xActions_RIGHT == null || xActions_RIGHT!.isEmpty
                        ? null
                        : ActionPane(motion: ScrollMotion(), extentRatio: xActions_LEFT_Width ?? (xActions_RIGHT!.length > 1 ? 0.5 : 0.3), dragDismissible: false, children: [
                            Container(
                                alignment: Alignment.topCenter,
                                child: Wrap(
                                    spacing: 3,
                                    runSpacing: 3,
                                    direction: Axis.vertical,
                                    children: xActions_RIGHT!
                                        .map((xclAction) => XSlidableAction(
                                              flex: 1,
                                              autoClose: xclAction.autoClose,
                                              margin: EdgeInsets.only(bottom: 3),
                                              width: xclAction.width,
                                              height: xclAction.height,
                                              label_Style: xclAction.label_Style,
                                              isVertical_BTN: xclAction.isVertical_BTN,
                                              toolTip: xclAction.toolTip,
                                              action_Child: xclAction.child,
                                              onPressed: (context) async => await xclAction.cmd!(itemInEdit_Clone, setState, context),
                                              backgroundColor: xclAction.background_Color ?? Colors.grey[900]!,
                                              foregroundColor: xclAction.label_Color ?? xclAction.icon_Color ?? Colors.white,
                                              icon: xclAction.icon ?? null,
                                              icon_Image: xclAction.icon_Image ?? null,
                                              label: xclAction.label ?? "",
                                            ))
                                        .toList()))
                          ]),
                    child: _buildWidgetOfHead(xclView: xclView!)))
        : Container();
  }

  Widget _buildWidgetOfHead({XView? xclView}) {
    var mqc = MediaQuery.of(context).size;
    return Container(
        alignment: Alignment.topCenter,
        child: Scrollbar(
            thumbVisibility: true,
            controller: xController_Scroll,
            child: SingleChildScrollView(
                controller: xController_Scroll,
                child: Container(
                    decoration: widget.decoration ?? BoxDecoration(),
                    child: Column(children: [
                      Container(
                          width: mqc.width,
                          child: Column(
                            crossAxisAlignment: CrossAxisAlignment.start,
                            children: xLayout_Render_HeadView(xclView != null ? xclView : widget.xView),
                          )),
                      xLayout_Head_BottomWidget(),
                    ])))));
  }

  ///Da Overridare per Aggiungere Widgets sotto l'Head della Scheda
  Widget xLayout_Head_BottomWidget() {
    return Container();
  }

  ///Da Overridare per Modificare la Renderizzazione delle celle all'Interno dell'Head
  List<Widget> xLayout_Render_HeadView(XView xview, {bool border_Visible = true}) {
    xLayout_maxRowLen = 0; //resetto
    var grps = xview.cols!
        . //
        groupListsBy((element) => element.originY)
        .entries
        .toList();
    var lastY = grps.last.key;
    double avgColsInY = 0;
    grps.map((e) => avgColsInY += e.value.length).toList();
    avgColsInY = avgColsInY / grps.length;
    var r = grps.map(
      (e) {
        //x ogni Y
        //x orgni sottoROW/grp
        double rowLen = 0;
        var child = xLayout_Render_HeadView_Widget_forY(
            e,
            e.value.map((e) {
              var xwidgt = widget.editable ? xLayout_CellWidget_Editable(e, itemInEdit_Clone, context, itemInEdit_Clone) : xLayout_CellWidget(e, itemInEdit_Clone, context);
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
            lastY,
            border_Visible: border_Visible,
            avgColsInY > 3);
        if (rowLen > xLayout_maxRowLen) xLayout_maxRowLen = rowLen;
        return child;
      },
    ).toList();

    return r;
  }

  ///Da overridare per Modificare la composizione dei pezzi dell'HEAD
  Widget xLayout_Render_HeadView_Widget_forY(
    MapEntry<int, List<XCol<dynamic>>> e,
    List<Widget> children,
    int lastY,
    bool border_separator, {
    bool border_Visible = true,
    Color? border_color,
  }) {
    late BoxDecoration? border;
    late EdgeInsets? margin;
    if (border_Visible) {
      if (lastY == e.key) {
        if (children.length == 1) {
          margin = null;
          border = BoxDecoration(
              border: Border(
            bottom: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight),
            left: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight),
            right: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight),
          ));
        } else {
          Color(0xff87d37c);
          //ultima e GRANDE
          margin = !border_separator ? null : EdgeInsets.only(top: 10);
          border = BoxDecoration(border: Border(bottom: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight), left: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight), right: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight), top: border_separator ? BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight) : BorderSide.none));
        }
      } else {
        //prima e altre Y
        margin = e.key == 0 || children.length == 1 || !border_separator ? null : EdgeInsets.only(top: 10);
        if (children.length == 1 || !border_separator)
          border = BoxDecoration(border: border_Visible ? Border.symmetric(vertical: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight)) : null);
        else
          border = BoxDecoration(border: border_Visible ? Border.all(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight) : null);
      }
    } else
      border = null;
    margin = null;
    return Container(
        decoration: border,
        margin: margin,
        //padding: border != null ? null : EdgeInsets.only(left: 5, right: 5),
        padding: EdgeInsets.only(left: 5, right: 5, top: 4),
        child: Column(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.start, children: [
          widget.modePage_Active ? Container(width: 0, height: 0) : xLayout_GetTitleWidget(e.key),
          widget.modePage_Active ? Container(width: 0, height: 0) : (widget.title_Widgets == null ? Container(width: 0, height: 0) : SizedBox(height: 15)),
          Container(
              padding: border_Visible ? EdgeInsets.only(bottom: 4, top: 4) : EdgeInsets.only(top: 0, bottom: 0, left: 0, right: 0),
              alignment: Alignment.topLeft,
              margin: border_Visible ? EdgeInsets.only(top: 5, left: 0, right: 0) : EdgeInsets.only(top: 0, bottom: 0, left: 0, right: 0),
              child: Wrap(
                runSpacing: 15,
                spacing: 5,
                direction: Axis.horizontal,
                alignment: WrapAlignment.start,
                runAlignment: WrapAlignment.start,
                crossAxisAlignment: WrapCrossAlignment.start,
                children: children,
              ))
        ]));
  }

  ///Widget per la costruzione dell'Head all'interno dei Dettagli
  Widget xLayout_xDett_Item_HeadWidget(dynamic itemDett, void Function(void Function()) parentSetState, {XView? xclViewUI}) {
    ScrollController? _scrollController = ScrollController();
    return Scrollbar(
        thumbVisibility: true,
        controller: _scrollController,
        child: SingleChildScrollView(
            controller: _scrollController,
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              mainAxisSize: MainAxisSize.min,
              children: widget.xHead_Show ? xLayout_Render_HeadView(xclViewUI!) : [],
            )));
  }

  ///Dialog Generico da Utilizzare
  Future<bool?> xLayout_Dialog(T item, {Widget? contentWidget, String? title, String? BTN_Label_YES, String? BTN_Label_NO, bool BTNno_Visible = true, String? BTN_Label, Function()? onPressed}) async {
    return await showDialog<bool>(
        barrierDismissible: false,
        context: context,
        builder: (context) {
          return XAlertDialog(
              title_Text: title ?? "Modifica il campo qui sotto:",
              title_Style: XStyles.xStyTextForTextBase(textColor: XColors.foregroundLight),
              child: contentWidget ?? Container(),
              actionsBTNarea_Child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                Expanded(
                    child: BTNno_Visible
                        ? XBtnbase(
                            label: BTN_Label_NO ?? "Annulla",
                            label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.undo),
                            onPressed: () => Navigator.pop(context, false),
                          )
                        : Container()),
                SizedBox(width: 10),
                Expanded(
                    child: XBtnbase(
                  label: BTN_Label_YES ?? "OK, avanti..",
                  label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.done),
                  onPressed: onPressed,
                ))
              ]));
        });
  }

  ///Layout della Scheda se è visualizzata come Alert Dialog
  Widget xLayout_asDialog(Widget content) {
    double actionBTN_Heigth = 35;
    return AlertDialog(
        backgroundColor: Colors.grey[900],
        contentPadding: EdgeInsets.symmetric(horizontal: MediaQuery.of(context).size.width * 0.02, vertical: MediaQuery.of(context).size.width * 0.01),
        content: StatefulBuilder(builder: (BuildContext context, StateSetter setState) {
          return SingleChildScrollView(child: Container(decoration: BoxDecoration(border: Border.all(width: 3, color: color_HintText)), width: xLayout_maxRowLen, child: content));
        }),
        actionsAlignment: MediaQuery.of(context).size.width < 900 ? MainAxisAlignment.center : null,
        actions: [
          Container(
              child: Wrap(runAlignment: WrapAlignment.center, alignment: WrapAlignment.center, runSpacing: 20, spacing: 20, children: [
            Container(child: xLayout_HeadAreaBuilder()),
            Container(
                margin: EdgeInsets.only(right: 20),
                child: Row(crossAxisAlignment: CrossAxisAlignment.center, mainAxisSize: MainAxisSize.min, children: [
                  btnUpdateChangesShow
                      ? XBtnbase(
                          height: actionBTN_Heigth,
                          width: MediaQuery.of(context).size.width > 900 ? 180 : 100,
                          elevation: 0,
                          label: widget.xSchDialog_BTNok_label,
                          decoration: xBoxDecorationStyleCircular_ForMenu(Colors.greenAccent[400]),
                          label_Style: XStyles.xStyTextForDescr(textColor: XColors.foregroundDark),
                          onPressed: () {
                            xCMD_Save();
                            Navigator.pop(context, widget.itemInEdit);
                          })
                      : Container(),
                  SizedBox(width: 10),
                  XBtnbase(
                    width: MediaQuery.of(context).size.width > 800 ? 180 : 100,
                    height: actionBTN_Heigth,
                    elevation: 0,
                    label: widget.xSchDialog_BTNcancel_label ?? "Cancel",
                    decoration: xBoxDecorationStyleCircular_ForMenu(Colors.redAccent),
                    onPressed: () => Navigator.pop(this.context, null),
                    label_Style: XStyles.xStyTextForDescr(textColor: XColors.foregroundDark),
                  ),
                ]))
          ]))
        ]);
  }

  ///Layout della Scheda se è visualizzata come un semplice Widget da inserire in UI
  Widget xLayout_asContainer() {
    return SingleChildScrollView(
        child: Container(
            decoration: widget.decoration ?? BoxDecoration(border: (widget.xHeader_AreaBorder ?? false) ? Border.all(width: 3, color: color_HintText) : null),
            width: widget.width ?? (MediaQuery.of(context).size.width > 1600 ? MediaQuery.of(context).size.width / 1.2 : MediaQuery.of(context).size.width / 1.2),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: widget.xHead_Show ? xLayout_Render_HeadView(widget.xView) : [],
            )));
  }

  ///Da Overridare se vuoi modificare il Layout delle celle dei Dettagli nell'area ROW della Scheda
  Widget xLayout_xDett_Item_CellWidget(XCol xCol, XFDataItem item, bool noTextWhenCellValueIsNull, {String formatDate = "dd/MM/yy", int? maxLines}) {
    Widget _xContainerOfWidgets;
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : ""),
          maxLines: maxLines != null
              ? maxLines
              : xCol.multilines
                  ? 3
                  : 1,
          style: XStyles.xStyTextForDescr(textColor: Colors.white),
          overflow: TextOverflow.ellipsis);
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _xContainerOfWidgets = Text(XUtils.dateToString(item[xCol.colKey] ?? DateTime(1900, 01, 01), format: formatDate), maxLines: 1, style: XStyles.xStyTextForDescr(textColor: Colors.white), overflow: TextOverflow.ellipsis);
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      if (xCol.format == "C") {
        _xContainerOfWidgets = Text(XUtils.xFormatToCurrency(context, item[xCol.colKey] ?? 0.0), style: XStyles.xStyTextForDescr(textColor: Colors.yellow), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis);
        // Se è un un semplice double
      } else {
        _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0.0", style: XStyles.xStyTextForDescr(textColor: Colors.yellow), overflow: TextOverflow.ellipsis);
      }
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0", style: XStyles.xStyTextForDescr(textColor: Colors.white), overflow: TextOverflow.ellipsis);

      //Se fosse una lista e voglio prendere la quantità di oggetti dentro
    } else if (xCol.dataType == bool) {
      _xContainerOfWidgets = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: true,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color,
            activeColor: xCol.xmodelXprop.col_Color,
            checkColor: Colors.black,
            value: (item[xCol.colKey] ?? false),
            onChanged: (value) async {
              setState(() {
                editedPage.value = true;
                item[xCol.colKey] = value;
              });
            }),
      );
    } else if (xCol.dataType == String && (xCol.colKey.startsWith("li"))) {
      _xContainerOfWidgets = Container();
    } else {
      _xContainerOfWidgets = Text(xCol.headerToolTip + (item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : "")), style: XStyles.xStyTextForDescr(textColor: Colors.white), overflow: TextOverflow.ellipsis);
    }
    return Container(width: xCol.width * XUtils.kforScale, child: _xContainerOfWidgets);
  }

  ///Da Overridare se vuoi aggiungere Widgets a destra dell'Item dei dettagli nell'area ROW
  Widget xLayout_xDett_Item_RightWidgets(BuildContext context, T item, double height) {
    return Row(children: [Column(children: [])]);
  }

  ///Da Overridare se vuoi aggiungere Widgets a sinistra dell'Item dei dettagli nell'area ROW
  List<Widget> xLayout_xDett_Item_LeftWidgets(dynamic item, void Function(void Function()) parentSetState) {
    return [];
  }

  Widget xLayout_xActionsItem_AddMedia(XFDataItem item) {
    return Container(
        child: PopupMenuButton(
            padding: EdgeInsets.all(0),
            icon: Container(padding: EdgeInsets.all(8), decoration: BoxDecoration(borderRadius: BorderRadius.circular(20), color: Colors.grey[800]), child: Icon(Icons.photo_camera_outlined, color: Colors.orange)),
            itemBuilder: (context) {
              return [
                PopupMenuItem(height: 40, child: XBtnbase(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), height: 40, label: "Aggiungi Immagine", icon_WidthArea: 30, label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.green), icon: Icons.visibility, icon_Size: 23, icon_Color: Colors.green, toolTip_Message: "Aggiungi un'immagine a questa riga", onPressed: () => xCMD_GetMedia(setState, item))),
                PopupMenuItem(height: 40, child: XBtnbase(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), height: 40, label: "Aggiungi Video", icon_WidthArea: 30, label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.green), icon: Icons.visibility, icon_Size: 23, icon_Color: Colors.green, toolTip_Message: "Aggiungi un video a questa riga", onPressed: () => xCMD_GetMedia(setState, item))),
                PopupMenuItem(height: 40, child: XBtnbase(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), height: 40, label: "Aggiungi Audio", icon_WidthArea: 30, label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.green), icon: Icons.visibility, icon_Size: 23, icon_Color: Colors.green, toolTip_Message: "Aggiungi un audio a questa riga", onPressed: () => xCMD_GetAudio(setState, item))),
              ];
            },
            iconSize: 22));
  }

  Widget xLayout_xActionsItem_ViewDett(XFDataItem item, bool dett_Active, void Function(void Function()) parentSetState, XView xView_Scheda, {String? title}) {
    return Container(
        child: PopupMenuButton(
            padding: EdgeInsets.all(0),
            icon: Container(padding: EdgeInsets.all(8), decoration: BoxDecoration(borderRadius: BorderRadius.circular(20), color: Colors.grey[800]), child: Icon(Icons.edit)),
            iconSize: 22,
            itemBuilder: (context) {
              return [
                PopupMenuItem(
                    height: 40,
                    child: XBtnbase(
                        decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                        height: 40,
                        width: 180,
                        label: "Vedi Dettagli",
                        icon_WidthArea: 30,
                        label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.blue),
                        icon: Icons.visibility,
                        icon_Size: 23,
                        icon_Color: Colors.blue,
                        toolTip_Message: "Vedi i dettagli di questa riga",
                        onPressed: () {
                          parentSetState(() {
                            item.isShowDetails = true;
                            item.isSel = item.isSel.not();
                          });
                        })),
                PopupMenuItem(
                    height: 40,
                    child: XBtnbase(
                        decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                        height: 40,
                        width: 180,
                        label: "Modifica",
                        icon_WidthArea: 30,
                        label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.yellow),
                        icon: Icons.edit,
                        icon_Size: 23,
                        icon_Color: Colors.yellow,
                        toolTip_Message: "Modifica questa riga",
                        onPressed: () async {
                          super.setState(() => enteredInEditOnCell = true);
                          await showDialog(
                              context: context,
                              builder: (context) {
                                return XAlertDialog(
                                    colorBackGround: XSchedaState.color_BackGround_EditDialog,
                                    actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
                                    title_Text: title != null ? "Scheda ${title}" : "Scheda",
                                    btnNO_label: "Annulla",
                                    btnYES_label: "Salva",
                                    btnNO_OnPressed: () => Navigator.pop(context),
                                    btnYES_OnPressed: () => Navigator.pop(context, item),
                                    child: XScheda(
                                      item,
                                      xView_Scheda,
                                      xHeader_AreaBorder: false,
                                      modePage_Active: false,
                                    ));
                              });
                          super.setState(() => enteredInEditOnCell = false);
                        }))
              ];
            }));
  }

  xBoxDecorationStyleCircular_ForMenu(Color? color) {
    return BoxDecoration(color: color, borderRadius: BorderRadius.circular(4));
  }

  /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L ///
  /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L ///
  /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L ///
  /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L ///
  /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L ///
  /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L ///

  //Per ricaricare la UI
  ///Da chiamare ogni volta che si vuole salvare il dato Clonato in quello Originale
  Future xCMD_Save() async {
    //se è new gli do ID, prima di save che sovrascrive
    if (itemInEdit_Clone.id == "") itemInEdit_Clone.id = Uuid().v4();
    editedPage.value = false;
    itemInEdit_Clone.copyProps(itemInEdit_Clone, widget.itemInEdit);
    xBottomBarAction_Fill();
    await xOnSaveAfter();
    setState(() {
      xWaiterMessage = "";
      isBusy = false;
    });
  }

  ///Override per aggiungere alle liste delle actions altre actions prima che vengano fillate tutte le varie aree
  Future xActions_LoadLists() async {}

  void rebuildAllChildren(BuildContext context) {
    void rebuild(Element el) {
      el.markNeedsBuild();
      el.visitChildren(rebuild);
    }

    (context as Element).visitChildren(rebuild);
  }

  ///Override per la Gestione del DELETE di un Item dei Dettagli della Scheda
  Future<XFDataItem> xDetts_Action_Delete(XFDataItem item) async {
    return item;
  }

  ///Override per la Gestione del EDIT di un Item dei Dettagli della Scheda
  Future<XFDataItem> xDetts_Action_Edit(XFDataItem item) async {
    return item;
  }

  _xfillxTabs({String? xCol_Key, bool forceAdd = false}) {
    xTabs.value.clear();
    return xfillxTabs(xCol_Key: xCol_Key, forceAdd: forceAdd);
  }

  ///Override per modificare il Fill degli XTabs Principali dellea Scheda
  xfillxTabs({String? xCol_Key, bool forceAdd = false}) {}

  ///Override per modificare il Fill degli XTabs Secoindari all'interno dei Dett della Scheda
  xfillxTabsDetts(XCol xCol, void Function(void Function()) parentSetState) async {
    var t = 0;
    xTabs_Detts.clear();
    for (var i in itemInEdit_Clone.getProp(xCol.colKey)) {
      xTabs_Detts.add(XTabItem(
          t,
          xCol.colCaption + " " + t.toString(), //
          xCol.colCaption + " " + t.toString(),
          itemClass: i,
          content: xTabViewDett_Widget(i, t, parentSetState), //tabViewPages(widget.xView.cols.firstWhere((element) => element.colKey == xCol.colKey))
          labelColor_Active: Colors.white,
          labelColor_Disabled: Colors.white,
          iconColor_Active: Colors.white,
          iconColor_Disabled: Colors.white,
          color_backGroundTab: Colors.green,
          color_backGroundTab_Activate: Colors.grey));
      t++;
    }
    xController_Tab_Dett = TabController(length: xTabs_Detts.length, vsync: this);
  }

  ///Override per il Salvataggio degli XMediaItem
  Future<bool?>? xMedia_OnSave(List<XMediaItem> liXMedia, XFDataItem item) async {
    return true;
  }

  Future<bool?>? xMedia_OnSave_INTERNAL(List<XMediaItem> liXMedia, XFDataItem item) async {
    return await xMedia_OnSave(liXMedia, item);
  }

  ///Apre la Galleria del cellulare per scegliere delle immagini
  Future xOnGetXMedia_FromGallery() async {
    var pickedFiles = await picker.pickMultiImage();
    setState(() {
      if (pickedFiles.isNotEmpty) {
        _images.clear();
        for (var pickedFile in pickedFiles) _images.add(XFile(pickedFile.path));
      }
    });
  }

  ///Comando per aprire il Widget per la Registrazione degli XMedia
  Future<List<XMediaItem>?> xCMD_GetMedia(void Function(void Function()) setState, XFDataItem item, {List<XMediaItem>? liXMedia_UI}) async {
    item.isShowDetails = true;
    FocusScope.of(context).unfocus();
    if (liXMedia_UI != null) liXMedias_MediaRecorder.value.addAll(liXMedia_UI);
    var _photoController = CameraController(widget.xApp!.state.cameras[0], ResolutionPreset.max, enableAudio: true);
    await showDialog(
        context: context,
        barrierDismissible: false,
        builder: (builder) {
          return StatefulBuilder(builder: (context, setStte) {
            return XAlertDialog(
                colorBackGround: Colors.grey[900],
                actionsBTNarea_Padding: EdgeInsets.all(1),
                child: Column(
                  children: [
                    saving
                        ? Container()

                        ///Row delle Preview dei media fatti
                        : Row(mainAxisAlignment: liXMedias_MediaRecorder.value.isNotEmpty ? MainAxisAlignment.start : MainAxisAlignment.center, children: [
                            Expanded(
                                child: SingleChildScrollView(
                                    scrollDirection: Axis.horizontal,
                                    child: Row(
                                        mainAxisAlignment: MainAxisAlignment.center,
                                        crossAxisAlignment: CrossAxisAlignment.center,
                                        children: liXMedias_MediaRecorder.value.isEmpty
                                            ? [Container(height: 80, width: MediaQuery.of(context).size.width, color: Colors.grey[800], alignment: Alignment.center)]
                                            : liXMedias_MediaRecorder.value
                                                .map((e) => InkWell(
                                                    child: e.mediaType == XEnums.mediaType.image.value
                                                        ? Container(
                                                            width: 80,
                                                            height: 80,
                                                            child: Stack(children: [
                                                              Container(margin: EdgeInsets.symmetric(horizontal: 5), width: 80, child: Image.memory(e.payload!, width: 80, height: 80)),
                                                              e.overlaySurface != null ? Container(margin: EdgeInsets.only(bottom: 50), child: Image.memory(e.overlaySurface!, height: 80, width: 80)) : Container(),
                                                            ]))
                                                        : e.mediaType == XEnums.mediaType.video.value
                                                            ? Container(
                                                                margin: EdgeInsets.symmetric(horizontal: 5),
                                                                decoration: BoxDecoration(color: Colors.grey[800], image: DecorationImage(image: MemoryImage(e.miniatura!))),
                                                                width: 80,
                                                                height: 80,
                                                                child: Container(child: Icon(Icons.play_arrow, size: 28, color: Colors.blueAccent[900])),
                                                              )
                                                            : Container(
                                                                margin: EdgeInsets.symmetric(horizontal: 5),
                                                                decoration: BoxDecoration(color: Colors.grey[800]),
                                                                width: 80,
                                                                height: 80,
                                                                child: Icon(Icons.mic),
                                                              )))
                                                .toList())))
                          ]),
                    Container(
                        width: MediaQuery.of(context).size.width,
                        height: MediaQuery.of(context).orientation == Orientation.portrait ? MediaQuery.of(context).size.height / 1.4 : MediaQuery.of(context).size.height / 1.42,
                        child: XMediaRecorder<XFDataItem>(
                          widget.key,
                          parentSetState: setStte,
                          photoController: _photoController,
                          itemOriginal: item,
                          lXMedias: liXMedias_MediaRecorder.value,
                          xApp: widget.xApp!,
                          onStartTakeVideo: (parentState) => setStte(() => isRecording = true),
                          onEndTakeVideo: (parentState) => setStte(() => isRecording = false),
                          onTakeMedia: (parentState) => setStte(() {
                            isTakingPhoto = isTakingPhoto.not();
                          }),
                        )),
                  ],
                ),
                title_Text: "Fotocamera del Lavoro",
                title_Style: XStyles.xStyTextForLabel(textColor: Colors.yellow),
                content_insetPadding: EdgeInsets.all(0),
                actionsBTNarea_Child: Container(
                    height: 70,
                    child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                      isRecording || isTakingPhoto
                          ? Expanded(
                              child: isRecording
                                  ? Text("Sto Registrando...", style: XStyles.xStyTextForSubLabel(textColor: Colors.red), textAlign: TextAlign.center) //
                                  : isTakingPhoto.not()
                                      ? Container()
                                      : XStatefulWidgetBase.LoaderIndicator(isTakingPhoto, label: "Acquisizione Media..", fixHeight: 30, fixWidth: 30))
                          : Container(),
                      isTakingPhoto || isRecording
                          ? Container()
                          : Expanded(
                              child: XBtnbase(
                              height: 45,
                              icon_Widget: Icon(Icons.undo, color: Colors.red, size: 30),
                              backGroundColor: Colors.grey[800]!,
                              elevation: 0,
                              label: "",
                              onPressed: () async {
                                liXMedias_MediaRecorder.value.clear();
                                await _photoController.dispose();
                                Navigator.pop(context, false);
                              },
                            )),
                      SizedBox(width: 6),
                      isTakingPhoto || isRecording
                          ? Container()
                          : Expanded(
                              child: XBtnbase(
                                  label: "Media Esterni",
                                  height: 45,
                                  backGroundColor: Colors.grey[800]!,
                                  elevation: 0,
                                  onPressed: () async {
                                    await _photoController.pausePreview();
                                    await xOnGetXMedia_FromGallery();
                                    if (_images.isNotEmpty) {
                                      _images.forEach((xclFile) async {
                                        print(xclFile.name);
                                        var xMedia = XMediaItem(
                                          Uuid().v4(),
                                          xDocID: item.id,
                                          payload: File(xclFile.path).readAsBytesSync(),
                                          isNew: true,
                                          mediaType: xclFile.name.endsWith("mp4")
                                              ? XEnums.mediaType.video.value
                                              : (xclFile.name.endsWith("jpg") || xclFile.name.endsWith("png"))
                                                  ? XEnums.mediaType.image.value
                                                  : xclFile.name.endsWith("aac")
                                                      ? XEnums.mediaType.audio.value
                                                      : XEnums.mediaType.image.value,
                                        );
                                        setStte(() => liXMedias_MediaRecorder.value.add(xMedia));
                                      });
                                    }
                                    await _photoController.resumePreview();
                                  })),
                      SizedBox(width: 6),
                      liXMedias_MediaRecorder.value.isNotEmpty
                          ? isTakingPhoto || isRecording
                              ? Container()
                              : Expanded(
                                  child: XBtnbase(
                                      height: 45,
                                      backGroundColor: Colors.grey[900]!,
                                      elevation: 0,
                                      icon_Widget: Icon(Icons.save, color: Colors.green, size: 30),
                                      label_Style: XStyles.xStyleText(colorText: Colors.green, fontSize: 24, activeBold: false),
                                      onPressed: () async {
                                        _photoController.pausePreview();
                                        setStte(() => saving = true);
                                        if (liXMedias_MediaRecorder.value.isNotEmpty) {
                                          isTakingPhoto = true;
                                          await Future.forEach(liXMedias_MediaRecorder.value, (xclMedia) => xMedia_OnTake_Handling(xclMedia.payload!, isBusy, setState, item, xclMedia.mediaType!));
                                          await xMedia_OnSave_INTERNAL(liMediaRAW, item)?.then((value) => Navigator.pop(context, true));
                                          item.showXMedia = true;
                                          if (item is T) editedPage.value = true;
                                          xBottomBarAction_Fill();
                                          rebuildAllChildren(context);
                                        }
                                        liXMedias_MediaRecorder.value.clear();
                                        isTakingPhoto = false;
                                        setStte(() => saving = false);
                                        await _photoController.dispose();
                                      }))
                          : Container()
                    ])));
          });
        });
    return liMediaRAW.isNotEmpty ? liMediaRAW : null;
  }

  ///Comando per la Registrazione di un Audio
  Future<File?> xCMD_GetAudio(void Function(void Function()) setState, XFDataItem xfDataItem) async {
    xfDataItem.isShowDetails = true;
    var idString = xfDataItem.id;
    if ((xMedia_CreateAudio ?? false) || _audioRecorder!.isRecording.not()) {
      xFileUI = File.fromUri(Uri.parse("${XLibStorage.filePath}/AUDIO/${itemInEdit_Clone.id},${idString},${Uuid().v4()}_.aac"));
      await xFileUI!.create(recursive: true);
      await _audioRecorder!.openRecorder();
      await _audioRecorder!.startRecorder(toFile: xFileUI!.path);
    } else {
      await _audioRecorder!.stopRecorder();
      _audioRecorder!.closeRecorder();

      var t = await xFileUI!.readAsBytes();
      await xFileUI!.writeAsBytes(t);
      var res = xFileUI!.readAsBytesSync();
      var xclMedia = XMediaItem(Uuid().v4(), xDocID: idString, blobURL: xFileUI!.path, payload: res, mediaType: XEnums.mediaType.audio.value);
      setState(() => liMediaRAW.add(xclMedia));
    }

    return xFileUI;
  }

  ///Override per la Gestione degli XMedia prima che vengano Salvati permanentemente sia su Disco che Blob
  Future<XMediaItem> xMedia_OnBeforeTake(XMediaItem xclMedia, XFDataItem idParent) async {
    return xclMedia;
  }

  ///Override per la Gestione degli XMedia prima che vengano Salvati permanentemente sia su Disco che Blob
  Future xMedia_OnTake_Handling(Uint8List file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem, int mediatype) async {
    setState(() => isBusy = false);
    var bytesForPayLoad = await file;
    //Preparo un XMediaItem con i legami e tipo di XMedia
    var t = XMediaItem(Uuid().v4(), xDocID: xfDataItem.id, mediaType: mediatype, payload: bytesForPayLoad, isNew: true);
    //Esegui se c'è una BL che puo essere aggiunta
    var x = await xMedia_OnBeforeTake(t, xfDataItem);
    var xclMedia = x;
    //Prendo il File
    final xFile = File("${XLibStorage.filePath}/XMEDIAs/${xclMedia.id}_.${extForMediaType(xclMedia.mediaType!)}"); // _ è il marker per DONE !
    t.blobURL = xFile.path;
    //lo creo e poi faccio la miniatura
    await xFile.create(recursive: true).then((value) async => await xFile.writeAsBytes(bytesForPayLoad)).whenComplete(() async {
      if (mediatype == XEnums.mediaType.video.value) {
        xclMedia.miniatura = await xCreateThumbnails_FromVideoURL(xFile.path);
      } else if (mediatype == XEnums.mediaType.image.value) {
        xclMedia.miniatura = await xCreateThumbnails_FromImage(bytesForPayLoad);
      }
    });
    xclMedia.localURI = xFile.path;
    xclMedia.xDocType = xfDataItem.X_docXObjectName;
    //Infine lo aggiungo alla lista di XMedia della Scheda
    setState(() => liMediaRAW.add(xclMedia));
  }

  Uint8List xCreateThumbnails_FromImage(Uint8List image_payload, {int width = 80, int height = 100}) {
    final imgOri = img.decodeJpg(image_payload)!;
    var resizedImg = img.copyResize(imgOri, width: width, height: height);
    final pngBytes = img.encodePng(resizedImg);
    return pngBytes;
  }

  static String extForMediaType(int mediatype) => mediatype == XEnums.mediaType.video.value
      ? "mp4"
      : mediatype == XEnums.mediaType.image.value
          ? "jpg"
          : "aac";

  xMedia_OnSave_EditedPicture(bool isBusy, void Function(void Function()) setState, XMediaItem xfDataItem) async {
    rebuildAllChildren(context);
  }

  Future<Uint8List?> xCreateThumbnails_FromVideoURL(String blobURL) async {
    var x = await thumb.VideoThumbnail.thumbnailData(
      video: blobURL,
      imageFormat: thumb.ImageFormat.PNG,
      maxWidth: 128, // specify the width of the thumbnail, let the height auto-scaled to keep the source aspect ratio
      quality: 25,
    );
    return x;
  }

  xMedia_OnTake_Picture(XFile file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem) async {
    var xFile;
    var idString = xfDataItem.id;
    setState(() {
      isBusy = true;
    });
    xFile = File("${XLibStorage.filePath}/IMMAGINI/${itemInEdit_Clone.id},${idString},${Uuid().v4()}_.jpg");
    await xFile.create(recursive: true);
    await xFile.writeAsBytes(await file.readAsBytes());
    var xclImage = XMediaItem(Uuid().v4(), xDocID: idString, blobURL: xFile.path, payload: await xFile.readAsBytes(), mediaType: XEnums.mediaType.image.value);
    setState(() => liMediaRAW.add(xclImage));
    rebuildAllChildren(context);
  }

  xMedia_OnTake_Video(XFile file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem) async {
    File xFile;
    var idString = xfDataItem.id;
    setState(() {
      isBusy = true;
    });
    xFile = File("${XLibStorage.filePath}/VIDEO/${itemInEdit_Clone.id},${idString},${Uuid().v4()}_.mp4");
    var byteOfVideoFile = await file.readAsBytes();
    xFile.writeAsBytes(byteOfVideoFile);
    await xFile.create(recursive: true);
    var xclVideo = await XMediaItem(Uuid().v4(), xDocID: idString, blobURL: file.path, payload: byteOfVideoFile, mediaType: XEnums.mediaType.video.value);
    xclVideo.miniatura = await xCreateThumbnails_FromVideoURL(xclVideo.blobURL!);
    setState(() => liMediaRAW.add(xclVideo));
    setState(() {
      isBusy = false;
    });
    rebuildAllChildren(context);
  }

  ///Metodo che ciamo ogni volta che voglio cambiare o aggiungere una TAB
  xTabs_ChangeActive(String tabKey, {bool forceAdd = false}) {
    setState(() {
      if (forceAdd) {
        _xfillxTabs(xCol_Key: tabKey, forceAdd: forceAdd);
      } else {
        var tabForKey = xTabs.value.firstWhereOrNull((element) => element.key == tabKey);
        if (tabForKey == null)
          _xfillxTabs(xCol_Key: tabKey);
        else
          xTab_CurrentIndex = tabForKey.idx;
      }
      xTab_Active = xTabs.value.firstWhere((element) => element.key == tabKey);
      rebuildAllChildren(context);
      enteredInEditOnCell = false;
      xTab_CurrentIndex = xTab_Active!.idx;
    });
  }

  Future<bool> xBlob_SetImage(Uint8List payload, String blobFullName) async {
    await azureStorage.putBlob(blobFullName, bodyBytes: payload, contentType: 'image/png').whenComplete(() {});
    return true;
  }

  Future<bool> xBlob_SetAudio(Uint8List payload, String blobFullName) async {
    await azureStorage.putBlob(blobFullName, bodyBytes: payload, contentType: 'audio/aac');
    return true;
  }

  Future<bool> xBlob_SetVideo(Uint8List payload, String blobFullName) async {
    await azureStorage.putBlob(blobFullName, bodyBytes: payload, contentType: 'video/mp4');
    return true;
  }

  //quando salvo ciclo per tutte le prop dell'attore e salvo le informazioni
  ///chiamato quando il valore cambia all'interno dell EDITOR della CELLA
  xOnXCell_Edit_OnChanged(XFDataItem itemInEdit, XCol xCol, dynamic newValue) async {}

  ///called in a setState
  xOnXCell_Edit_AfterSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {}
  xOnXCell_Edit_BeforeSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) async {}

  //Da chiamare per Confermare l'edit di un dato
  /// valueForRealCol = value da mettere nella col reale: es artID noi abbiamo sempre colKey = artiID_resolved, la RealCol
  @nonVirtual
  xOnXCell_Edit_SubmitValue_INTERNAL(XFDataItem itemInEdit, XCol xCol, dynamic newValue, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    var valueIsChanged;
    if (newValue != null && newValue is XEnumDef)
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue.value!);
    else
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue);
    // print("$valueIsChanged = ${itemInEdit[xCol.colKey]} colKey ${xCol.colKey}  newv: $newValue");

    xOnXCell_Edit_BeforeSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_SubmitValue_ToItem(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_AfterSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    calcDoc(xCol, newValue);
    xUpdateCaption();
    setState(() {
      editedPage.value = editedPage.value | valueIsChanged;
      btnUpdateChangesShow = true;
      itemInEdit.isModified = valueIsChanged; //DD BUG FIX
    });
    xBottomBarAction_Fill();
  }

  /// only itemInEdit[xCol.colKey] = value!;
  xOnXCell_Edit_SubmitValue_ToItem(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    if (newValue is XEnumDef) {
      itemInEdit[xCol.colKey] = newValue.value;
    } else {
      if (newValue is String) {
        newValue.trim();
      }
      // ID & _resolved
      if (xCol.colKey.endsWith("_resolved")) {
        if (valueForResolved != null) {
          itemInEdit[xCol.colKey] = valueForResolved!;
        }
        if (valueForRealCol != null) // parte del campo vero, senza _resolved
        {
          itemInEdit[xCol.colKey.replaceAll("_resolved", "")] = valueForRealCol!;
        } else {
          itemInEdit[xCol.colKey] = newValue;
        }
      } else {
        itemInEdit[xCol.colKey] = valueForRealCol ?? newValue;
      }
    }
  }

  xOnXCell_Before_Edit(XCol xCol, dynamic value, {dynamic itemToSet}) async {
    if (xEditDialog_liProps.isEmpty) {
      xEditDialog_EditCell = xCol.colCaption;
    } else {
      for (var i in xEditDialog_liProps) {
        xEditDialog_EditCell = " " + i.col_Label;
      }
    }

    if (isSchWeb.not() && (kIsWeb || isAndroid() || isIOS()) && widget.modePage_Active) {
      var x = await xEditDialog(itemToSet, xEditDialog_EditCell, value, xCol, btns_Active: widget.xEditDialog_BTNs_ForEditValue);
      if (x != null) {
        itemInEdit_Clone[xCol.colKey] = x;
      }
    }
    // setState(() {
    enteredInEditOnCell = false;
    btnUpdateChangesShow = false;
    // });
    return () {};
  }

  //TODO da Verificare
  // void xOnChangeData(XCol xCol, dynamic newValue, void Function(void Function()) parentSetState) {}

  ///Comando per la cancellazione di un Item dai Dettagli
  Future<bool> xCMD_DeleteFromList(XFDataItem itemToRemove, String title, {required List<dynamic> listFromClone_RemoveItem, required List<dynamic> listFromOriginal_RemoveItem, required Function(String) cmd_Delete}) async {
    setState(() {
      enteredInEditOnCell = true;
    });
    bool? x = await showDialog(
        barrierDismissible: false,
        context: context,
        builder: (builder) {
          return XAlertDialog(
            btnNO_label: "NO",
            btnYES_label: "SI",
            btnYES_OnPressed: () => Navigator.pop(context, true),
            btnNO_OnPressed: () => Navigator.pop(context, false),
            title_Text: title,
            title_Style: XStyles.xStyTextForSubLabel(textColor: Colors.yellow),
          );
        });

    if (x != null && x) {
      editedPage.value = true;

      if (listFromClone_RemoveItem.isEmpty) {
        xBottomBarAction_Fill();
      }
      var res = listFromOriginal_RemoveItem.firstWhereOrNull((element) => element.id == itemToRemove.id);

      if (res != null) {
        if (itemToRemove.id == "") {
          return false;
        } else {
          listFromClone_RemoveItem.remove(itemToRemove);
          setState(() {
            enteredInEditOnCell = false;
          });
          await cmd_Delete(itemToRemove.id);
          return true;
        }
      } else {
        setState(() {
          enteredInEditOnCell = false;
        });
        return false;
      }
    } else {
      setState(() {
        enteredInEditOnCell = false;
      });
      return false;
    }
  }

  ///Comando per il Back dalla Scheda
  Future<bool> xCMD_Back() async {
    if (editedPage.value) {
      var res = await showDialog(
          context: context,
          builder: (context) {
            return XAlertDialog(
              title_Text: "Vuoi salvare le tue modifiche?",
              title_Style: XStyles.xStyTextForSubLabel(textColor: Colors.yellow),
              actionsBTNarea_Child: Row(children: [
                Expanded(child: XBtnbase(label: "Annulla", label_Style: XStyles.xStyTextForDescr(textColor: Colors.yellow), onPressed: () => Navigator.pop(context, null))),
                Expanded(child: XBtnbase(label: "No", label_Style: XStyles.xStyTextForDescr(textColor: Colors.red), onPressed: () => Navigator.pop(context, false))),
                Expanded(child: XBtnbase(label: "Si", label_Style: XStyles.xStyTextForDescr(textColor: Colors.green), onPressed: () => Navigator.pop(context, true))),
              ]),
            );
          });
      if (res == null) {
        return false;
      } else if (res) {
        xCMD_Save();
        Navigator.pop(context, widget.itemInEdit);
        return true;
      } else {
        Navigator.pop(context);
        return false;
      }
    } else {
      editedPage.value = false;
      if (widget.itemInEdit.isModified)
        Navigator.pop(context, widget.itemInEdit);
      else
        Navigator.pop(context);
      return true;
    }
  }

  ///Methodo INTERNO per il riempimento degli XTabs Principali ("Dettagli della Scheda")
  xBottomBarAction_Fill_INTERNAL() {
    liBottomActions.clear();
    if (xActions_BOTTOMBAR!.isNotEmpty) {
      xActions_BOTTOMBAR!.forEach((element) {
        liBottomActions.add(XBottomNavigationBarItem(
          element.key ?? "",
          label: element.label,
          icon: element.icon_Image != null ? Container(width: element.width ?? 40, child: Image.memory(element.icon_Image!)) : Container(width: element.width ?? 40, child: Icon(element.icon, color: element.icon_Color, size: element.icon_Size ?? 30)),
          tooltip: element.toolTip,
          label_Color: element.label_Color,
          label_Style: element.label_Style,
          cmd: () => element.cmd!(itemInEdit_Clone, setState, context),
        ));
      });
    }

    if ((editedPage.value)) {
      liBottomActions.add(XBottomNavigationBarItem("saveExit", label: "Salva e\nChiudi", icon: Container(width: 40, child: Icon(Icons.undo, color: Colors.green, size: 30)), tooltip: "Salva le modifiche e chiude la scheda"));
    }
    //XFX xché è l'ADD egenrico della XSCH 1a a DX
    if (xInitList_AddDetts().isNotEmpty && widget.xBottomBar_AddBTN_Detts_Active && widget.allowAddDetts) {
      liBottomActions.add(XBottomNavigationBarItem("addDett", label: "Aggiungi\nDettaglio", icon: Container(width: 40, child: Icon(Icons.add, color: Colors.green, size: 30)), tooltip: "Aggiungi un dettaglio..."));
    }
  }

  ///toBE OVERRIDE chiamata 2 volte, in init e in LAYOUT. la prima serve per far sapere al LAY che deve avere la BottomNavBar senza dover mettere un bool apposta
  xBottomBarAction_Fill() {
    xBottomBarAction_Fill_INTERNAL();
  }

  Future xBottomBarAction_OnTap_INTERNAL(int currentIdx, void Function(void Function()) parentSetState) async {
    var act = liBottomActions[currentIdx];
    if (act.wKey == "saveExit") {
      setState(() {
        xWaiterMessage = "Sto salvando i tuoi dati..";
        isBusy = true;
      });
      await xCMD_Save();
      setState(() {
        xWaiterMessage = "";
        isBusy = false;
      });
      Navigator.pop(context, widget.itemInEdit);
    } else if (act.wKey == "save") {
      setState(() {
        xWaiterMessage = "Sto salvando i tuoi dati..";
        isBusy = true;
      });
      await xCMD_Save();
      setState(() {
        xWaiterMessage = "";
        isBusy = false;
      });
    }
    if (act.wKey == "addDett") await xCMD_xOnAddDett();
    var x = xActions_BOTTOMBAR!.firstWhereOrNull((element) => element.key == act.wKey);
    if (x != null && act.cmd != null) act.cmd!();
    xBottomBarAction_OnTap(act, parentSetState);
  }

  Future xBottomBarAction_OnTap(XBottomNavigationBarItem act, void Function(void Function()) parentSetState) async {}

  @nonVirtual
  Future<XFDataItem?> xOnAddNewDett_INTERNAL(XFDataItem item) async {
    if (item.id == "") item.id = Uuid().v4();
    item.isNew = true; //DD BUG FIX
    return xOnAddNewDett(item);
  }

  Future<XFDataItem?> xOnAddNewDett(XFDataItem item) async {
    return item;
  }

  List<XItem_BTNadd> xInitList_AddDetts() {
    return [];
  }

  Future<XFDataItem?> xOnBefore_AddDett() async {
    return null;
  }

  Future<XFDataItem?> xOnAfter_AddDett(XFDataItem xclObj) async {
    return null;
  }

  ///EditDialog per l'Aggiunta di un nuovo Items che fa un aggiunta a sequenza per ogni colonna della Vista
  Future<XFDataItem?> xEditDialog_xOnAddItem(XView xView, XFDataItem item, void Function(void Function()) setState, {List<ScontiBTN>? liSconti}) async {
    bool isFirst = false;
    int u = 0;
    XFDataItem? rval = null;
    if (xView.cols!.where((e) => e.dataType != bool || e.readOnly != true || e.colKey.startsWith("li").not()).length == 1) {
      isFirst = false;
    } else {
      for (var i in xView.cols!) {
        if (i.dataType == bool || i.readOnly == true || i.colKey.startsWith("li")) continue;
        u++;
        var x = await xEditDialog(item, i.colCaption, item[i.colKey], i, liSconti: liSconti);
        if (x == null) {
          if (u == 1) isFirst = true;
          break;
        } else
          item[i.colKey] = x;
      }
    }

    if (!isFirst) {
      rval = await xPreview_Dialog(xView, item);
      if (rval == null) return null;
    }

    return rval;
  }

  Future xCMD_xOnAddDett() async {
    var x = await xInitList_AddDetts();
    var t;
    if (x.length == 1) {
      var p = xTabs.value.firstWhereOrNull((element) => element.key == x.first.key);
      if (p == null)
        xTabs_ChangeActive(x.first.key, forceAdd: true);
      else
        xTabs_ChangeActive(x.first.key);
      t = x.first.key;
    } else {
      var p = xTab_Active != null ? xTabs.value.firstWhereOrNull((element) => element.key == xTab_Active!.key) : null;
      if (p != null) {
        t = p.key;
        xTabs_ChangeActive(t);
      } else {
        t = await showDialog(
            context: context,
            builder: (context) {
              return XAlertDialog(
                  height: null,
                  title_Text: "Scegli quale dettaglio aggiungere:",
                  actionsBTNarea_Child: Row(children: [
                    Expanded(
                        child: XBtnbase(
                      label: "Chiudi",
                      backGroundColor: Colors.grey[800],
                      label_Style: XStyles.xStyTextForLabel(textColor: XColors.undo),
                      onPressed: () => Navigator.pop(context, null),
                    ))
                  ]),
                  title_Style: XStyles.xStyTextForTextBase(),
                  child: Column(
                      mainAxisSize: MainAxisSize.min,
                      children: x
                          .map((e) => Row(children: [
                                Expanded(
                                    child: XBtnbase(
                                  margin: EdgeInsets.symmetric(vertical: 5),
                                  label: e.label,
                                  backGroundColor: Colors.grey[800],
                                  height: 35,
                                  onPressed: () {
                                    var x = xTabs.value.firstWhereOrNull((element) => element.key == e.key);
                                    if (x == null)
                                      xTabs_ChangeActive(e.key, forceAdd: true);
                                    else
                                      xTabs_ChangeActive(e.key);
                                    Navigator.pop(context, e.key);
                                  },
                                  label_Style: XStyles.xStyTextForSubLabel(textColor: e.backgroundColor),
                                ))
                              ]))
                          .toList()));
            });
      }
    }

    if (t != null && t != "" && t == xTab_Active!.key) {
      var y = xTab_Active!.itemClass!.getCloneFull();
      var xclObject = await xOnAddNewDett_INTERNAL(y);
      XFDataItem? res = null;
      if (xTab_Active != null && xTab_Active!.xElencoToView != null && xTab_Active!.xElencoToView!.xCells_EditType != null) {
        if (xTab_Active!.xElencoToView!.xCells_EditType!.value == XEnums.editType.scheda.value) {
          res = await xOnBefore_AddDett().then((value) async => value != null ? xOnAfterActionOnDett_INTERNAL(value) : null);
        } else if (xTab_Active!.xElencoToView!.xCells_EditType!.value == XEnums.editType.form.value) {
          res = await xPreview_Dialog(xTab_Active!.xElencoToView!.liCols_EditData.isEmpty ? xTab_Active!.xElencoToView!.view ?? xTab_Active!.xElencoToView!.viewDetts! : XView("AddView", cols: xTab_Active!.xElencoToView!.liCols_EditData), xclObject);
          if (res != null) {
            await xOnAfter_AddDett(res);
            await xOnAfterActionOnDett_INTERNAL(res);
          }
        } else {
          res = await xEditDialog_xOnAddItem(xTab_Active!.xElencoToView!.liCols_EditData.isEmpty ? xTab_Active!.xElencoToView!.view ?? xTab_Active!.xElencoToView!.viewDetts! : XView("AddView", cols: xTab_Active!.xElencoToView!.liCols_EditData), xclObject!, setState);
          if (res != null) {
            await xOnAfter_AddDett(res);
            await xOnAfterActionOnDett_INTERNAL(res);
          }
        }
      } else {
        if (widget.xIsActive_AddItem_DefaultBL.not()) {
          if (widget.xOnBeforeAddDettLayout != null) {
            res = xclObject != null
                ? widget.xOnBeforeAddDettLayout == null
                    ? null
                    : await widget.xOnBeforeAddDettLayout!(xTab_Active!.xElencoToView!.view!, xclObject, setState)
                : null;
          } else {
            res = xclObject != null ? await xLayout_DialogAddItem(xTab_Active!.xElencoToView!.view!, xclObject, setState) : null;
          }
        }
      }

      var resBeforeAddItemInList;
      if (res != null) {
        resBeforeAddItemInList = await xOnBeforeAddDettToList(res);
        editedPage.value = true; //x ADD
      }
      var liToAddItem = itemInEdit_Clone.getProp(t);
      var x = xTabs.value.firstWhereOrNull((element) => element.key == xTab_Active!.key);
      if (res != null) {
        liToAddItem.add(resBeforeAddItemInList);

        if (x != null) {
          xTab_CurrentIndex = x.idx;
        } else {
          xTab_CurrentIndex = xTab_Active!.idx;
        }
      } else {
        if (liToAddItem.isNotEmpty) {
        } else {}
      }
      calcDoc(null, liToAddItem);
    }
  }

  XFDataItem? xOnBeforeAddDettToList(XFDataItem xclObject) {
    return xclObject;
  }

  /// DO NOTHING =>     widget.title = itemInEdit_Clone .isNew ? "Nuovo Cliente" : itemInEdit_Clone.nickName;;
  xUpdateCaption() {
    if (widget.title == null || widget.title == "") widget.title = (itemInEdit_Clone.isNew ? "Nuovo " : "") + itemInEdit_Clone.X_docCaption!;
  }

  /// NOT TO OVERRIDE !
  XFDataItem? xOnAfterActionOnDett_INTERNAL(XFDataItem xclObject) {
    superSetState(() => editedPage.value = true);
    calcDoc(null, xclObject);
    xBottomBarAction_Fill();
    _xfillxTabs();
    return xOnAfterActionOnDett(xclObject);
  }

  XFDataItem? xOnAfterActionOnDett(XFDataItem xclObject) {
    return xclObject;
  }

  Future<XFDataItem?> xOnActionOnDett(XFDataItem xclObject) async {
    await xOnAfterActionOnDett_INTERNAL(xclObject);
    return xclObject;
  }

  Future<PermissionStatus> _getContactPermission() async {
    PermissionStatus permission = await Permission.contacts.status;
    if (permission != PermissionStatus.granted && permission != PermissionStatus.permanentlyDenied) {
      PermissionStatus permissionStatus = await Permission.contacts.request();
      return permissionStatus;
    } else {
      return permission;
    }
  }

  Future<Contact?> xCMD_AddFromRubrica(List<Contact> listContact) async {
    await _getContactPermission();
    if (listContact.isEmpty) {
      var res = await ContactsService.getContacts();
      listContact.addAll(res);
    }
    Contact? xclContatto;
    var x = await showDialog<Contact>(
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return XAlertDialog(
                title_Text: "Scegli il contatto dalla tua RUBRICA:",
                height: null,
                content_VerticalPadding: 30,
                child: XDropSearch<Contact>(
                  dropDownMode: "Dialog",
                  al_Title: "",
                  al_BackGroundColor: Colors.grey[900],
                  itemSelected: xclContatto,
                  liItems: listContact.where((element) => element.phones!.isNotEmpty).toList(),
                  label: "",
                  itemAsString: (p0) => (p0.givenName ?? "") + " " + (p0.familyName ?? ""),
                  onChanged_ItemOfDD: (contact) {
                    setState(() => xclContatto = contact);
                  },
                ),
                actionsBTNarea_Child: Row(children: [
                  Expanded(
                      child: XBtnbase(
                    label: "Annulla",
                    onPressed: () => Navigator.pop(context, null),
                    label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.undo),
                  )),
                  xclContatto != null
                      ? Expanded(
                          child: XBtnbase(
                          label: "Avanti",
                          onPressed: () => Navigator.pop(context, xclContatto),
                          label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.done),
                        ))
                      : Container()
                ]));
          });
        });
    if (x != null && xclContatto != null)
      return xclContatto;
    else
      return null;
  }

  /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D ///
  /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D ///
  /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D ///
  /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D ///
  /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D ///
  /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D /// /// B U I L D ///

  @override
  Widget build(BuildContext context) {
    var content = Column(
      mainAxisSize: MainAxisSize.min,
      children: widget.xHead_Show ? xLayout_Render_HeadView(widget.xView) : [],
    );
    return (widget.modePage_Active.not()
        ? Container(
            margin: EdgeInsets.all(8),
            child: widget.modeDialog_Active.not()
                ////Se la scheda non si trova in un dialog
                ? xLayout_asContainer()
                : xLayout_asDialog(content))
        ////Se la scheda si trova in un dialog
        : xLayout_asPage(context));
  }

  ///Widget per la costruzione di ItemComplessi utilizzati nei Dettagli della Scheda
  buildXItem<T extends XFDataItem, K>(
    T item,
    List<dynamic> liChildrens,
    Function(T) BTNadd_cmdAdd,
    void Function(void Function()) parentSetState, {
    Widget Function(dynamic)? dettItem,
    String? BTNadd_label,
    Widget? mainWidget,
    Color? backGround_Color,
    Widget Function(dynamic)? dettWidget,
    EdgeInsetsGeometry? margin,
    List<XPopUpMenuItem>? liPopUpMenu_Items,
    bool border_Visible = false,
    bool title_InMainWidget_Visible = false,
    XView? xView_Scheda,
    XView? xView_Elenco,
    XView? xViewDett,
    List<Widget>? titleLiWidgets,
    bool viewDett_Data = false,
  }) {
    return StatefulBuilder(builder: (context, setState) {
      return XElencoItem(setState, item, context, xView_Scheda!,
          xViewDetts: xViewDett,
          margin: margin ?? EdgeInsets.only(left: 10, right: 10, bottom: 10),
          changeStatoWithTap: true,
          onTapItem: () => parentSetState(() => item.isShowDetails = item.isShowDetails.not()),
          showTrailingArrow: false,
          decorationBackGroundContainer: border_Visible
              ? BoxDecoration(color: backGround_Color ?? Colors.grey[900], border: Border(left: BorderSide(), right: BorderSide(), top: BorderSide(), bottom: BorderSide())) //
              : BoxDecoration(color: backGround_Color ?? Colors.grey[900]),
          showingDetails: item.isShowDetails,
          showMainWithDetails: true,
          childMain: Column(mainAxisSize: MainAxisSize.min, children: [
            Row(mainAxisAlignment: MainAxisAlignment.end, children: [
              mainWidget != null ? Container() : Icon((item.isShowDetails) ? Icons.keyboard_arrow_up_outlined : Icons.keyboard_arrow_down_outlined, color: XColors.foregroundLight),
              mainWidget != null
                  ? Container()
                  : xView_Elenco != null && widget.xHead_Show
                      ? Expanded(child: Row(children: [Expanded(child: Wrap(children: xLayout_Render_HeadView(xView_Elenco, border_Visible: false)))])) //
                      : Container(),
              mainWidget != null ? Expanded(flex: 2, child: mainWidget) : Container(),
              Container(margin: EdgeInsets.only(top: 5, right: 5, bottom: 5), child: xLayout_xActionsItem_ViewDett(item, viewDett_Data, setState, xView_Scheda)),
              xMedia_isActive ? Container(margin: EdgeInsets.only(top: 5, right: 5, bottom: 5), child: xLayout_xActionsItem_AddMedia(item)) : Container(),
              Container(
                  margin: EdgeInsets.only(top: 5, right: 5, bottom: 5),
                  child: XBtnbase(
                      width: 40,
                      height: 40,
                      icon_WidthArea: 25,
                      icon: Icons.add,
                      icon_Size: 22,
                      elevation: 0,
                      decoration: BoxDecoration(color: Colors.grey[800], borderRadius: BorderRadius.all(Radius.circular(25))),
                      label_Color: XColors.foregroundLight,
                      icon_Color: XColors.done,
                      onPressed: () {
                        FocusScope.of(context).unfocus();
                        BTNadd_cmdAdd(item);
                        setState(() => item.isShowDetails = true);
                      })),
              liPopUpMenu_Items != null
                  ? Container(
                      height: 30,
                      child: PopupMenuButton(
                          padding: EdgeInsets.all(1),
                          icon: Icon(Icons.more_vert_outlined),
                          iconSize: 22,
                          itemBuilder: (context) {
                            return liPopUpMenu_Items
                                .map((e) => PopupMenuItem(
                                    height: 40,
                                    child: XBtnbase(
                                      decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                                      height: 40,
                                      width: (e.iconImage != null || e.icon != null) ? 250 : 150,
                                      label: e.title,
                                      icon_WidthArea: 50,
                                      label_Style: XStyles.xStyTextForSubLabel(textColor: e.color),
                                      icon_Widget: e.icon != null ? null : Container(width: 50, child: e.iconImage),
                                      icon: e.iconImage != null ? null : e.icon,
                                      icon_Size: 23,
                                      icon_Color: e.iconImage != null ? null : e.color,
                                      toolTip_Message: e.toolTip_Message,
                                      onPressed: () => e.onPressed!(context, item),
                                    )))
                                .toList();
                          }))
                  : Container(),
            ])
          ]),
          childDetails: Column(children: [
            item.isSel ? xLayout_xDett_Item_HeadWidget(item, parentSetState, xclViewUI: xView_Scheda) : Container(),
            dettWidget != null ? dettWidget(item) : Column(children: liChildrens.map((xclVoce) => dettItem!(xclVoce)).toList()),
            Container(
                child: Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
              //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI
              xMedia_isActive
                  ? (liMediaRAW.isNotEmpty && liMediaRAW.any((element) => element.xDocID == item.id))
                      ? Container(
                          margin: EdgeInsets.all(8),
                          decoration: BoxDecoration(border: Border.all(color: Colors.grey[700]!)),
                          child: Column(children: [
                            Row(children: [Expanded(child: Container(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), child: Text("Media", textAlign: TextAlign.center, style: XStyles.xStyTextForSubLabel(textColor: XColors.foregroundLight))))]),
                            Column(
                              children: liMediaRAW.groupListsBy((element) => element.mediaType).entries.map((e) {
                                if (e.key == XEnums.mediaType.audio.value) {
                                  return xLayout_Builder_AudioArea(liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.audio.value).toList(), item);
                                } else if (e.key == XEnums.mediaType.image.value) {
                                  return xLayout_Builder_ImmaginiArea(liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.image.value).toList(), parentID: item.id);
                                } else {
                                  return xLayout_Builder_VideoArea(liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.video.value).toList(), item);
                                }
                              }).toList(),
                            )
                          ]))
                      : Container()
                  : Container()
              //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI
            ]))
          ]));
    });
  }
}

class ScontiBTN {
  String scontoValue;
  int positionY;
  int? positionX;
  ScontiBTN({required this.scontoValue, required this.positionY, this.positionX});
}

class XItem_BTNadd {
  String key;
  String label;
  Color backgroundColor;
  XItem_BTNadd({required this.key, required this.label, required this.backgroundColor});
}
