import 'dart:async';
import 'dart:io';
import 'package:audio_waveforms/audio_waveforms.dart';
import 'package:camera/camera.dart';
import 'package:collection/collection.dart';
import 'package:contacts_service/contacts_service.dart';
import 'package:date_field/date_field.dart';
import 'package:flutter/foundation.dart' as found;
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_slidable/flutter_slidable.dart';
import 'package:image_picker/image_picker.dart';
import 'package:intl/intl.dart';
import 'package:observable/observable.dart';
import 'package:permission_handler/permission_handler.dart';
import 'package:syncfusion_flutter_datagrid/datagrid.dart';
import 'package:syncfusion_flutter_gauges/gauges.dart';
import 'package:uuid/uuid.dart';
import 'package:video_player/video_player.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xfxbase/XfxToolTips.dart';
import 'package:xfxbase/_XFX/XF_Col.dart';
import 'package:xfxbase/_XFX/XF_View.dart';
import 'package:xfxbase/_XFX/XFx.dart';
import 'package:xfxwidgets/XActionsBase.dart';
import 'package:xfxwidgets/XF_GRID/XElGrid.dart';
import 'package:xfxwidgets/XF_MAIN/XApp.dart';
import 'package:xfxwidgets/XF_MAIN/XAppState.dart';
import 'package:xfxwidgets/xMediaItem.dart';
import 'package:xtoolspackage/XLibStorage.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:video_thumbnail/video_thumbnail.dart' as thumb;
import 'package:image/image.dart' as img;
import '../ImagePainter/ImagePainter.dart';
import '../XF_SCHEDA/Xfx_Scheda.dart';
import '../XMediaRecorder.dart';
import '../XTabItem.dart';
import '../XfxDropDown.dart';
import '../XfxUtils.dart';
import '../xfxwidgets.dart';
import 'XFilterEl.dart';
import 'XPopUpMenuItem.dart';

class XElenco<T extends StatefulWidget, K extends XFDataItem> extends StatefulWidget {
  XElenco(
    this.title_Text,
    this.view, {
    Key? key,
    this.xApp,
    this.viewDetts,
    this.isEditable = false,
    this.xLayout_HeightElArea_Factor,
    this.title_Color,
    this.title_Style,
    this.title_OnTop_Visible = false,
    this.title_OnTop_BackgroundColor,
    this.title_OnTop_AddBTN_Height,
    this.title_OnTop_AddBTN_Label,
    this.title_OnTop_AddBTN_Color,
    this.title_OnTop_AddBTN_OnPressed,
    this.title_OnTop_AddBTN_Width,
    this.title_OnTop_AddBTN_Visible = false,
    this.title_OnTop_AddBTN_Margin,
    this.margin_Horizontal,
    this.onRefresh_ScrollDownList,
    this.item_Widget,
    this.floatingActionButton,
    this.headers_Visible = false,
    this.filters_Visible = false,
    this.searchBar_Active = true,
    this.allowAdd = false,
    this.cmd_Add,
    this.pageMode_Active = true,
    this.onTapItem,
    this.onDoubleTapItem,
    this.onLongTapItem,
    this.onTapBack,
    this.xOnReturnBack,
    this.schNameToOpen,
    this.formatDate,
    this.liDetts,
    this.xDrawerMenu,
    this.appBar_Color,
    this.searchBar_Color,
    this.searchBar_ColorBorder,
    this.searchBar_ColorHint,
    this.searchBar_ColorIconClear,
    this.searchBar_ColorIconSearch,
    this.searchBar_ColorText,
    this.searchBar_hintText,
    this.searchBar_whereMethod,
    this.liPopUpMenu_Items,
    this.itemSelected_BackGroundColor,
    this.elDettsMode_SchItem,
    this.xDettItem_Widget,
    this.edited,
    this.noTextWhenCellValueIsNull = false,
    this.liWidgets_LeftArea_Item,
    this.schedaMode = false,
    this.itemEdited,
    this.rootItemEdited,
    this.xBL_BTN_EmptyList,
    this.showHead_DettsRowInItem = true,
    this.xDetts_xColname,
    this.appBar_Height,
    this.xDettItem_BackGroundColor,
    this.widgetBuild_Override,
    this.appBar_Visible = true,
    this.liWidgets_RightArea_Item,
    this.showHead = true,
    this.xDett_minHeight_showHead = true,
    this.xDett_AddBTN_Active = true,
    this.liXMediaToUse,
    this.xTab_List,
    this.isScrollableTabs,
    this.appBar_LeadingWidget,
    this.appBar_LeadingWidth,
    this.borderAree_Header,
    this.appBar_Custom_Visible = false,
    this.xCells_Item_Widget = null,
    this.xCells_Item_Width = null,
    this.xCells_Item_TextStyle = null,
    this.xObjParent = null,
    this.isCompexUI_WrapItems = false,
    this.xWidget_Left,
    this.xWidget_Right,
    this.xLayout_Stack_Alignment,
  }) : super(key: key);

  ///View Principale dell'Elenco
  XView? view;

  ///View dei dettagli degli Items dell'Elenco
  XView? viewDetts;

  ///Da riempire con xApp a livello di App
  XApp? xApp;

  ///Oggetto parente se lo ha, disolito riempito se l'elenco è usato da una Scheda
  XFDataItem? xObjParent;

  //Bool per determinare se un elenco è editabile in line o no
  bool isEditable;

  ///Margine orizzontale dell'intero Elenco
  double? margin_Horizontal;

  ///Metodo da riempire con la BL quando refreshi l'Elenco
  Future<void> Function(BuildContext)? onRefresh_ScrollDownList;

  ///Viene modificato un XFDataItem a qualsiasi livello
  Function(XFDataItem)? itemEdited;

  ///Viene modificato un XFdataItem root = K
  Function(K)? rootItemEdited;

  ///Metodo chiamato dal Bottone visibile solo se la lista è vuota
  Widget? Function()? xBL_BTN_EmptyList;

  ///Abilitare o diabilitare per mostrare l'HeaderView
  bool headers_Visible;

  ///Abilitare o diabilitare per mostrare i Filtri dell'Elenco
  bool? filters_Visible;

  ///Abilitare o diabilitare per mostrare la Scheda dell'Item nell'Item
  bool showHead_DettsRowInItem;

  ///Background Color dell'intero elenco tranne dell'AppBar
  Color? backgroundColor;

  ///Lista di Tabs da riempire per avere un elenco Multi-Tabs
  late List<XTabItem>? xTab_List;

  ///Da riempire con la Key della Colonna da visualizzare come Dettagli degli Items
  String? xDetts_xColname;

  ///Widget dell'ItemDett visualizzato nei dettagli dell'Item dell'Elenco
  Widget? Function(dynamic)? xDettItem_Widget;

  ///Formato della data che verrà utilizzato in tutto l'Elenco
  String? formatDate;

  ///Flex value per dare le dimensioni verticali all'Elenco rispetto ai Widget sopra l'Elenco come l'AddBTN e la SearchBar
  ///Flex default => 18
  int? xLayout_HeightElArea_Factor;

  ///Allineamento dell'Area dell'elenco degli items all'interno dello stack per tenere il dragEndDrop
  Alignment? xLayout_Stack_Alignment;

  ///Testo del Titolo
  String title_Text;

  ///Colore del Titolo
  Color? title_Color;

  ///Abilitare o diabilitare per mostrare o no il "Titolo Alto"
  bool title_OnTop_Visible;

  ///Abilitare o diabilitare per mostrare il Bottone a destra del "Titolo Alto"
  bool? title_OnTop_AddBTN_Visible;

  ///Altezza del "Titolo Alto"
  double? title_OnTop_Height;

  ///Label del bottone a destra del "Titolo Alto"
  String? title_OnTop_AddBTN_Label;

  ///Colore del Background del Container che contiene il "Titolo Alto"
  Color? title_OnTop_BackgroundColor;

  ///Colore del Back del Bottone a destra del "Titolo Alto"
  Color? title_OnTop_AddBTN_Color;

  ///Evento del Bottone a destra del "Titolo Alto"
  Function()? title_OnTop_AddBTN_OnPressed;

  ///Altezza del Bottone a destra del "Titolo Alto"
  double? title_OnTop_AddBTN_Height;

  ///Width del Bottone a destra del "Titolo Alto"
  double? title_OnTop_AddBTN_Width;

  ///Margine del Bottone a destra del "Titolo Alto"
  EdgeInsets? title_OnTop_AddBTN_Margin;

  ///Style del Titolo dell'Elenco
  TextStyle? title_Style;

  ///Widget dell'Item visualizzato nell'Elenco
  Widget? Function(K)? item_Widget;

  ///Colore dell'AppBar
  Color? appBar_Color;

  ///Width dell'Area del Leading ovvero l'Area a SINISTRA nell'AppBar
  double? appBar_LeadingWidth;

  ///Widget per il LeadingWidget dell'AppBar (PARTE SINISTRA)
  Widget? appBar_LeadingWidget;

  ///Bottone in basso a destra nell'Elenco
  Widget? floatingActionButton;

  ///DrawerMenu Widget da visualizzare come drawer dell'Elenco
  Widget? xDrawerMenu;

  ///Evento chiamato quando premi Back nell'Elenco
  Function(void Function(void Function()))? xOnReturnBack;

  ///Abilitare o disabilitare per visualizzare la SearchBar
  bool searchBar_Active;
  Color? searchBar_ColorHint;
  Color? searchBar_ColorText;
  Color? searchBar_ColorIconClear;
  Color? searchBar_ColorIconSearch;
  Color? searchBar_Color;
  Color? searchBar_ColorBorder;
  String? searchBar_hintText;

  ///Lista di Widgets da inserire nell'Area a DESTRA di ogni singolo Item
  List<Widget>? Function(K)? liWidgets_RightArea_Item;

  ///Lista di Widgets da inserire nell'Area a SINISTRA di ogni singolo Item
  List<Widget>? Function(K)? liWidgets_LeftArea_Item;

  ///Metodo che ritorna un bool per la ricerca nella searchBar
  bool Function(K, String)? searchBar_whereMethod;

  ///Valore che mi dice se l'Elenco è stato modificato o no
  ValueNotifier<bool>? edited;

  ///Da mettere true per abilitare l'Aggiunta di Item nell'Elenco
  bool allowAdd;

  ///Da mettere true settare l'Elenco con le impostazioni per inserirlo in una Scheda
  bool? schedaMode;

  ///Altezza dell'AppBar
  double? appBar_Height;

  ///Comando da riempire con la BL per l'Add di un Item
  Future Function(void Function(void Function()))? cmd_Add;

  ///Evento per il Doppio Tab su un Item
  Function()? onDoubleTapItem;

  ///Evento per il Tab su un Item
  Function(K)? onTapItem;

  ///Evento per il LongTab su un Item
  Function(dynamic)? onLongTapItem;

  ///Evento per il Tap sul Back dell'Elenco
  Function()? onTapBack;

  ///Nome della Scheda da Apire che verrà utilizzato da un Navigator con il PushNamed, quindi deve essere definita una route con quella Scheda nel MAIN
  String? schNameToOpen;

  ///Background Color di un Item Selezionato
  Color? itemSelected_BackGroundColor;

  ///Background Color di un dettaglio Selezionato di un Item
  Color? xDettItem_BackGroundColor;

  ///Lista di colonne per l'aggiunta di un nuovo item
  List<XCol> liCols_EditData = List<XCol>.empty(growable: true);

  //Setta il tipo di Editabilità dell'item dell'elenco e dell'aggiunta di un nuovo Item
  late XEnumDef? xCells_EditType;

  ///Widget per Cella degli Items
  Widget Function(XCol xCol, XFDataItem item)? xCells_Item_Widget;
  double? Function(XCol xCol, XFDataItem item, double? widthByXfx)? xCells_Item_Width;
  TextStyle Function(XCol xcol, XFDataItem? xfd, Color color)? xCells_Item_TextStyle;

  bool noTextWhenCellValueIsNull;
  bool pageMode_Active;
  bool? elDettsMode_SchItem;
  bool appBar_Visible;
  Widget? widgetBuild_Override;

  bool? borderAree_Header;
  bool showHead;
  bool xDett_minHeight_showHead;
  bool xDett_AddBTN_Active;
  bool? isScrollableTabs;
  List<XPopUpMenuItem>? liPopUpMenu_Items = List<XPopUpMenuItem>.empty(growable: true);
  // List<XAction>? liXActions = List<XAction>.empty(growable: true);
  List<dynamic>? liDetts;
  bool isCompexUI_WrapItems;

  ///elenco XMedia in carico alla scheda che questo elenco deve usare
  final List<XMediaItem>? liXMediaToUse;
  bool appBar_Custom_Visible;
  Widget? xWidget_Right;
  Widget? xWidget_Left;
  //bool Function(K, String?)? whereMethod;
  @override
  XElencoState<T, K> createState() => XElencoState<T, K>();
}

class XElencoState<T extends StatefulWidget, K extends XFDataItem> extends State<XElenco<T, K>> with TickerProviderStateMixin {
  ScrollController? scroll_controller = ScrollController();
  TextEditingController searchController = TextEditingController();
  late PlayerController playerController;
  late TabController tabController;
  late VideoPlayerController? videoPlayerController;
  late StreamSubscription<PlayerState> playerStateSubscription;
  final MenuController _menuController = MenuController();
  final _imagePainterState_Key = GlobalKey<ImagePainterState>();

  ///Da riempire con la chiamata alle API se vuoi riempire la lista direttamente da chiamata
  Future<List<K>> Function()? xLoadData_apiCall = null;

  ///Lista interna all'Elenco utilizzata dalla UI per visualizzare la LIsta
  List<K> list = List<K>.empty(growable: true);

  ///Da riempire con la Lista che vorrai visualizzare nell'Elenco
  List<K> Function()? xLoadData_get = null;

  ///Hook osservabile dell'Elenco da legare alla Lista RAW a livello di AppState per avere la Lista che si aggiorna sempre quandop vengono modfificati i suoi Items
  ObservableList<K>? xListObservable_Hook;

  ///Variabile interna dell'Elenco degli XMedia presenti in tutto l'elenco
  List<XMediaItem> liMediaRAW = List<XMediaItem>.empty(growable: true);

  ///Variabile interna dell'Elenco per appoggiare gli items che vengono eliminati prima di salvare l'eliminazione
  List<K> liDelItems = List<K>.empty(growable: true);

  ///Elenco di XPopUpMenuItem che verranno inseriti in un menu a PopUp da un BTN Functions sugli Items che mostrerà queste azioni
  List<XPopUpMenuItem> liPopUpMenu_ActionOnItem = List<XPopUpMenuItem>.empty(growable: true);

  ///Da modificare per abilitare o disabilitare il Waiter che gira dell'Elenco
  ValueNotifier<bool> isBusy = ValueNotifier(true);

  ///Elenco di XMediaItem utilizzato dall'Elenco per apoggiare i nuovi media Presi
  found.ValueListenable<List<XMediaItem>> liXMedias_MediaRecorder = ValueNotifier<List<XMediaItem>>(List<XMediaItem>.empty(growable: true));

  static String xFilterAll = "TUTTI";

  ///Filtro da cambiare per filtrare la Lista dell'Elenco
  String xFilterCurrent = "";

  ///Valore interno all'Elenco per filtrare la Lista
  String? xFilterValue;

  ///Timer utilizzato dalla Barra di Search per gestire il filtro e filtrare la lista dopo tot millisecondi che l'utente scrive
  Timer? timerSearch;

  //Per gestire EditDialog
  ///Da riempire con un elenco di XProp che verranno visualizzate nel EditDialog di un Item
  List<XProp> xEditDialog_liProps = List<XProp>.empty(growable: true);

  ///Nome della Cella, ovvero la colonna, che siamo editando
  String xEditDialog_EditCell = "";

  //Variabili per i Filtri
  ///Da riempire con un elenco di XProp che verranno usate per fare le Ricerche sull'elenco
  List<XProp> xFilter_SearchBarXCols = List<XProp>.empty(growable: true);

  ///Da riempire con un elenco di XProp che verranno usate per ordinare l'Elenco
  List<XProp> xFilter_OrderBy_XProps = List<XProp>.empty(growable: true);

  ///Da riempire con un XFilterEl per aggiungere i filtri all'Elenco
  List<XFilterEl<dynamic>> xFilter_XFilters = List<XFilterEl<dynamic>>.empty(growable: true);

  //Variabili a livello di XScheda
  ///Da abilitare se vuoi la Gestione degli XMedia
  bool xMedia_Active = false;

  ///Da abilitare se vuoi i vari bordi della UI tondeggianti
  bool xRoundedStyle_Active = false;

  ///Da rimepire col messaggio da visualizzare nel Waiter che gira
  String xWaiterMessage = "";

  ///Tab Index selezionato della xTabs_List
  int xCurrentTabIdx = 0;
  int xSelectedPlayerIdx = 0;
  late final ValueNotifier<bool> _isLoaded;

  ///Da Abilitare per attivare il Drag&Drop sull'Elenco
  bool isActive_addDropInElenco = false;

  ///Da Abilitare per visualizzare la barra di aggiunta di un Item dal Drag&Drop
  bool xLayout_AddAreaDrop_NewItem = false;
  bool neededRealoadData = false;
  //File utilizzato come appoggio per diverse BL dell'Elenco
  File? file;

  TextStyle? searchBar_StyleText;
  TextStyle? searchBar_HintStyleText;

  //Variabili di Gestione delle XAction
  ///Modifica la Width delle XActions sugli Items
  double xActionsBTN_Width = 35;

  ///Modifica la Height delle XActions sugli Items
  double xActionsBTN_Height = 35;

  ///Modifica il Bacground delle XActions sugli Items
  Color xActionsBTN_BackgroundColor = Color.fromARGB(255, 27, 27, 27);

  ///Modifica il colore del Bordo delle XActions sugli Items
  Color xActionsBTN_BorderColor = Colors.transparent; // Colors.grey[600]!;

  //Liste dei Tipi di XAction
  ///Azioni di Sinistra sugli Items
  List<XAction>? xActionLi_LEFT;

  ///Azioni di Destra sugli Items
  List<XAction>? xActionLi_RIGHT;

  ///Azioni Fast sugli Items a destra dei Dati della Riga
  List<XAction>? xActionLi_FAST;
  //Impostazioni delle XAction
  ///Larghezza dell Area delle Azioni di Sinistra sugli Items, in percentuale in double es. 0.5
  double? xActions_LEFT_widthArea;

  ///Larghezza dell Area delle Azioni di Destra sugli Items, in percentuale in double es. 0.5
  double? xActions_RIGHT_widthArea;

  ///Decide se le Azioni di Destra devono avere l'Asse di Scroll orizzontale o verticale, se TRUE => Stanno in verticale
  bool xActions_RIGHT_HorizontalAxis = false;

  ///Decide se le Azioni di Sinistra devono avere l'Asse di Scroll orizzontale o verticale, se TRUE => Stanno in verticale
  bool xActions_LEFT_HorizontalAxis = false;

  ///Aggiunge il Bottone di AddNota negli ItemComplex con gli XMedias
  bool xActions_AddNota_isActive = false;

  ///Widget a Sinistra dell'AppBar nello Slider
  List<Widget>? xAppBar_Widgets_LEFT;

  ///Widget a Destra dell'AppBar nello Slider
  List<Widget>? xAppBar_Widgets_RIGHT;

  ///Larghezza in percentuale es. 0.5, a Sinistra dell'AppBar nello Slider
  double? xAppBar_Widgets_LEFT_WidthArea;

  ///Larghezza in percentuale es. 0.5, a Destra dell'AppBar nello Slider
  double? xAppBar_Widgets_RIGHT_WidthArea;

  //Variabili per Styles
  ///Formato della data di tutte le Celle Editabili
  String xCellEditable_xFormat_Date = "dd/MM";

  ///Abilitata o no il bordo di tutte le Celle Editabili
  bool xCellEditable_borderColor_Visible = false;

  ///Colore del Bordo di tutte le Celle Editabili
  Color? xCellEditable_borderColor;

  ///Colore del Bordo di tutte le Celle Editabili Disabilitate
  Color? xCellEditable_borderColor_Disabled;

  ///Colore della Label di tutte le Celle Editabili Disabilitate
  Color? xCellEditable_labelColor_Disabled;

  ///Padding di ogni Items
  EdgeInsetsGeometry? xItems_Padding;

  ///Background Color di ogni Items
  Color xItems_BackgroundColor = Colors.grey[900]!;

  ///Colore del Bordo di ogni Items
  Color xItems_BorderColor = Colors.black;

  ///Definisce se le Celle devono essere flessibili oppure no
  bool xItem_cellIsFlexible = true;

  ///Definisce la quantità di oggetti da visualizzare su un Item
  double xLayout_maxRowLen = 0.0;

  bool isWeb = false;

  ///Propietà interna
  bool isTakingPhoto = false;

  ///Propietà interna
  bool isRecording = false;

  ///Propietà interna
  bool saving = false;

  ///Propietà interna
  List<XFile> _images = [];

  ///Propietà interna
  final picker = ImagePicker();

  @override
  void initState() {
    if (widget.xCells_EditType == null) {
      widget.xCells_EditType = XEnums.editType.scheda;
    }
    //Starto il loading dell'Elenco
    _isLoaded = ValueNotifier(true);

    //Preparo le Liste vuote a livello di State di XElenco
    xActionLi_LEFT = List<XAction>.empty(growable: true);
    xActionLi_RIGHT = List<XAction>.empty(growable: true);
    xActionLi_FAST = List<XAction>.empty(growable: true);
    xAppBar_Widgets_LEFT = List<Widget>.empty(growable: true);
    xAppBar_Widgets_RIGHT = List<Widget>.empty(growable: true);
    //Riempio le Actions Fast cone le Azioni Base
    xActionLi_FAST!.addAll([XActionsBase.showXMedia, XActionsBase.addXMedia, XActionsBase.addDett, XActionsBase.popUpActions]);

    if (widget.xTab_List == null) widget.xTab_List = List<XTabItem>.empty(growable: true);
    if (widget.edited == null) widget.edited = ValueNotifier(false);
    if (widget.xCells_Item_TextStyle == null) widget.xCells_Item_TextStyle = (xCol, item, color) => XStyles.xStyTextForLabel(textColor: color == Colors.black ? XColors.foregroundLight : color);
    if (searchBar_StyleText == null) searchBar_StyleText = XStyles.xStyTextForSubLabel(textColor: widget.searchBar_ColorHint ?? XColors.foregroundLight);

    //Carico i Dati
    xLoadDataOnly();

    //Riempio le liste con gli oggetti che mi aggiungono nelle Actions
    xActions_LoadLists();

    //Inizializzo i Filtri
    initXFilters();
    //Ciclo per tutte le colonne della view che mmi passano e vado a ordinare la lista con le propietà passate
    widget.view!.cols!.forEach((element) {
      if (xFilter_OrderBy_XProps.any((xProp) => xProp.col_Name == element.colKey)) element.sorted = true;
    });
    if (widget.liDetts != null) {
      for (var xProp in xFilter_OrderBy_XProps) {
        widget.liDetts!.orderBy([xProp.col_Name], desc: (widget.view!.cols!.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
      }
    } else {
      for (var xProp in xFilter_OrderBy_XProps) {
        list.orderBy([xProp.col_Name], desc: (widget.view!.cols!.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
      }
    }
    //metto in ascolto il searchController
    searchController.addListener(
      () => setState(() {
        xFilterValue = searchController.text;
        if (timerSearch != null) timerSearch!.cancel();
        timerSearch = Timer(Duration(milliseconds: 300), timerSearchHandlerList);
      }),
    );
    //Aggiungo la lista che mi passano se me la passano in ascolto per eventuali cambi di UI per delle Changes fatte su di essa
    if (xListObservable_Hook != null) xListObservable_Hook!.changes.listen((event) => neededRealoadData = true);

    //Riempio la Lista a livello di State dell'elenco degli XMedia partendo dall'originale che mi passano
    if (widget.liXMediaToUse != null) liMediaRAW = widget.liXMediaToUse!;

    //Se Flag dell'elenco xActions_AddNota_isActive è attivo aggiungo l'azione all'itemComplex dell'AddNota
    if (xActions_AddNota_isActive) {
      xActionLi_RIGHT!.add(XAction(
        "addNotaVuota",
        0,
        "",
        icon: Icons.note_add_outlined,
        label_Color: Colors.white,
        toolTip: "Aggiungi una nota vuota",
        fastAction: false,
        cmd: (itemActive, parentSetState, context) async => await xCMD_AddNewNota(itemActive, parentSetState),
      ));
    }
    super.initState();
    //BL post initState
    if (kIsWeb.not()) {
      //Preparo il playerController per il VideoRecorder e l'AudioPlayer
      playerController = PlayerController();
      playerStateSubscription = playerController.onPlayerStateChanged.listen((_) => setState(() {}));
    }

    //Preparo il TabContreoller per le Tab ipotetiche nell'Elenco
    tabController = TabController(length: widget.xTab_List!.length, vsync: this, initialIndex: xCurrentTabIdx, animationDuration: Duration.zero);
    var _controllerIsValid = tabController.animation != null;
    if (_controllerIsValid) {
      tabController.addListener(() => setState(() => xCurrentTabIdx = tabController.index));
      tabController.animation!.addListener(() => setState(() => xCurrentTabIdx = tabController.index));
    }
  }

  @override
  void dispose() {
    _isLoaded.dispose();
    isBusy.dispose();
    searchController.dispose();
    if (kIsWeb.not()) {
      playerController.dispose();
      playerStateSubscription.cancel();
    }
    tabController.dispose();
    super.dispose();
  }

  ///Override per aggiungere alle liste delle actions altre actions prima che vengano fillate tutte le varie aree
  Future xActions_LoadLists() async {}

  ///Mettere quì il codice di init degli XFilters
  void initXFilters() {
    xFilter_XFilters.clear();
    xFilter_OrderBy_XProps.clear();
    xFilter_SearchBarXCols.clear();
  }

  ///Chiamalo per reloddare tutta la UI dell'Elenco
  void rebuildAllChildren(BuildContext context) {
    void rebuild(Element el) {
      el.markNeedsBuild();
      el.visitChildren(rebuild);
    }

    (context as Element).visitChildren(rebuild);
  }

  ///Chiamato solo quando viene modificato il valore della xSearchBar
  timerSearchHandlerList() {
    setState(() {
      if (timerSearch != null) timerSearch!.cancel();
      if (xFilterValue != "") {
        xFilterCurrent = xFilterValue.toString();
      } else if (xFilterValue == "") {
        xFilterCurrent = "";
      }
    });
  }

  ///Chiamalo quando torni da un altra pagina dopo una navigazione cosi da riscatenare il cambiamento della lista
  onComeBack() {
    if (neededRealoadData) xLoadDataOnly();
  }

//
//
//
//Metodi di load/refresh dei Dati
//Metodi di load/refresh dei Dati
//Metodi di load/refresh dei Dati
//
//
//

  ///Caricamento dei Dati dell'Elenco e Fill della Lista dell'Elenco
  xLoadDataOnly() {
    setState(() => isBusy.value = true);
    if (xLoadData_get != null) {
      list.clear();
      list.addAll(xLoadData_get!());
      setState(() {
        isBusy.value = false;
        xAfter_LoadData_Done();
      });
    }
    if (xLoadData_apiCall != null) {
      xLoadData_apiCall!().then((value) {
        list.clear();
        list.addAll(value);
      }).whenComplete(() {
        setState(() {
          isBusy.value = false;
          xAfter_LoadData_Done();
        });
      });
    }
    if (widget.liDetts != null) setState(() => isBusy.value = false);
    neededRealoadData = false;
  }

  ///Override per inserire codice dopo il loadData
  xAfter_LoadData_Done() {}

  ///Da chiamare per refreshare la Lista dell'Elenco come nuova,ma se la where è fill allora refresha la lista usando xListObservable_Hook applicandoci la tua Where
  xRefresh_Data({bool Function(K)? where}) {
    if (where != null) {
      setState(() {
        list.clear();
        list.addAll(xListObservable_Hook!.where((element) => where(element)));
      });
    } else
      xLoadDataOnly();
  }

//
//
//
//Eventi legati agli Items dell'elenco
//Eventi legati agli Items dell'elenco
//Eventi legati agli Items dell'elenco
//
//
//

  ///Override per modificare l'OnTap su un Item
  Future xOnTapItem(K item) async {
    return null;
  }

  ///Override per modificare il LongPress su un Item
  Future xOnLongTapItem(dynamic item) async {
    return (widget.onLongTapItem != null) ? (widget.onLongTapItem!(item)) : null;
  }

//
//
//
//Eventi legati all'edit di una cella Editable
//Eventi legati all'edit di una cella Editable
//Eventi legati all'edit di una cella Editable
//
//
//

  ///Evento chiamato prima dell'Edit di una cella Editable
  xOnXCell_Before_Edit(XCol xCol, dynamic value, {dynamic itemToSet}) async {
    if (xEditDialog_liProps.isEmpty) {
      xEditDialog_EditCell = xCol.colCaption;
    } else {
      for (var i in xEditDialog_liProps) {
        xEditDialog_EditCell = " " + i.col_Label;
      }
    }
    // setState(() {});
    return () {};
  }

  ///Evento chiamato prima dell'Uscita dall'edit da una cella Editable
  xOnXCell_Edit_BeforeSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) async {}

  ///Evento chiamato quando il valore cambia all'interno dell EDITOR della CELLA
  xOnXCell_Edit_OnChanged(XFDataItem itemInEdit, XCol xCol, dynamic newValue) async {
    xOnXCell_Edit_SubmitValue_ToItem(itemInEdit, xCol, newValue, true);
  }

  ///called in a setState
  ///Evento chiamato dopo l'Uscita dalla Cella Editable
  xOnXCell_Edit_AfterSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {}
  //Da chiamare per Confermare l'edit di un dato
  /// valueForRealCol = value da mettere nella col reale: es artID noi abbiamo sempre colKey = artiID_resolved, la RealCol
  xOnXCell_Edit_SubmitValue_INTERNAL(XFDataItem itemInEdit, XCol xCol, dynamic newValue, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    var valueIsChanged;
    itemInEdit.isModified = true;

    if (newValue != null && newValue is XEnumDef)
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue.value ?? 0);
    else
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue);

    xOnXCell_Edit_BeforeSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_SubmitValue_ToItem(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_AfterSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    widget.rootItemEdited!(itemInEdit as K);
  }

  /// only itemInEdit[xCol.colKey] = value!;
  xOnXCell_Edit_SubmitValue_ToItem(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    if (newValue is XEnumDef) {
      itemInEdit[xCol.colKey] = newValue.value;
    } else {
      // ID & _resolved
      if (xCol.colKey.endsWith("_resolved")) {
        if (valueForResolved != null) itemInEdit[xCol.colKey] = valueForResolved!;
        if (valueForRealCol != null) // parte del campo vero, senza _resolved
          itemInEdit[xCol.colKey.replaceAll("_resolved", "")] = valueForRealCol!;
        else
          itemInEdit[xCol.colKey] = newValue;
      } else
        itemInEdit[xCol.colKey] = valueForRealCol ?? newValue;
    }
  }

//
//
//
//Eventi per il Drag&Drop
//Eventi per il Drag&Drop
//Eventi per il Drag&Drop
//
//
//

  ///Evento chiamato una volta accettato il DROP su un Item
  Future xOnDrop_Accept(XFDataItem? itemDragged, XFDataItem? itemToDrop) async {
    setState(() => isActive_addDropInElenco = false);
  }

  ///Evento da chiamare per accettare il Drop sull'Item.
  bool xOnDrop_BeforeAccept(XFDataItem? itemDragged, XFDataItem? itemToDrop) {
    var res = xOnDrop_BeforeAccept_INTERNAL(itemDragged, itemToDrop);
    if (xLayout_AddAreaDrop_NewItem) {
      setState(() {
        if (res)
          isActive_addDropInElenco = true;
        else
          isActive_addDropInElenco = false;
      });
    }

    return res;
  }

  ///Evento chiamato per accettare il Drop sull'Item (!INTERNAL!)
  bool xOnDrop_BeforeAccept_INTERNAL(XFDataItem? itemDragged, XFDataItem? itemToDrop) {
    return true;
  }

  ///Evento chiamato una volta quando vai via da un Item dell'Elenco con l'oggetto che vuoi droppare
  xOnDrop_Leave(XFDataItem? item) {
    setState(() => isActive_addDropInElenco = false);
  }

  ///Evento chiamato quando cambia un XFilter inserito nella lista dei filtri nel metodo initXFilter
  bool xFilter_FilterItem(K item) {
    // widget.whereMethod!(element, filterCurrent)
    var rval = true;
    // se ci sono appli XFilterEl
    if (xFilter_XFilters.isNotEmpty) {
      for (var xf in xFilter_XFilters) {
        var propNameReal = xf.xPropOfItemToFilter.col_Name;
        if (propNameReal.endsWith("ID")) propNameReal += "_resolved";
        if (xf.Value == xf.All)
          rval = true;
        else if (xf.Value is XFDataItem) {
          if (xf.xPropOfItemToFilter.col_Name.endsWith("ID"))
            rval = item[xf.xPropOfItemToFilter.col_Name]! == (xf.Value as XFDataItem).id;
          else
            rval = item[xf.xPropOfItemToFilter.col_Name]! == (xf.Value as XFDataItem)[xf.ColsOfXFdataItemToShow.first.col_Name];
        } else if (xf.Value is XEnumDef) {
          rval = item[xf.xPropOfItemToFilter.col_Name]! == (xf.Value as XEnumDef).value;
        } else {
          rval = item[propNameReal]! == xf.Value!;
        }
        if (!rval) return false;
      }
    }
    if (xFilterCurrent.isNotEmpty && xFilter_SearchBarXCols.isNotEmpty) {
      var searchBarResult = false;
      for (XProp pippo in xFilter_SearchBarXCols) {
        var propNameReal = pippo.col_Name;
        if (propNameReal.endsWith("ID")) propNameReal += "_resolved";
        searchBarResult = item[propNameReal]!.toLowerCase().contains(xFilterCurrent.toLowerCase());
        if (searchBarResult) {
          break;
        }
      }
      if (searchBarResult) return searchBarResult;
      if (widget.searchBar_whereMethod != null) return widget.searchBar_whereMethod!(item, xFilterCurrent);
      return searchBarResult;
    }
    return true;
  }

//
//
//
//Cmds dell'Elenco
//Cmds dell'Elenco
//Cmds dell'Elenco
//
//
//

  ///Comando per rimuovere un Item dalla Lista e scatenare il change
  Future<bool> xCMD_DeleteFromList(XFDataItem itemToRemove, String title, {required Function(String) cmd_Delete}) async {
    bool x = await showDialog(
        barrierDismissible: false,
        context: context,
        builder: (builder) {
          return XAlertDialog(
            btnNO_label: "NO",
            btnYES_label: "SI",
            btnYES_OnPressed: () => Navigator.pop(context, true),
            btnNO_OnPressed: () => Navigator.pop(context, false),
            title_Text: title,
            title_Style: XStyles.xStyTextForSubLabel(textColor: Colors.yellow),
          );
        });

    if (x) {
      if (itemToRemove.id == "") {
        return false;
      } else {
        if (widget.liDetts != null) {
          setState(() => widget.liDetts!.remove(itemToRemove));
        } else {
          setState(() => list.remove(itemToRemove));
        }
        await cmd_Delete(itemToRemove.id);
        if (widget.rootItemEdited != null && itemToRemove is K) {
          widget.rootItemEdited!(itemToRemove);
        } else if (widget.itemEdited != null) {
          widget.itemEdited!(itemToRemove);
        }
        if (widget.edited != null) widget.edited!.value = true;
        return true;
      }
    } else
      return false;
  }

  ///Comando per Aggiungere un contatto dalla Rubrica
  Future<Contact?> xCMD_AddFromRubrica(List<Contact> listContact) async {
    PermissionStatus permission = await Permission.contacts.status;
    if (permission != PermissionStatus.granted && permission != PermissionStatus.permanentlyDenied) {
      PermissionStatus permissionStatus = await Permission.contacts.request();
      print(permissionStatus);
    } else
      print(permission);

    if (listContact.isEmpty) {
      var res = await ContactsService.getContacts();
      listContact.addAll(res);
    }
    Contact? xclContatto;
    var x = await showDialog<Contact>(
        context: context,
        builder: (context) {
          return StatefulBuilder(
            builder: (context, setState) {
              return XAlertDialog(
                  title_Text: "Scegli il contatto dalla tua RUBRICA:",
                  height: null,
                  content_VerticalPadding: 30,
                  child: XDropSearch<Contact>(
                    dropDownMode: "Dialog",
                    al_Title: "",
                    al_BackGroundColor: Colors.grey[900],
                    itemSelected: xclContatto,
                    liItems: listContact.where((element) => element.phones!.isNotEmpty).toList(),
                    label: "",
                    itemAsString: (p0) => (p0.givenName ?? "") + " " + (p0.familyName ?? ""),
                    onChanged_ItemOfDD: (contact) => setState(() => xclContatto = contact),
                  ),
                  actionsBTNarea_Child: Row(children: [
                    Expanded(
                        child: XBtnbase(
                      label: "Annulla",
                      onPressed: () => Navigator.pop(context, null),
                      label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.undo),
                    )),
                    xclContatto != null
                        ? Expanded(
                            child: XBtnbase(
                            label: "Avanti",
                            onPressed: () => Navigator.pop(context, xclContatto),
                            label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.done),
                          ))
                        : Container()
                  ]));
            },
          );
        });
    if (x != null && xclContatto != null)
      return xclContatto;
    else
      return null;
  }

  ///Evento chiamato quando l'utente fa Tap su una cella dell'HeadView di un Elenco
  xOnTapHeaderCell(XCol xCol) {
    setState(() {
      widget.view!.cols!.forEach((element) {
        if (element.colKey != xCol.colKey) {
          element.sorted = null;
        }
      });
      if (xCol.sorted == null) {
        xCol.sorted = true;
      } else {
        xCol.sorted = xCol.sorted!.not();
      }
      if (widget.liDetts != null) {
        widget.liDetts!.orderBy([xCol.colKey], desc: (xCol.sorted ?? false).not());
      } else {
        list.orderBy([xCol.colKey], desc: (xCol.sorted ?? false).not());
      }
    });
  }

//
//
//
//XActions
//XActions
//XActions
//
//
//

  ///Chiamalo pert aggiungere delle XActions a SINISTRA dell'Item
  List<XAction?>? xActions_LEFT_ForItem(XFDataItem item) {
    return null;
  }

  ///Chiamalo pert aggiungere delle XActions a DESTRA dell'Item
  List<XAction?>? xActions_RIGHT_ForItem(XFDataItem item) {
    return null;
  }

  ///Chiamalo pert aggiungere delle XActions veloci visibili a destra sull'Item, ma solo visibili nell'ItemComplex
  List<XAction?>? xActions_FAST_ForItem(XFDataItem item) {
    return [];
  }

//
//
//
//XMEDIAS Event/Cmds
//XMEDIAS Event/Cmds
//XMEDIAS Event/Cmds
//
//
//

  ///Comando per ottenre gli XMedia e aprire XMediaRecorder
  Future<File?> xCMD_XMedia_GetMedia(void Function(void Function()) setState, XFDataItem item) async {
    item.isShowDetails = true;
    FocusScope.of(context).unfocus();
    var _photoController = CameraController(widget.xApp!.state.cameras[0], ResolutionPreset.max, enableAudio: true);
    await showDialog<bool?>(
        context: context,
        barrierDismissible: false,
        builder: (builder) {
          return StatefulBuilder(builder: (context, setState) {
            final global_Key = GlobalKey();
            return XAlertDialog(
                colorBackGround: Colors.grey[900],
                actionsBTNarea_Padding: EdgeInsets.all(0),
                content_VerticalPadding: 0,
                child: Container(
                    alignment: Alignment.topCenter,
                    child: Column(
                      mainAxisSize: MainAxisSize.min,
                      children: [
                        saving
                            ? Container()

                            ///Row delle Preview dei media fatti
                            : Row(mainAxisAlignment: liXMedias_MediaRecorder.value.isNotEmpty ? MainAxisAlignment.start : MainAxisAlignment.center, children: [
                                Expanded(
                                    child: SingleChildScrollView(
                                        scrollDirection: Axis.horizontal,
                                        child: Row(
                                            mainAxisAlignment: MainAxisAlignment.center,
                                            crossAxisAlignment: CrossAxisAlignment.center,
                                            children: liXMedias_MediaRecorder.value.isEmpty
                                                ? [Container(height: 80, width: MediaQuery.of(context).size.width, color: Colors.grey[800], alignment: Alignment.center)]
                                                : liXMedias_MediaRecorder.value
                                                    .map((e) => InkWell(
                                                        onTap: () {
                                                          if (e.mediaType == XEnums.mediaType.image.value) {
                                                            xCMD_XMedia_OpenPhoto(e, item);
                                                          } else if (e.mediaType == XEnums.mediaType.video.value) {
                                                            xCMD_XMedia_OpenVideo(e, pathPreviewVideo: "${XLibStorage.filePath}/XMEDIAS/${e.id}_.mp4", setState: setState);
                                                          } else if (e.mediaType == XEnums.mediaType.audio.value) {
                                                            xCMD_XMedia_OpenAudio(e, item, true);
                                                          }
                                                        },
                                                        onLongPress: () async {
                                                          await xOnDelXMedia_InPreview(e, setState);
                                                        },
                                                        child: e.mediaType == XEnums.mediaType.image.value
                                                            ? Container(
                                                                width: 80,
                                                                height: 80,
                                                                child: Stack(children: [
                                                                  Container(margin: EdgeInsets.symmetric(horizontal: 5), width: 80, child: Image.memory(e.payload!, width: 80, height: 80)),
                                                                  e.overlaySurface != null
                                                                      ? Container(
                                                                          margin: EdgeInsets.only(bottom: 50),
                                                                          child: Image.memory(
                                                                            e.overlaySurface!,
                                                                            height: 80,
                                                                            width: 80,
                                                                          ))
                                                                      : Container()
                                                                ]))
                                                            : e.mediaType == XEnums.mediaType.video.value
                                                                ? Container(
                                                                    margin: EdgeInsets.symmetric(horizontal: 5),
                                                                    decoration: BoxDecoration(color: Colors.grey[800], image: DecorationImage(image: MemoryImage(e.miniatura!))),
                                                                    width: 80,
                                                                    height: 80,
                                                                    child: Container(
                                                                      child: Icon(Icons.play_arrow, size: 28, color: Colors.blueAccent[900]),
                                                                    ))
                                                                : Container(
                                                                    margin: EdgeInsets.symmetric(horizontal: 5),
                                                                    decoration: BoxDecoration(color: Colors.grey[800]),
                                                                    width: 80,
                                                                    height: 80,
                                                                    child: Icon(Icons.mic),
                                                                  )))
                                                    .toList())))
                              ]),

                        ///XMEDIA RECORDER
                        ///XMEDIA RECORDER
                        Container(
                            width: MediaQuery.of(context).size.width,
                            height: MediaQuery.of(context).orientation == Orientation.portrait ? MediaQuery.of(context).size.height / 1.34 : MediaQuery.of(context).size.height / 1.42,
                            child: XMediaRecorder<XFDataItem>(
                              global_Key,
                              parentSetState: setState,
                              photoController: _photoController,
                              itemOriginal: item,
                              lXMedias: liXMedias_MediaRecorder.value,
                              xApp: widget.xApp!,
                              onStartTakeVideo: (parentState) => setState(() => isRecording = true),
                              onEndTakeVideo: (parentState) => setState(() => isRecording = false),
                              onTakeMedia: (parentState) => setState(() => isTakingPhoto = isTakingPhoto.not()),
                            ))

                        ///XMEDIA RECORDER
                        ///XMEDIA RECORDER
                      ],
                    )),
                title_Widget: Container(),
                title_Style: XStyles.xStyTextForLabel(textColor: Colors.yellow),
                content_insetPadding: EdgeInsets.all(0),
                actionsBTNarea_Child: Container(
                    height: 70,
                    child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                      isRecording || isTakingPhoto
                          ? Expanded(
                              child: isRecording
                                  ? Text("Sto Registrando...", style: XStyles.xStyTextForSubLabel(textColor: Colors.red), textAlign: TextAlign.center) //
                                  : isTakingPhoto.not()
                                      ? Container()
                                      : XStatefulWidgetBase.LoaderIndicator(isTakingPhoto, label: "Acquisizione Media..", fixHeight: 30, fixWidth: 30))
                          : Container(),
                      isTakingPhoto || isRecording
                          ? Container()
                          : Expanded(
                              child: XBtnbase(
                              height: 45,
                              icon_Widget: Icon(Icons.undo, color: Colors.red, size: 30),
                              backGroundColor: Colors.grey[800]!,
                              onPressed: () async {
                                liXMedias_MediaRecorder.value.clear();
                                Navigator.pop(context, false);
                              },
                              elevation: 0,
                              label: "",
                            )),
                      SizedBox(width: 6),
                      isTakingPhoto || isRecording
                          ? Container()
                          : Expanded(
                              child: XBtnbase(
                              label: "Media Esterni",
                              height: 45,
                              backGroundColor: Colors.grey[800]!,
                              elevation: 0,
                              onPressed: () async {
                                await _photoController.pausePreview();
                                await _getImages_FromGallery();
                                if (_images.isNotEmpty) {
                                  _images.forEach((xclFile) async {
                                    print(xclFile.name);
                                    var xMedia = XMediaItem(
                                      Uuid().v4(),
                                      xDocID: item.id,
                                      mediaType: xclFile.name.endsWith("mp4")
                                          ? XEnums.mediaType.video.value
                                          : (xclFile.name.endsWith("jpg") || xclFile.name.endsWith("png"))
                                              ? XEnums.mediaType.image.value
                                              : xclFile.name.endsWith("aac")
                                                  ? XEnums.mediaType.audio.value
                                                  : XEnums.mediaType.image.value,
                                      payload: File(xclFile.path).readAsBytesSync(),
                                      isNew: true,
                                    );
                                    setState(() => liXMedias_MediaRecorder.value.add(xMedia));
                                  });
                                }
                                await _photoController.resumePreview();
                              },
                            )),
                      SizedBox(width: 6),
                      liXMedias_MediaRecorder.value.isNotEmpty
                          ? isTakingPhoto || isRecording
                              ? Container()
                              : Expanded(
                                  child: XBtnbase(
                                  height: 45,
                                  backGroundColor: Colors.grey[900]!,
                                  onPressed: () async {
                                    _photoController.pausePreview();
                                    setState(() => saving = true);
                                    if (liXMedias_MediaRecorder.value.isNotEmpty) {
                                      isTakingPhoto = true;
                                      await Future.forEach(liXMedias_MediaRecorder.value, (xclMedia) => xOnTakeXMedia_handling(xclMedia.payload!, isBusy.value, setState, item, xclMedia.mediaType!));
                                      await xOnSaveXMedia_INTERNAL(liMediaRAW, item)?.then((value) => Navigator.pop(context, true));
                                      item.showXMedia = true;
                                      if (item is K)
                                        widget.rootItemEdited != null ? widget.rootItemEdited!(item) : null;
                                      else
                                        widget.itemEdited != null ? widget.itemEdited!(item) : null;
                                    }
                                    liXMedias_MediaRecorder.value.clear();
                                    isTakingPhoto = false;
                                    setState(() => saving = false);
                                    await _photoController.dispose();
                                  },
                                  elevation: 0,
                                  icon_Widget: Icon(Icons.save, color: Colors.green, size: 30),
                                  label_Style: XStyles.xStyleText(colorText: Colors.green, fontSize: 24, activeBold: false),
                                ))
                          : Container()
                    ])));
          });
        }).then((value) async => await _photoController.dispose());
    return null;
  }

  ///Comando per aprire una foto degli XMedia
  Future xCMD_XMedia_OpenPhoto(XMediaItem xMedia, XFDataItem item, {DateTime? dtImage, bool isNewNota = false}) async {
    xMedia.isSel = true;
    var res = await showDialog<bool?>(
        context: context,
        builder: (context) {
          return ImagePainter.signature(
            xMedia: xMedia,
            isNewNota: isNewNota,
            height: MediaQuery.of(context).size.height / 1.2,
            width: MediaQuery.of(context).size.width,
            loadMedia: (xclMedia) async => await xLoadMedia(xclMedia),
            key: _imagePainterState_Key,
          );
        });
    xMedia.isSel = false;
    if (res != null && res) {
      // diciamo al padre (SCHEDA) che è stato modificato qlcs
      if (item is K)
        widget.rootItemEdited != null ? widget.rootItemEdited!(item) : null;
      else
        widget.itemEdited != null ? widget.itemEdited!(item) : null;
      setState(() => xMedia.isModified = true);
      await xOnAfterXMedia_EditPhoto(xMedia);
    } else {}
  }

  ///Comando per aprire un video degli XMedia
  Future xCMD_XMedia_OpenVideo(XMediaItem xMedia, {String? pathPreviewVideo, void Function(void Function())? setState}) async {
    isBusy.value = false;
    setState!(() {
      xWaiterMessage = "Caricamento del Video, Attendi un attimo..";
      xMedia.isSel = true;
    });
    if (xMedia.payload == null) {
      await xOnGetXMedia(xMedia).then((x) {
        if (x != null) xMedia.payload = x.payload;
      });
    }
    xMedia.isSel = false;
    bool _isPlaying = false;

    Future<void> _playVideo() async {
      await videoPlayerController!.play();
      setState(() {});
    }

    Future<void> _pauseVideo() async {
      await videoPlayerController!.pause();
      setState(() {});
    }

    Future<void> _stopVideo() async {
      await videoPlayerController!.pause();
      await videoPlayerController!.seekTo(Duration.zero);
      setState(() {});
    }

    bool isPlaying;
    File x = await (xMedia.localURI != "" || pathPreviewVideo != null) ? File.fromUri(Uri.parse(pathPreviewVideo ?? xMedia.localURI!)) : File("${XLibStorage.filePath}/XMEDIAS/${xMedia.id}_.mp4");
    await x.create(recursive: true);
    await x.writeAsBytes(xMedia.payload!).then((value) async {
      videoPlayerController = await VideoPlayerController.file(value, videoPlayerOptions: VideoPlayerOptions(allowBackgroundPlayback: true));

      await videoPlayerController!
        ..addListener(() {
          isPlaying = videoPlayerController!.value.isPlaying;
          if (isPlaying != _isPlaying) setState(() => _isPlaying = isPlaying);
        })
        ..initialize().then((_) => setState(() {}));
      await videoPlayerController!.play();

      return await showDialog(
          context: context,
          builder: (context) {
            return StatefulBuilder(builder: (context, setState) {
              var isPlay = videoPlayerController!.value.isPlaying;
              return XAlertDialog(
                  content_insetPadding: EdgeInsets.all(0),
                  title_TextAlign: TextAlign.center,
                  actionsBTNarea_Padding: EdgeInsets.all(0),
                  title_Text: "Video",
                  actionsBTNarea_Child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                    isPlay
                        ? Expanded(
                            child: XBtnbase(
                            label: "Restart",
                            onPressed: () {
                              setState(() {
                                _stopVideo();
                                isPlay = false;
                              });
                            },
                            label_Style: XStyles.xStyTextForLabel(textColor: Colors.yellow),
                          ))
                        : Container(),
                    Expanded(
                        child: XBtnbase(
                      label: isPlay ? "Pausa" : "Play",
                      onPressed: () {
                        setState(() {
                          if (isPlay) {
                            _pauseVideo();
                            isPlay = false;
                          } else {
                            _playVideo();
                            isPlay = true;
                          }
                        });
                      },
                      label_Style: XStyles.xStyTextForLabel(textColor: Colors.green),
                    )),
                    Expanded(
                        child: XBtnbase(
                      label: "Chiudi",
                      onPressed: () {
                        videoPlayerController!.dispose();
                        Navigator.pop(context);
                      },
                      label_Style: XStyles.xStyTextForLabel(textColor: Colors.red),
                    ))
                  ]),
                  child: Stack(children: [
                    InkWell(
                        child: Container(width: MediaQuery.of(context).size.width, height: MediaQuery.of(context).size.height, child: VideoPlayer(videoPlayerController!)),
                        onTap: () {
                          setState(() {
                            if (isPlay) {
                              _pauseVideo();
                              isPlay = false;
                            } else {
                              _playVideo();
                              isPlay = true;
                            }
                          });
                        })
                  ]));
            });
          }).whenComplete(() {
        setState(() {
          xWaiterMessage = "";
          isBusy.value = true;
        });
      });
    });
  }

  ///Comando per aprire un audio degli XMedia
  Future xCMD_XMedia_OpenAudio(XMediaItem audio, XFDataItem item, bool isPreview) async {
    await showDialog(
        context: context,
        builder: (context) {
          return XAlertDialog(
              height: 150,
              actionsBTNarea_Child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                Expanded(
                    child: XBtnbase(
                        label: "Chiudi",
                        label_Color: Colors.red,
                        onPressed: () {
                          playerController.stopPlayer();
                          playerController.dispose();
                          Navigator.pop(context);
                        }))
              ]),
              child: xLayout_Builder_AudioArea(audio, isPreview),
              title_Text: "");
        });
  }

  ///Comando per l'aggiunta di una nota tutta bianca pronta per l'edit
  ///Overridabile per modificare o aggiungere BL
  /// !!! OBBLIGATORIO passargli un itemActive XFDataItem con una lista di XMediaItem !!!
  Future xCMD_AddNewNota(dynamic itemActive, void Function(void Function()) parentSetState) async {
    //nuova notas bianca
    var xclMedia = XMediaItem(Uuid().v4(), xDocID: itemActive.id, mediaType: XEnums.mediaType.image.value, payload: xCreateWhiteImage_SizeOfScreen(), isNew: true);
    xclMedia.visPos = itemActive.liXMedia!.isEmpty ? 10 : itemActive.liXMedia!.last.visPos! + 10;
    liMediaRAW.add(xclMedia);
    itemActive.showXMedia = true;
    itemActive.isModified = true;
    xclMedia.blobURL = "${XLibStorage.filePath}/XMEDIAs/${xclMedia.id}_.${XElencoState.extForMediaType(xclMedia.mediaType!)}";
    await xCMD_XMedia_OpenPhoto(xclMedia, itemActive, isNewNota: true).then((value) => parentSetState(() {})).then((value) => widget.rootItemEdited!(itemActive));
  }

  ///Comando per l'Aggiunta di una Riga all'elenco partendo da un cliente
  /// !!! OBBLIGATORIO passargli un Cliente !!!
  Future xCMD_AddNew_FromCliente<T, XFDataItem>(
    T newObj,
    List<Contact> liContatti,
    List<DynamicCli> liCliente, {
    Future Function(T newOBJ, DynamicCli cliente)? onAddObj_FromCliExist,
    Future Function(T newOBJ, String alias, String nome, String cognome, String cell, String email, String referente)? onAddObj_FromCliRubrica,
    Future Function(T newOBJ, String alias, String nome, String cognome, String cell, String email, String referente)? onAddObj_FromCliInput,
    Future Function(T newOBJ)? onSaveAfter_Cliente,
    bool isActive_input_ALIAS = true,
    bool isActive_input_NOME = true,
    bool isActive_input_COGNOME = true,
    bool isActive_input_CELL = true,
    bool isActive_input_EMAIL = true,
    bool isActive_input_REFERENTE = true,
  }) async {
    dynamic cliente_UI;
    TextEditingController alias_textEditingController_UI = TextEditingController();
    TextEditingController nome_textEditingController_UI = TextEditingController();
    TextEditingController cognome_textEditingController_UI = TextEditingController();
    TextEditingController cell_textEditingController_UI = TextEditingController();
    TextEditingController email_textEditingController_UI = TextEditingController();
    TextEditingController nomeReferente_textEditingController_UI = TextEditingController();
    String? _alias_UI;
    String? _nome_UI;
    String? _cognome_UI;
    String? _cell_UI;
    String? _email_UI;
    String? _nomeReferente_UI;

    Contact? xclContact;

    bool cli_exist = false;
    bool cli_rubrica = false;
    bool loadingRubrica = false;
    var res = await showDialog<bool?>(
        barrierDismissible: false,
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return Container(
                child: XAlertDialog(
                    height: 250,
                    colorBackGround: Colors.grey[900],
                    actionsBTNarea_Padding: EdgeInsets.all(5),
                    content_VerticalPadding: 5,
                    btnNO_OnPressed: () => Navigator.pop(context, false),
                    btnYES_OnPressed: () => Navigator.pop(context, true),
                    btnYES_label: "Avanti",
                    btnNO_label: "Annulla",
                    title_Text: "Contatto della Richiesta:",
                    child: Container(
                        alignment: Alignment.topCenter,
                        child: SingleChildScrollView(
                            child: Column(mainAxisSize: MainAxisSize.min, children: [
                          Row(children: [
                            isActive_input_NOME
                                ? Expanded(
                                    child: Autocomplete<DynamicCli>(
                                    fieldViewBuilder: (BuildContext context, TextEditingController textEditingController, FocusNode focusNode, VoidCallback onFieldSubmitted) {
                                      return XTextFormField(
                                        controller: nome_textEditingController_UI,
                                        borderWidth: 2,
                                        height: null,
                                        colorBorder: Colors.grey[900],
                                        focusNode: focusNode,
                                        autoFocus: true,
                                        border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                        hintText: "nome cliente...",
                                        labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                        textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                        hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                        textCapitalization: TextCapitalization.sentences,
                                        inputFormatters: [],
                                        onChanged: (value) {
                                          textEditingController.text = value;
                                          setState(() {
                                            if (value == "") {
                                              _nome_UI = null;
                                            } else {
                                              _nome_UI = value;
                                            }
                                            if (cliente_UI != null) {
                                              cliente_UI = null;
                                            } else {}
                                          });
                                        },
                                      );
                                    },
                                    displayStringForOption: (option) {
                                      return (option.nome ?? "") + " " + (option.cognome ?? "");
                                    },
                                    optionsBuilder: (TextEditingValue textEditingValue) {
                                      if (textEditingValue.text == '') {
                                        return Iterable<DynamicCli>.empty();
                                      } else {
                                        return liCliente.where((element) => element.nome!.toLowerCase().contains(textEditingValue.text.toLowerCase()));
                                      }
                                    },
                                    onSelected: (cli) {
                                      setState(() {
                                        cliente_UI = cli.getCloneFull();
                                        _nome_UI = "";
                                        alias_textEditingController_UI.text = cliente_UI!.nickname;
                                        nome_textEditingController_UI.text = cliente_UI!.nome ?? "";
                                        cognome_textEditingController_UI.text = cliente_UI!.cognome ?? "";
                                        email_textEditingController_UI.text = cliente_UI!.email ?? "";
                                        cell_textEditingController_UI.text = cliente_UI!.cell ?? "";
                                      });
                                    },
                                    initialValue: TextEditingValue(text: _nome_UI ?? ""),
                                  ))
                                : Container(),
                            SizedBox(width: 10),
                            isActive_input_COGNOME
                                ? Expanded(
                                    child: Autocomplete<DynamicCli>(
                                    fieldViewBuilder: (BuildContext context, TextEditingController textEditingController, FocusNode focusNode, VoidCallback onFieldSubmitted) {
                                      return XTextFormField(
                                        controller: cognome_textEditingController_UI,
                                        height: null,
                                        borderWidth: 2,
                                        colorBorder: Colors.grey[900],
                                        focusNode: focusNode,
                                        autoFocus: false,
                                        border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                        hintText: "cognome cliente...",
                                        labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                        textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                        hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                        textCapitalization: TextCapitalization.sentences,
                                        inputFormatters: [],
                                        onChanged: (value) {
                                          textEditingController.text = value;
                                          setState(() {
                                            if (value == "") {
                                              _cognome_UI = null;
                                            } else {
                                              _cognome_UI = value;
                                            }
                                            if (cliente_UI != null) {
                                              cliente_UI = null;
                                            } else {}
                                          });
                                        },
                                      );
                                    },
                                    displayStringForOption: (option) {
                                      return (option.cognome ?? "") + " " + (option.nome ?? "");
                                    },
                                    optionsBuilder: (TextEditingValue textEditingValue) {
                                      if (textEditingValue.text == '') {
                                        return Iterable<DynamicCli>.empty();
                                      } else {
                                        return liCliente.where((element) => element.cognome!.toLowerCase().contains(textEditingValue.text.toLowerCase()));
                                      }
                                    },
                                    onSelected: (cli) {
                                      setState(() {
                                        cliente_UI = cli.getCloneFull();
                                        _cognome_UI = "";
                                        alias_textEditingController_UI.text = cliente_UI!.nickname;
                                        nome_textEditingController_UI.text = cliente_UI!.nome ?? "";
                                        cognome_textEditingController_UI.text = cliente_UI!.cognome ?? "";
                                        email_textEditingController_UI.text = cliente_UI!.email ?? "";
                                        cell_textEditingController_UI.text = cliente_UI!.cell ?? "";
                                      });
                                    },
                                    initialValue: TextEditingValue(text: _nome_UI ?? ""),
                                  ))
                                : Container(),
                          ]),
                          isActive_input_ALIAS
                              ? Row(children: [
                                  Expanded(
                                      child: XTextFormField(
                                          controller: alias_textEditingController_UI,
                                          borderWidth: 2,
                                          colorBorder: Colors.grey[900],
                                          autoFocus: true,
                                          border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          height: null,
                                          disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                          hintText: "alias...",
                                          labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                          hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textCapitalization: TextCapitalization.sentences,
                                          inputFormatters: [],
                                          onChanged: (value) {
                                            alias_textEditingController_UI.text = value;
                                            setState(() {
                                              if (value == "")
                                                _alias_UI = null;
                                              else
                                                _alias_UI = value;
                                              if (cliente_UI != null) cliente_UI = null;
                                            });
                                          })),
                                  SizedBox(width: 10)
                                ])
                              : Container(),
                          isActive_input_REFERENTE
                              ? Row(children: [
                                  Expanded(
                                      child: XTextFormField(
                                          controller: nomeReferente_textEditingController_UI,
                                          borderWidth: 2,
                                          height: null,
                                          colorBorder: Colors.grey[900],
                                          border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                          hintText: "nome referente...",
                                          textCapitalization: TextCapitalization.sentences,
                                          keyboardType: TextInputType.name,
                                          labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                          hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          inputFormatters: [],
                                          onChanged: (value) {
                                            nomeReferente_textEditingController_UI.text = value;
                                            setState(() {
                                              if (value == "")
                                                _nomeReferente_UI = null;
                                              else
                                                _nomeReferente_UI = value;
                                              if (cliente_UI != null) cliente_UI = null;
                                            });
                                          }))
                                ])
                              : Container(),
                          isActive_input_CELL
                              ? Row(children: [
                                  Expanded(
                                      child: XTextFormField(
                                          controller: cell_textEditingController_UI,
                                          borderWidth: 2,
                                          height: null,
                                          colorBorder: Colors.grey[900],
                                          border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                          hintText: "cell...",
                                          textCapitalization: TextCapitalization.sentences,
                                          keyboardType: TextInputType.phone,
                                          labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                          hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          inputFormatters: [],
                                          onChanged: (value) {
                                            cell_textEditingController_UI.text = value;
                                            setState(() {
                                              if (value == "")
                                                _cell_UI = null;
                                              else
                                                _cell_UI = value;
                                              if (cliente_UI != null) cliente_UI = null;
                                            });
                                          }))
                                ])
                              : Container(),
                          isActive_input_EMAIL
                              ? Row(children: [
                                  Expanded(
                                      child: XTextFormField(
                                          controller: email_textEditingController_UI,
                                          borderWidth: 2,
                                          height: null,
                                          colorBorder: Colors.grey[900],
                                          border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                          hintText: "email...",
                                          keyboardType: TextInputType.emailAddress,
                                          labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                          hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          inputFormatters: [],
                                          onChanged: (value) {
                                            email_textEditingController_UI.text = value;
                                            setState(() {
                                              if (value == "")
                                                _email_UI = null;
                                              else
                                                _email_UI = value;
                                              if (cliente_UI != null) cliente_UI = null;
                                            });
                                          }))
                                ])
                              : Container(),
                          SizedBox(height: 20),
                          Row(children: [
                            onAddObj_FromCliRubrica != null
                                ? Expanded(
                                    child: loadingRubrica
                                        ? Container(child: XStatefulWidgetBase.LoaderIndicator(loadingRubrica, fixHeight: 40, fixWidth: 40, label: "Caricamento"))
                                        : XBtnbase(
                                            backGroundColor: Colors.grey[800],
                                            toolTip_Message: "Inserisci un nuovo Cliente dalla Rubrica",
                                            label: "Da Rubrica",
                                            label_Color: Colors.blue,
                                            onPressed: () async {
                                              cli_rubrica = true;
                                              setState(() => loadingRubrica = true);
                                              xclContact = await xCMD_AddFromRubrica(liContatti);
                                              setState(() => loadingRubrica = false);
                                              if (xclContact != null) {
                                                setState(() {
                                                  if (xclContact!.phones != null && xclContact!.phones!.isNotEmpty) {
                                                    _alias_UI = (xclContact!.givenName ?? "") + " " + (xclContact!.familyName ?? "");
                                                    _cell_UI = xclContact!.phones!.first.value ?? "";
                                                    _email_UI = "";
                                                  }
                                                });
                                              }
                                              Navigator.pop(context, true);
                                            }))
                                : Container(),
                            (onAddObj_FromCliRubrica != null && onAddObj_FromCliExist != null) ? SizedBox(width: 10) : Container(),
                            onAddObj_FromCliExist != null
                                ? Expanded(
                                    child: XBtnbase(
                                        backGroundColor: Colors.grey[800],
                                        toolTip_Message: "Usa un Cliente gia esistente",
                                        label: "Da Esistente",
                                        label_Color: Colors.green,
                                        onPressed: () {
                                          cliente_UI = null;
                                          cli_exist = true;
                                          Navigator.pop(context, true);
                                        }))
                                : Container(),
                          ])
                        ])))));
          });
        });
    if (res != null && res) {
      if (cli_exist) {
        var res = await cmd_AddCliFromExist(liCliente);
        if (res != null) {
          await onAddObj_FromCliExist!(newObj, res);
        } else {
          return xCMD_AddNew_FromCliente(newObj, liContatti, liCliente);
        }
      } else if (cli_rubrica) {
        if (xclContact != null) await onAddObj_FromCliRubrica!(newObj, _alias_UI ?? "", _nome_UI ?? "", _cognome_UI ?? "", _cell_UI ?? "", _email_UI ?? "", _nomeReferente_UI ?? "");
      } else {
        if (_alias_UI != "") await onAddObj_FromCliInput!(newObj, _alias_UI ?? "", _nome_UI ?? "", _cognome_UI ?? "", _cell_UI ?? "", _email_UI ?? "", _nomeReferente_UI ?? "");
      }
      await onSaveAfter_Cliente!(newObj);
    }
  }

  Future<dynamic> cmd_AddCliFromExist(List<dynamic> liCliente) async {
    dynamic xclCliente;
    var x = await showDialog<dynamic>(
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return XAlertDialog(
                title_Text: "Scegli il Cliente tra quelli esistenti:",
                height: null,
                content_VerticalPadding: 30,
                child: XDropSearch<dynamic>(
                  dropDownMode: "Dialog",
                  al_Title: "",
                  al_BackGroundColor: Colors.grey[900],
                  itemSelected: xclCliente,
                  liItems: liCliente.where((element) => element.nome!.isNotEmpty || element.cognome!.isNotEmpty).toList(),
                  label: "",
                  itemAsString: (p0) => (p0.nome ?? "") + " " + (p0.cognome ?? ""),
                  onChanged_ItemOfDD: (cli) => setState(() => xclCliente = cli),
                ),
                actionsBTNarea_Child: Row(children: [
                  Expanded(
                      child: XBtnbase(
                    label: "Annulla",
                    onPressed: () => Navigator.pop(context, null),
                    label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.undo),
                  )),
                  xclCliente != null
                      ? Expanded(
                          child: XBtnbase(
                          label: "Avanti",
                          onPressed: () => Navigator.pop(context, xclCliente),
                          label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.done),
                        ))
                      : Container()
                ]));
          });
        });
    if (x != null && xclCliente != null) {
      return xclCliente;
    } else {
      return null;
    }
  }

  ///Evento da chiamare per ottenre un XMediaItem (API)
  Future<XMediaItem?> xOnGetXMedia(XMediaItem item) async {
    return item;
  }

  ///Evento che gestisce il salvataggio di un media e la generazione della sua Thumbnail
  Future xOnTakeXMedia_handling(Uint8List file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem, int mediatype) async {
    setState(() => isBusy = false);
    var bytesForPayLoad = await file;
    var t = XMediaItem(Uuid().v4(), xDocID: xfDataItem.id, mediaType: mediatype, payload: bytesForPayLoad, isNew: true);
    var x = await xOnBefore_TakeXMedia(t, xfDataItem);
    var xclMedia = x;
    // per ora non lo mettiamo visto che sendDataBack lo prende dal loaclPATH e lo mette lui lì
    // payload: await file.readAsBytes(),
    final xFile = File("${XLibStorage.filePath}/XMEDIAs/${xclMedia.id}_.${extForMediaType(xclMedia.mediaType!)}"); // _ è il marker per DONE !
    await xFile.create(recursive: true).then((value) async => await xFile.writeAsBytes(bytesForPayLoad)).whenComplete(() async {
      if (mediatype == XEnums.mediaType.video.value)
        xclMedia.miniatura = await xCreateThumbnail_FromVideo(xFile.path);
      else if (mediatype == XEnums.mediaType.image.value) {
        var image = img.decodeJpg(xclMedia.payload!)!;
        if (image.width > image.height) xclMedia.payload = await _rotateImageFromBytes(xclMedia.payload!);
        xclMedia.miniatura = await xCreateThumbnails_fromImage(bytesForPayLoad);
      }
    });

    xclMedia.localURI = xFile.path;
    xclMedia.xDocType = xfDataItem.X_docXObjectName;
    setState(() => liMediaRAW.add(xclMedia));
  }

  ///Evento che gestisce il salvataggio degli XMedia (OVERRIDABLE)
  Future<bool?>? xOnSaveXMedia(List<XMediaItem> liXMedia, XFDataItem item) async {
    return true;
  }

  ///Evento che gestisce il salvataggio degli XMedia (INTERNAL)
  Future<bool?>? xOnSaveXMedia_INTERNAL(List<XMediaItem> liXMedia, XFDataItem item) async {
    return await xOnSaveXMedia(liXMedia, item);
  }

  ///Evento che gestisce la cancellazione di un XMedia all'interno delXMediaRecorder quando stai acquisendo i Media
  Future<bool?>? xOnDelXMedia_InPreview(XMediaItem xMedia, void Function(void Function()) setState) async {
    var res = await showDialog<bool?>(
        context: context,
        builder: (context) {
          return XAlertDialog(
            title_Text: "Sicuro di voler cancellare il Media ${xMedia.blobURL}?",
            title_Style: XStyles.xStyTextForSubLabel(textColor: XColors.warning),
            btnNO_label: "Annulla",
            btnYES_label: "Si",
            btnNO_OnPressed: () => Navigator.pop(context, false),
            btnYES_OnPressed: () => Navigator.pop(context, true),
          );
        });
    if (res != null && res) {
      setState(() => liXMedias_MediaRecorder.value.remove(xMedia));
      return res;
    } else
      return false;
  }

  ///Evento che gestisce la Cancellazione degli XMedia (INTERNAL)
  Future<bool?>? xOnDelXMedia_INTERNAL(XMediaItem xMedia, XFDataItem item) async {
    var res = await showDialog<bool?>(
        context: context,
        builder: (context) {
          return XAlertDialog(
            title_Text: "Sicuro di voler cancellare il Media ${xMedia.blobURL}?",
            title_Style: XStyles.xStyTextForSubLabel(textColor: XColors.warning),
            btnNO_label: "Annulla",
            btnYES_label: "Si",
            btnNO_OnPressed: () => Navigator.pop(context, false),
            btnYES_OnPressed: () => Navigator.pop(context, true),
          );
        });
    if (res != null && res) {
      late Directory direct;
      direct = Directory("${XLibStorage.filePath}/XMEDIAS/");
      direct.listSync().removeWhere((element) => element.path.contains(xMedia.id));
      setState(() => liMediaRAW.remove(xMedia));
      res = await xOnDelXMedia(xMedia)!;
      item is K ? widget.rootItemEdited!(item) : widget.itemEdited!(item);
      return res;
    } else
      return false;
  }

  ///Evento da overridare per aggiungere codice POST cancellazione dell'XMedia
  Future<bool?>? xOnDelXMedia(XMediaItem xMedia) async {
    return true;
  }

  ///Evento da overridare per aggiungere codice prima dell'acquisizione di un XMedia
  Future<XMediaItem> xOnBefore_TakeXMedia(XMediaItem xclMedia, XFDataItem idParent) async {
    return xclMedia;
  }

  ///Evento da overridare per aggiungere codice dopo l'Edit di un XMedia
  Future<Uint8List?>? xOnAfterXMedia_EditPhoto(XMediaItem xMedia) async {
    return null;
  }

  bool xMedia_Empty(XFDataItem item) {
    return xMediaListOfMine(item).isEmpty;
  }

  ///Metodo di caricamento degli XMediaItem
  Future xLoadMedia(dynamic xMedia) async {
    xMedia as XMediaItem;
    if (xMedia.payload != null) {
    } else if (xMedia.payload == null && xMedia.localURI != "") {
      File(xMedia.localURI!).readAsBytes().then((value) => xMedia.payload = value);
    } else if (xMedia.payload == null && xMedia.localURI == "") {
      await xOnGetXMedia(xMedia).then((x) {
        if (x != null) {
          xMedia.payload = x.payload;
          xMedia.overlaySurface = x.overlaySurface;
        }
      });
    }
  }

  ///Metodo per sapere se gli XMedia sono miei o di altri
  List<XMediaItem> xMediaListOfMine(XFDataItem item) {
    return liMediaRAW.where((element) => element.xDocID == item.id).toList();
  }

  ///Metodo per la creazione di una miniatura da un Video
  Future<Uint8List?> xCreateThumbnail_FromVideo(String blobURL) async {
    var x = await thumb.VideoThumbnail.thumbnailData(
      video: blobURL,
      imageFormat: thumb.ImageFormat.PNG,
      maxWidth: 128, // specify the width of the thumbnail, let the height auto-scaled to keep the source aspect ratio
      quality: 25,
    );
    return x;
  }

  ///Metodo per la creazione di una miniatura da una Foto
  Uint8List xCreateThumbnails_fromImage(Uint8List image_payload, {int width = 80, int height = 100}) {
    final imgOri = img.decodeJpg(image_payload)!;
    var resizedImg = img.copyResize(imgOri, width: width, height: height);
    final pngBytes = img.encodePng(resizedImg);
    return pngBytes;
  }

  Uint8List xCreateWhiteImage_SizeOfScreen() {
    var mqSize = MediaQuery.of(context).size;
    return xCreateWhiteImage(mqSize.width.toInt(), mqSize.height.toInt());
  }

  Uint8List xCreateWhiteImage(int width, int height) {
    List<int> pixels = List.filled(width * height * 3, 255);
    Uint8List image = Uint8List.fromList(pixels);
    img.Image imgData = img.Image.fromBytes(width: width, height: height, bytes: image.buffer);
    Uint8List encodedImage = img.encodeJpg(imgData);
    return encodedImage;
  }

//
//
//
//XEditDialog / xPreview_Dialog  Method
//XEditDialog / xPreview_Dialog  Method
//XEditDialog / xPreview_Dialog  Method
//
//
//

  ///Preview con i vari DataEntry per l'aggiunta o modifica o visualizzazione di un Item che non ha scheda
  Future<XFDataItem?> xPreview_Dialog(XView xView, dynamic value) async {
    dynamic valueUI = value.getCloneFull();
    var liCols = xView.cols!.where((element) => element.colKey.startsWith("li").not() && element.readOnly == false);
    return await showDialog<XFDataItem>(
        context: context,
        barrierColor: Colors.black.withAlpha(230),
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return Container(
                width: MediaQuery.of(context).size.width - 20,
                alignment: Alignment.center,
                child: SingleChildScrollView(
                    child: XAlertDialog(
                        actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
                        content_insetPadding: EdgeInsets.all(3),
                        content_VerticalPadding: 5,
                        width: MediaQuery.of(context).size.width - 20,
                        colorBackGround: XSchedaState.color_BackGround_EditDialog,
                        actionsBTNarea_Child: Container(
                            padding: EdgeInsets.only(bottom: 10),
                            child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                              XBtnbase(
                                width: 120,
                                label: "Annulla",
                                label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.red),
                                backGroundColor: Colors.red.withAlpha(60),
                                onPressed: () => Navigator.pop(context, null),
                              ),
                              SizedBox(width: 10),
                              XBtnbase(
                                width: 120,
                                label: "Conferma",
                                label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.green),
                                backGroundColor: Colors.green.withAlpha(60),
                                onPressed: () {
                                  xView.cols!.forEach((e) {
                                    if (valueUI[e.colKey] != null) setState(() => value[e.colKey] = valueUI[e.colKey]);
                                  });
                                  return Navigator.pop(context, valueUI);
                                },
                              ),
                            ])),
                        child: Column(
                          crossAxisAlignment: CrossAxisAlignment.start,
                          mainAxisSize: MainAxisSize.min,
                          children: liCols.length == 1
                              ? [Container(width: 500, margin: EdgeInsets.symmetric(vertical: 5, horizontal: 10), child: xLayout_CellWidget_Editable(liCols.first, valueUI, context, valueUI, parentSetState: setState, onBeforeCMD_Active: false, autoFocus: true))]
                              : liCols.map((e) {
                                  return Container(margin: EdgeInsets.symmetric(vertical: 5, horizontal: 10), child: xLayout_CellWidget_Editable(e, valueUI, context, valueUI, parentSetState: setState, onBeforeCMD_Active: false));
                                }).toList(),
                        ))));
          });
        });
  }

  ///EditDialog per la modifica di un singolo campo
  Future<dynamic> xEditDialog(XFDataItem item, String title, dynamic value, XCol xCol, {List<ScontiBTN>? liSconti}) async {
    FocusScope.of(context).unfocus();
    TextEditingController textController = TextEditingController(text: item[xCol.colKey].runtimeType != DateTime ? item[xCol.colKey].toString() : XUtils.dateToString(item[xCol.colKey], format: "dd/MM/yyyy", noDateLabel: ""));
    var res = await showDialog<dynamic>(
        context: context,
        barrierDismissible: false,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return Container(
                width: MediaQuery.of(context).size.width - 10,
                alignment: Alignment.center,
                child: SingleChildScrollView(
                    child: XAlertDialog(
                        colorBackGround: XSchedaState.color_BackGround_EditDialog,
                        actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
                        content_insetPadding: EdgeInsets.all(2),
                        height: null,
                        title_Text: title,
                        title_Style: XStyles.xStyTextForLabel(textColor: Colors.blue),
                        btnYES_label: "OK",
                        btnNO_label: "Annulla",
                        btnNO_OnPressed: () => Navigator.pop(context, null),
                        btnYES_OnPressed: () {
                          if (value != textController.text) {}
                          if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
                            value = textController.text;
                          } else if (xCol.dataType == DateTime) {
                            value = DateTime.parse(textController.text);
                          } else if (xCol.dataType == double) {
                            value = double.parse(textController.text);
                          } else if (xCol.dataType == int) {
                            value = int.parse(textController.text);
                          }

                          // lo fa già xOnXCell_Edit_SubmitValue
                          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
                          Navigator.pop(context, value);
                        },
                        child: xEditDialog_Override_Editor(xCol.colCaption, value, xCol, textController, item: item) != null
                            ? xEditDialog_Override_Editor(xCol.colCaption, value, xCol, textController, item: item)
                            : (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != DateTime && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                ? Container()
                                : Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
                                    SizedBox(height: 10),
                                    (xCol.dataType == String && xCol.colKey.startsWith("li").not() && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                        ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                            Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController)),
                                            SizedBox(width: 10),
                                            xEditDialog_Builder_BTNs(item, textController, "C", false, setState),
                                          ])
                                        : xCol.dataType == String && xCol.colKey.startsWith("li").not()
                                            ? Column(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                Row(children: [Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController))]),
                                                SizedBox(height: 10),
                                                Row(mainAxisAlignment: MainAxisAlignment.end, children: [
                                                  XBtnbase(
                                                      width: 60,
                                                      label: "Copia \nTutto",
                                                      label_TextAlign: TextAlign.center,
                                                      label_Color: Colors.white,
                                                      padding: EdgeInsets.all(0),
                                                      backGroundColor: Colors.grey[700],
                                                      onPressed: () {
                                                        Clipboard.setData(ClipboardData(text: textController.text));
                                                        ScaffoldMessenger.of(context).showSnackBar(
                                                          SnackBar(content: Text('Testo copiato negli appunti')),
                                                        );
                                                      }),
                                                  SizedBox(width: 20),
                                                  xEditDialog_Builder_BTNs(item, textController, "C", false, setState),
                                                ])
                                              ])
                                            : xCol.dataType == DateTime
                                                ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController))])
                                                : Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                    Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController)),
                                                    SizedBox(width: 10),
                                                    xEditDialog_Builder_BTNs(item, textController, "C", false, setState),
                                                  ]),
                                    SizedBox(height: 10),
                                    ((xCol.dataType == String).not() && xCol.dataType != DateTime)
                                        ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                            Expanded(
                                                child: Wrap(alignment: WrapAlignment.end, spacing: 8, runSpacing: 8, children: [
                                              xEditDialog_Builder_BTNs(item, textController, "+20", false, setState, xCol: xCol),
                                              xEditDialog_Builder_BTNs(item, textController, "+10", false, setState, xCol: xCol),
                                              xEditDialog_Builder_BTNs(item, textController, "+5", false, setState, xCol: xCol),
                                              xEditDialog_Builder_BTNs(item, textController, "+3", false, setState, xCol: xCol),
                                              xCol.dataType == String && xCol.colKey.startsWith("li").not() ? Container() : xEditDialog_Builder_BTNs(item, textController, "+1", false, setState, xCol: xCol),
                                            ]))
                                          ])
                                        : Container()
                                  ]))));
          });
        });
    return res;
  }

  ///EditDialog per l'Aggiunta di un nuovo Items che fa un aggiunta a sequenza per ogni colonna della Vista
  Future<XFDataItem?> xEditDialog_xOnAddItem(XView xView, XFDataItem item, void Function(void Function()) setState, {List<ScontiBTN>? liSconti}) async {
    bool isFirst = false;
    int u = 0;
    XFDataItem? rval = null;
    if (xView.cols!.where((e) => e.dataType != bool || e.readOnly != true || e.colKey.startsWith("li").not()).length == 1) {
      isFirst = false;
    } else {
      for (var i in xView.cols!) {
        if (i.dataType == bool || i.readOnly == true || i.colKey.startsWith("li")) continue;
        u++;
        var x = await xEditDialog(item, i.colCaption, item[i.colKey], i, liSconti: liSconti);
        if (x == null) {
          if (u == 1) isFirst = true;
          break;
        } else
          item[i.colKey] = x;
      }
    }

    if (!isFirst) {
      rval = await xPreview_Dialog(xView, item);
      if (rval == null) return null;
    }

    return rval;
  }

  ///CellBuilder dellxEntry
  Container xEditDialog_CellBuilder(XFDataItem item, XCol xCol, BuildContext context, void Function(void Function()) setState, TextEditingController controller, {TextInputType? keyboardType, bool autoFocus = true, bool label_Visible = false, List<TextInputFormatter>? inputFormatters}) {
    Widget _widgetForCell = Container();
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _widgetForCell = xLayout_TextFormField_Builder(
        height: null,
        context: context,
        xCol: xCol,
        autoFocus: autoFocus,
        controller: controller,
        label_Visible: label_Visible,
        multiLines: xCol.multilines,
        maxLines: xCol.multilines ? 4 : 1,
        inputFormatters: inputFormatters,
        editable: xCol.readOnly,
        keyboardType: keyboardType,
        borderColor: xCellEditable_borderColor,
        borderColor_Disabled: xCellEditable_borderColor_Disabled,
        labelColor_Disabled: xCellEditable_labelColor_Disabled,
        onSubmitted: (p0) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, p0),
        onBefore_Edit: () {},
        onChanged: (value) => item[xCol.colKey] = value,
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      DateTime? dt;
      if (controller.text != "") dt = DateTime.parse(controller.text);
      _widgetForCell = xLayout_DateFormField_Builder(
          xCol: xCol,
          onBefore_Edit: () {},
          value: dt == DateTime(1900, 01, 01) ? null : dt,
          onDateSelected: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      _widgetForCell = xLayout_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          label_Visible: label_Visible,
          maxLines: 1,
          borderColor: xCellEditable_borderColor,
          borderColor_Disabled: xCellEditable_borderColor_Disabled,
          labelColor_Disabled: xCellEditable_labelColor_Disabled,
          autoFocus: true,
          onBefore_Edit: () {},
          keyboardType: TextInputType.number,
          controller: controller,
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value)),
          onChanged: (value) {
            if (value != "")
              xOnXCell_Edit_OnChanged(item, xCol, double.parse(value));
            else
              xOnXCell_Edit_OnChanged(item, xCol, 0.0);
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xLayout_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        label_Visible: label_Visible,
        autoFocus: true,
        xCol: xCol,
        borderColor: xCellEditable_borderColor,
        borderColor_Disabled: xCellEditable_borderColor_Disabled,
        labelColor_Disabled: xCellEditable_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {},
        onSubmitted: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value),
        controller: controller,
        // value: controller.text == "0.0" ? "" : controller.text,
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "")
            xOnXCell_Edit_OnChanged(item, xCol, int.parse(value));
          else
            xOnXCell_Edit_OnChanged(item, xCol, 0);
        },
      );
    } else
      return Container(width: 0, height: 0);

    return Container(child: StatefulBuilder(builder: (context, setState) {
      return _widgetForCell;
    }));
    //}
  }

  ///Da overridare per sovrascrivere il Widget all'interno dell'EdiDialog
  Widget? xEditDialog_Override_Editor(String title, dynamic value, XCol<dynamic> xCol, TextEditingController controller, {dynamic item}) {
    return null;
  }

  ///Builder dei bottoni cher verranno visualizzati nell'XEditDialog
  XBtnbase xEditDialog_Builder_BTNs(XFDataItem item, TextEditingController controller, String valueAndLabel, bool isSconto, void Function(void Function()) parentSetState, {XCol? xCol}) {
    return XBtnbase(
        padding: EdgeInsets.all(1),
        width: 45 * XUtils.kforScale,
        label_Style: XStyles.xStyTextForSubLabel(
            textColor: valueAndLabel.contains("+")
                ? Colors.green
                : valueAndLabel.contains("-") || valueAndLabel == ("C")
                    ? Colors.red
                    : Colors.green),
        label: valueAndLabel,
        backGroundColor: Colors.grey[700],
        onPressed: () {
          if (valueAndLabel == "C") {
            controller.text = "";
            FocusScope.of(context).unfocus();
          }
        });
  }

//
//
//
//xLayout overridable Method
//xLayout overridable Method
//xLayout overridable Method
//
//
//

  ///Override per cambiare la build del singolo Filtro a DropDown
  xLayout_xFilter_Builder_SingleXDropDown(XFilterEl<dynamic> xFilter) {
    return StatefulBuilder(builder: (context, state) {
      return Container(
          width: ((xFilter.width ?? 200) * widget.xApp!.KforScale) < 170 ? 170 : (xFilter.width ?? 200) * widget.xApp!.KforScale,
          child: XfxDropDown<dynamic>(xFilter.ColsOfXFdataItemToShow,
              label: "",
              menu_SearchBoxBorderANDtitle_Color: ThemeData.estimateBrightnessForColor(xFilter.backgroundMenuColor ?? xFilter.xPropOfItemToFilter.col_Color) == Brightness.dark ? XColors.foregroundLight : XColors.foregroundDark,
              menu_height: xFilter.menu_height,
              background_Color: (value) => xFilter.backgroundMenuColor ?? xFilter.xPropOfItemToFilter.col_Color,
              liItems: xFilter.Items,
              itemSelected: xFilter.Value,
              label_Behavior: FloatingLabelBehavior.auto,
              item_TextStyle: (p0) => xFilter.textStyle != null
                  ? xFilter.textStyle!(p0) //
                  : xFilter.Value is XEnumDef
                      ? XStyles.xStyTextForTitle(textColor: ThemeData.estimateBrightnessForColor((xFilter.Value as XEnumDef).backColor) == Brightness.dark ? XColors.foregroundLight : XColors.foregroundDark)
                      : XStyles.xStyTextForTitle(textColor: XColors.foregroundLight),
              item_LabelStyle: (p0) => xFilter.textStyle != null ? xFilter.textStyle!(p0) : XStyles.xStyTextForTitle(textColor: p0),
              clearBTN_Active: xFilter.All != null && xFilter.Value != xFilter.All,
              onChanged_ItemOfDD: (value) => setState(() => state(() => xFilter.Value = value == null ? xFilter.All : value))));
    });
  }

  ///Override per cambiare la build del Menu per i Multi-Filtro a DropDown
  DropdownMenuItem xLayout_xFilter_Builder_XFilterEl(XFilterEl<dynamic> xf) {
    return DropdownMenuItem(
        value: xf,
        child: Row(children: [
          Container(
              width: ((xf.width ?? 200) * widget.xApp!.KforScale) < 170 ? 170 : (xf.width ?? 200) * widget.xApp!.KforScale,
              child: XfxDropDown<dynamic>(xf.ColsOfXFdataItemToShow,
                  label: "",
                  liItems: xf.Items,
                  itemSelected: xf.Value,
                  menu_SearchBoxBorderANDtitle_Color: ThemeData.estimateBrightnessForColor(xf.backgroundMenuColor ?? xf.xPropOfItemToFilter.col_Color) == Brightness.dark ? XColors.foregroundLight : XColors.foregroundDark,
                  menu_height: xf.menu_height,
                  background_Color: (value) => xf.backgroundMenuColor ?? xf.xPropOfItemToFilter.col_Color,
                  item_TextStyle: (p0) => xf.textStyle != null
                      ? xf.textStyle!(p0) //
                      : xf.Value is XEnumDef
                          ? XStyles.xStyTextForTitle(textColor: ThemeData.estimateBrightnessForColor((xf.Value as XEnumDef).backColor) == Brightness.dark ? XColors.foregroundLight : XColors.foregroundDark)
                          : XStyles.xStyTextForTitle(textColor: XColors.foregroundLight),
                  item_LabelStyle: (p0) => xf.textStyle != null ? xf.textStyle!(p0) : XStyles.xStyTextForLabel(textColor: p0),
                  label_Behavior: FloatingLabelBehavior.auto,
                  clearBTN_Active: xf.All != null,
                  clearBTN_getValueForCLEAR: () => xf.All,
                  onChanged_ItemOfDD: (value) => setState(() => xf.Value = value == null ? xf.All : value)))
        ]));
  }

  ///Override per aggiungere dei Widgets a SINISTRA di ogni singolo Items
  List<Widget>? xLayout_WidgetsLeftArea_Item(K item, void Function(void Function()) parentSetState) {
    return widget.liWidgets_LeftArea_Item != null ? widget.liWidgets_LeftArea_Item!(item)! : null;
  }

  ///Override per aggiungere dei Widgets a DESTRA di ogni singolo Items
  List<Widget>? xLayout_WidgetsRightArea_Item(K item, void Function(void Function()) parentSetState) {
    return widget.liWidgets_LeftArea_Item != null ? widget.liWidgets_LeftArea_Item!(item)! : null;
  }

  ///Override per modificare il comportamento degli "Items di Dettaglio" degli "Items Main" dell'Elenco
  Widget? xLayout_DettItemWidget(dynamic item) {
    if (widget.xDettItem_Widget != null)
      return widget.xDettItem_Widget!(item);
    else
      return null;
  }

  ///Widget TextFormField Editor Generico
  Widget xLayout_TextFormField_Builder<T>({
    required BuildContext context,
    required XCol xCol,
    Function(String)? onChanged,
    Function(String)? onSubmitted,
    String? hintText,
    List<TextInputFormatter>? inputFormatters,
    TextInputType? keyboardType,
    bool editable = true,
    bool label_Visible = true,
    bool autoFocus = false,
    String? value,
    bool? selectText,
    bool? multiLines,
    double? height,
    int? maxLines,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Color? backgorundColor,
    Color? backgorundColor_Disabled,
    TextEditingController? controller,
    Function()? onBefore_Edit,
  }) {
    OutlineInputBorder outLineBorder = OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (xCellEditable_borderColor_Visible ? (xCol.xmodelXprop.col_Color == Colors.black ? (borderColor ?? Colors.grey[400]!) : xCol.xmodelXprop.col_Color) : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[400]!), width: 1));
    UnderlineInputBorder underLineBorder = UnderlineInputBorder(borderSide: BorderSide(color: editable.not() ? (xCellEditable_borderColor_Visible ? (xCol.xmodelXprop.col_Color == Colors.black ? (borderColor ?? Colors.grey[400]!) : xCol.xmodelXprop.col_Color) : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[400]!), width: 1));
    return XTextFormField(
      controller: value != null ? null : controller,
      border: widget.isEditable && onBefore_Edit == null ? underLineBorder : outLineBorder,
      disabledBorder: widget.isEditable && onBefore_Edit == null ? underLineBorder : outLineBorder,
      enabledBorder: widget.isEditable && onBefore_Edit == null ? underLineBorder : outLineBorder,
      focusedBorder: widget.isEditable && onBefore_Edit == null ? underLineBorder : outLineBorder,
      label: label_Visible ? xCol.colCaption + (editable ? "🔒" : "") : "",
      onChanged: onChanged,
      floatingLabelBehaviorActive: widget.isEditable ? FloatingLabelBehavior.always : FloatingLabelBehavior.auto,
      onEditingComplete: () => onSubmitted == null ? null : onSubmitted(value!),
      onFieldSubmitted: (value) => onSubmitted == null ? null : onSubmitted(value!),
      autoFocus: autoFocus,
      onTap: () {
        if (controller != null) {
          if (xCol.dataType == String)
            null;
          else
            controller.selection = TextSelection(baseOffset: 0, extentOffset: controller.text.length);
        }
        if (onBefore_Edit != null) {
          onBefore_Edit();
        }
      },
      initialValue: controller != null ? null : value,
      // borderVisible: editable.not(),
      maxLines: maxLines,
      isCollapsed: false,
      enabled: editable.not(),
      height: null,
      fillColor: editable ? Colors.transparent : XSchedaState.color_CellBackGorundDisabled,
      filled: XSchedaState.color_CellBackGorundDisabled != null ? true : false,
      multiLines: (xCol.colCaption.toLowerCase().contains("email") || (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")) || xCol.colCaption.toLowerCase().contains("inidrizzo") || xCol.colCaption.toLowerCase().contains("ind"))
          ? false
          : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
              ? false
              : multiLines ?? false,
      contentPadding: EdgeInsets.only(top: 7, left: 5, bottom: 7),
      textStyle: XStyles.xStyleText(colorText: XSchedaState.color_Text),
      textAlign: xCol.dataType is int || xCol.dataType is double ? TextAlign.end : TextAlign.start,
      labelStyle: XStyles.xStyTextForLabel(textColor: xCol.xmodelXprop.col_Color == Colors.black ? XColors.foregroundLight : xCol.xmodelXprop.col_Color), //XSchedaState.colorOfHintText
      keyboardType: keyboardType ??
          ((xCol.colCaption.toLowerCase().contains("email"))
              ? TextInputType.emailAddress
              : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
                  ? TextInputType.phone
                  : (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto"))
                      ? TextInputType.number
                      : TextInputType.text),
      textCapitalization: (xCol.dataType == String && xCol.colKey.startsWith("li").not())
          ? TextCapitalization.sentences //
          : TextCapitalization.none,
      hintText: editable ? "..." : (hintText ?? "..."),
      hintStyle: XStyles.xStyTextForSubDescr(textColor: XSchedaState.color_HintText),
      inputFormatters: inputFormatters ?? [],
    );
  }

  ///Widget per il Text Generico
  Widget xLayout_Text_Builder<T>({required BuildContext context, required XCol xCol, required String value, List<TextInputFormatter>? inputFormatters, double? height}) {
    return XTextWithLabel(
      label: xCol.colCaption,
      text: xCol.format == "C" ? XUtils.xFormatToCurrency(context, double.parse(value)) : value,
      text_Style: XStyles.xStyTextForDescr(textColor: Colors.white),
      label_Style: XStyles.xStyTextForLabel(textColor: XSchedaState.color_HintText),
    );
  }

  ///Widget DateTime Editor Generico
  Widget xLayout_DateFormField_Builder({
    required XCol xCol,
    required Function(DateTime)? onDateSelected,
    bool editable = true,
    DateTime? value,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Function()? onBefore_Edit,
    TextEditingController? controller,
    String? format,
  }) {
    OutlineInputBorder outLineBorder = OutlineInputBorder(borderSide: BorderSide(color: xCol.readOnly.not() ? (xCellEditable_borderColor_Visible ? xCol.xmodelXprop.col_Color : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[800]!), width: 1));
    UnderlineInputBorder underLineBorder = UnderlineInputBorder(borderSide: BorderSide(color: xCol.readOnly.not() ? (xCellEditable_borderColor_Visible ? xCol.xmodelXprop.col_Color : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[800]!), width: 1));
    return DateTimeFormField(
      decoration: InputDecoration(
        contentPadding: EdgeInsets.only(right: 2, top: 2, bottom: 2, left: 4),
        hintStyle: XStyles.xStyleText(fontSize: 15, colorText: XSchedaState.color_HintText),
        errorStyle: TextStyle(color: Colors.redAccent),
        border: widget.isEditable && onBefore_Edit == null ? underLineBorder : outLineBorder,
        disabledBorder: widget.isEditable && onBefore_Edit == null ? underLineBorder : outLineBorder,
        enabledBorder: widget.isEditable && onBefore_Edit == null ? underLineBorder : outLineBorder,
        focusedBorder: widget.isEditable && onBefore_Edit == null ? underLineBorder : outLineBorder,
        labelText: xCol.colCaption,
        constraints: BoxConstraints(maxHeight: 40),
        floatingLabelBehavior: widget.isEditable ? FloatingLabelBehavior.always : FloatingLabelBehavior.auto,
        labelStyle: value != null
            ? XStyles.xStyTextForLabel(textColor: xCol.readOnly ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[800]!) : (borderColor ?? Colors.grey[600]!)) //
            : XStyles.xStyTextForLabel(textColor: editable.not() ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[800]!) : (xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight)),
      ),
      onChanged: (value) => onDateSelected!(value!),
      onTap: xCol.readOnly.not() ? null : () {},
      initialValue: value,
      dateFormat: DateFormat(format ?? "dd/MM/yy"),
      style: XStyles.xStyleText(fontSize: 15, colorText: Colors.white),
      materialDatePickerOptions: MaterialDatePickerOptions(
        initialEntryMode: DatePickerEntryMode.calendar,
        initialDatePickerMode: DatePickerMode.day,
      ),
      mode: DateTimeFieldPickerMode.date,
      autovalidateMode: AutovalidateMode.onUserInteraction,
      validator: (e) => (e?.day ?? 0) == 1 ? 'Perfavore sistema la data' : null,
    );
  }

  ///Override per cambiare l'editor della Cella Editabile dell'Items
  Container xLayout_CellWidget_Editable(XCol xCol, dynamic item, BuildContext context, dynamic itemToSet, {void Function(void Function())? parentSetState, double? fixWidth, bool onBeforeCMD_Active = true, bool autoFocus = false, TextEditingController? controller}) {
    late Widget _widgetForCell;
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != bool) {
      _widgetForCell = FocusScope(
          onKeyEvent: (node, event) {
            if (event is KeyDownEvent && event.logicalKey.keyLabel == LogicalKeyboardKey.tab.keyLabel) {
              print("Tab premuto");
              widget.rootItemEdited!(item as K);
              FocusScope.of(context).nextFocus();
              return KeyEventResult.handled; // Indica che l'evento è stato gestito
            } else {
              return KeyEventResult.skipRemainingHandlers; // Indica che l'evento non è stato gestito
            }
          },
          child: xLayout_TextFormField_Builder(
            height: null,
            context: context,
            controller: controller,
            xCol: xCol,
            autoFocus: autoFocus,
            multiLines: (fixWidth ?? xCol.width) >= 200 ? true : false,
            editable: xCol.readOnly,
            labelColor_Disabled: xCellEditable_labelColor_Disabled,
            borderColor: xCellEditable_borderColor,
            borderColor_Disabled: xCellEditable_borderColor_Disabled,
            onSubmitted: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value),
            value: item[xCol.colKey] ?? "",
            onChanged: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value),
            onBefore_Edit: null,
          ));
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _widgetForCell = xLayout_DateFormField_Builder(
        xCol: xCol,
        borderColor: xCellEditable_borderColor,
        borderColor_Disabled: xCellEditable_borderColor_Disabled,
        labelColor_Disabled: xCellEditable_labelColor_Disabled,
        format: xCellEditable_xFormat_Date,
        onBefore_Edit: null,
        // onBefore_Edit: () => xOnXCell_Before_Edit(xCol, item),
        value: item[xCol.colKey] == DateTime(1900, 01, 01) ? null : item[xCol.colKey],
        onDateSelected: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value),
      );
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      _widgetForCell = xLayout_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          autoFocus: autoFocus,
          xCol: xCol,
          controller: controller,
          maxLines: 1,
          borderColor: xCellEditable_borderColor,
          borderColor_Disabled: xCellEditable_borderColor_Disabled,
          labelColor_Disabled: xCellEditable_labelColor_Disabled,
          onBefore_Edit: null,
          // onBefore_Edit: () {
          //   if (onBeforeCMD_Active) xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
          // },
          keyboardType: TextInputType.number,
          value: (item[xCol.colKey] == null || item[xCol.colKey].toString() == "0.0") ? "" : XUtils.xFormatDouble(context, item[xCol.colKey]),
          inputFormatters: [FilteringTextInputFormatter.allow(RegExp(r'^\d+\.?\d{0,2}'))],
          onSubmitted: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value)),
          onChanged: (value) {
            if (value != "") {
              xOnXCell_Edit_OnChanged(item, xCol, double.parse(value));
            } else {
              xOnXCell_Edit_OnChanged(item, xCol, 0.0);
            }
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xLayout_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        controller: controller,
        autoFocus: autoFocus,
        xCol: xCol,
        borderColor: xCellEditable_borderColor,
        borderColor_Disabled: xCellEditable_borderColor_Disabled,
        labelColor_Disabled: xCellEditable_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: null,
        // onBefore_Edit: () {
        //   if (onBeforeCMD_Active) xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
        // },
        onSubmitted: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value),
        value: item[xCol.colKey].toString() == "0.0" ? "" : XUtils.xFormatInt(context, item[xCol.colKey]),
        inputFormatters: [FilteringTextInputFormatter.allow(RegExp(r'^\d+\.?\d{0,2}'))],
        onChanged: (value) {
          if (value != "") {
            xOnXCell_Edit_OnChanged(item, xCol, int.parse(value));
          } else {
            xOnXCell_Edit_OnChanged(item, xCol, 0);
          }
        },
      );
    } else if (xCol.dataType == bool) {
      _widgetForCell = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: false,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
            activeColor: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
            checkColor: XColors.foregroundDark,
            mainAxisAlignment_Label_HorizontalMode: MainAxisAlignment.start,
            value: (item[xCol.colKey] ?? false),
            onTap: () async {
              parentSetState != null
                  ? parentSetState(() {
                      item[xCol.colKey] = (item[xCol.colKey] as bool).not();
                      xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, item[xCol.colKey]);
                    })
                  : setState(() {
                      item[xCol.colKey] = (item[xCol.colKey] as bool).not();
                      xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, item[xCol.colKey]);
                    });
            },
            onChanged: (value) async {
              parentSetState != null
                  ? parentSetState(() {
                      xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
                      item[xCol.colKey] = value;
                    })
                  : setState(() {
                      xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
                      item[xCol.colKey] = value;
                    });
            }),
      );
    } else {
      //DEVE essere W e H = 0 se no il Wrap fa casino nel gestirlo e va a "un po' a capo" dopo l'ultimo Widget
      return Container(width: 0, height: 0);
    }
    return Container(
      width: fixWidth ?? xCol.width,
      margin: EdgeInsets.only(
        bottom: widget.isEditable ? 5 : 0,
        left: widget.isEditable ? 2 : 0,
        right: widget.isEditable ? 2 : 0,
      ),
      padding: xCol.dataType == DateTime ? EdgeInsets.only(top: 1 * (XUtils.kforScale)) : null,
      child: _widgetForCell,
    );
  }

  ///Override per Aggiungere Widgets che si vedranno sopra gli Items dell'Elenco
  Widget? xLayout_WidgetOverItems(XFDataItem xItem) {
    return null;
  }

  ///Override per cambiare il Widget di ogni Items dell'Elenco, chiamato per ogni Items.
  Widget? xLayout_ItemWidget(K item) {
    List<XAction>? _xActionsLi_LEFT = List<XAction>.empty(growable: true);
    List<XAction>? _xActionsLi_RIGHT = List<XAction>.empty(growable: true);
    List<XAction>? _xActionsLi_FAST = List<XAction>.empty(growable: true);
    _xActionsLi_RIGHT.clear();
    late List<XFDataItem> liDettsUI;
    if (widget.xDetts_xColname != null) liDettsUI = item[widget.xDetts_xColname!];
    //Aggiungo alla lista delle XActionsRight quelle fisse a livello di xelenco
    if (xActionLi_RIGHT != null) _xActionsLi_RIGHT.addAll(xActionLi_RIGHT!.toList());
    if (xActions_RIGHT_ForItem(item) != null) {
      xActions_RIGHT_ForItem(item)!.forEach((xActionRight) {
        if (xActionRight != null) _xActionsLi_RIGHT.add(xActionRight);
      });
    }
    //Aggiungo alla lista delle XActionsLeft quelle fisse a livello di xelenco
    if (xActionLi_LEFT != null) _xActionsLi_LEFT.addAll(xActionLi_LEFT!.toList());
    //Aggiungo le altre XAction Left a livello di Item dell'elenco
    if (xActions_LEFT_ForItem(item) != null) {
      xActions_LEFT_ForItem(item)!.forEach((xActionLeft) {
        if (xActionLeft != null) {
          _xActionsLi_LEFT.add(xActionLeft);
        }
      });
    }

    var x = xActions_FAST_ForItem(item)!;
    x.forEach((xActionFast) {
      if (xActionFast != null) _xActionsLi_FAST.add(xActionFast);
    });
    return widget.schedaMode == true
        ? DragTarget<XFDataItem>(onWillAccept: (data) {
            var res = xOnDrop_BeforeAccept(data!, item);
            setState(() {
              if (res)
                item.isSel = true;
              else
                item.isSel = false;
            });
            return res;
          }, onAccept: (data) async {
            await xOnDrop_Accept(data, item);
            setState(() => item.isSel = false);
          }, onLeave: (data) {
            xOnDrop_Leave(data!);
            setState(() => item.isSel = false);
          }, builder: (context, candidateData, rejectedData) {
            return XElencoItem(setState, item, context, widget.view!,
                funct: widget.rootItemEdited != null ? () => widget.rootItemEdited!(item) : null,
                showingDetails: item.isShowDetails,
                margin: EdgeInsets.symmetric(vertical: 0),
                liXActions_LEFT: _xActionsLi_LEFT,
                xActions_RIGHT_HorizontalAxis: xActions_RIGHT_HorizontalAxis,
                xActions_LEFT_HorizontalAxis: xActions_LEFT_HorizontalAxis,
                widgetOnStackOfItems: xLayout_WidgetOverItems(item),
                liXActions_RIGHT: _xActionsLi_RIGHT,
                liXActions_FAST: _xActionsLi_FAST,
                xActions_LEFT_widthArea: xActions_LEFT_widthArea,
                xActions_RIGHT_widthArea: xActions_RIGHT_widthArea,
                cellIsFlexible: xItem_cellIsFlexible,
                styleForItemCell: widget.xCells_Item_TextStyle,
                xLayout_Row_CellWidth: widget.xCells_Item_Width,
                xLayout_Row_Cell: widget.xCells_Item_Widget ?? (xCol, item) => isWeb || widget.isEditable ? xLayout_CellWidget_Editable(xCol, item, context, item) : xLayout_Item_RowWidgets(xCol, item),
                paddingOfItem: xItems_Padding,
                decorationBackGroundContainer: widget.xApp!.state.xBox_Decoration(
                  item,
                  backGround_Color: xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : widget.backgroundColor,
                  border: (xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : widget.backgroundColor) == xItems_BackgroundColor ? Border(bottom: BorderSide(color: xItems_BorderColor, width: 2)) : null,
                ),
                backGroundColor_ChildMain: xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : (item.isShowDetails && widget.elDettsMode_SchItem == true ? xItems_BackgroundColor : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? xItems_BackgroundColor : widget.appBar_Color!.withAlpha(30))),
                backGroundColor_ChildDetails: xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : (item.isShowDetails ? xItems_BackgroundColor : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? xItems_BackgroundColor : widget.appBar_Color!.withAlpha(30))),
                onDoubleTapItem: widget.onDoubleTapItem,
                showTrailingArrow: false,
                widgets_RightArea: xLayout_WidgetsRightArea_Item(item, setState),
                childMain: widget.item_Widget != null ? widget.item_Widget!(item) : null,
                widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
                onTapItem: () async {
                  var x = await xOnTapItem(item);
                  if (x == null) {}

                  widget.onTapItem != null ? widget.onTapItem!(item) : null;
                },
                onLongTapItem: () => xOnLongTapItem(item),
                // xLayout_Row_Cell: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),
                edited: widget.edited ?? ValueNotifier(false),
                //Widget che raffigura i dettagli che sono dentro la riga espansa
                childDetails: Column(mainAxisSize: MainAxisSize.min, children: [(widget.xDettItem_Widget != null ? widget.xDettItem_Widget!(item) ?? Container() : Container())]));
          })
        : (widget.elDettsMode_SchItem != null && widget.elDettsMode_SchItem!)
            ? xLayout_DettItemWidget(item) ??
                DragTarget<XFDataItem>(onWillAccept: (data) {
                  var res = xOnDrop_BeforeAccept(data!, item);
                  setState(() {
                    if (res) {
                      item.isSel = true;
                    } else {
                      item.isSel = false;
                    }
                  });
                  return res;
                }, onAccept: (data) async {
                  await xOnDrop_Accept(data, item);
                  setState(() {
                    item.isSel = false;
                  });
                }, onLeave: (data) {
                  xOnDrop_Leave(data!);
                  setState(() {
                    item.isSel = false;
                  });
                }, builder: (context, candidateData, rejectedData) {
                  return XElencoItem(setState, item, context, widget.view!,
                      funct: widget.rootItemEdited != null ? () => widget.rootItemEdited!(item) : null,
                      showingDetails: item.isShowDetails,
                      liXActions_LEFT: _xActionsLi_LEFT,
                      liXActions_RIGHT: _xActionsLi_RIGHT,
                      liXActions_FAST: _xActionsLi_FAST,
                      xActions_RIGHT_HorizontalAxis: xActions_RIGHT_HorizontalAxis,
                      xActions_LEFT_HorizontalAxis: xActions_LEFT_HorizontalAxis,
                      xActions_LEFT_widthArea: xActions_LEFT_widthArea,
                      xActions_RIGHT_widthArea: xActions_RIGHT_widthArea,
                      widgetOnStackOfItems: xLayout_WidgetOverItems(item),
                      cellIsFlexible: xItem_cellIsFlexible,
                      styleForItemCell: widget.xCells_Item_TextStyle,
                      xLayout_Row_CellWidth: widget.xCells_Item_Width,
                      xLayout_Row_Cell: widget.xCells_Item_Widget ?? (xCol, item) => isWeb || widget.isEditable ? xLayout_CellWidget_Editable(xCol, item, context, item) : xLayout_Item_RowWidgets(xCol, item),
                      paddingOfItem: xItems_Padding,
                      margin: EdgeInsets.symmetric(vertical: 0),
                      decorationBackGroundContainer: widget.xApp!.state.xBox_Decoration(
                        item,
                        backGround_Color: xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : widget.backgroundColor,
                        border: (xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : widget.backgroundColor) == xItems_BackgroundColor ? Border(bottom: BorderSide(color: xItems_BorderColor, width: 2)) : null,
                      ),
                      backGroundColor_ChildMain: xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? xItems_BackgroundColor : widget.appBar_Color!.withAlpha(30)),
                      backGroundColor_ChildDetails: xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : widget.xDettItem_BackGroundColor ?? (widget.appBar_Color == null ? widget.xDettItem_BackGroundColor ?? xItems_BackgroundColor : widget.appBar_Color!.withAlpha(30)),
                      onDoubleTapItem: widget.onDoubleTapItem,
                      childMain: widget.item_Widget != null ? widget.item_Widget!(item) : null,
                      widgets_RightArea: xLayout_WidgetsRightArea_Item(item, setState),
                      widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
                      showTrailingArrow: true,
                      //DD 19/09/23 questo ha risolto su ELattACQ che NON espandeva i datt, magari ha portato altri casini
                      onTapItem: () async {
                        setState(() {
                          item.isSel = item.isShowDetails = item.isShowDetails.not();
                        });
                        await xOnTapItem(item);
                        widget.onTapItem != null ? widget.onTapItem!(item) : null;
                      },
                      onLongTapItem: () => xOnLongTapItem(item),
                      edited: widget.edited ?? ValueNotifier(false),
                      childDetails: Container(
                          width: MediaQuery.of(context).size.width,
                          child: widget.showHead_DettsRowInItem && widget.xDetts_xColname != null
                              ? XScheda(item, widget.viewDetts!, xHead_Show: widget.showHead_DettsRowInItem, modePage_Active: false)
                              : Container(
                                  child: Column(
                                  crossAxisAlignment: CrossAxisAlignment.start,
                                  children: liDettsUI
                                      .map((element) => Container(
                                          child: Column(
                                              crossAxisAlignment: CrossAxisAlignment.start,
                                              children: widget.viewDetts!.cols!.groupListsBy((element) => element.originY).entries.map((e) {
                                                return Wrap(
                                                    spacing: 3,
                                                    runSpacing: 5,
                                                    children: e.value.map((e) {
                                                      return xLayout_Item_RowWidgets(e, element);
                                                    }).toList());
                                              }).toList())))
                                      .toList(),
                                ))));
                })
            : xLayout_DettItemWidget(item) ??
                DragTarget<XFDataItem>(onWillAccept: (data) {
                  var res = xOnDrop_BeforeAccept(data!, item);
                  setState(() {
                    if (res) {
                      item.isSel = true;
                    } else {
                      item.isSel = false;
                    }
                  });
                  return res;
                }, onAccept: (data) async {
                  await xOnDrop_Accept(data, item);
                  setState(() {
                    item.isSel = false;
                  });
                }, onLeave: (data) {
                  xOnDrop_Leave(data!);
                  setState(() {
                    item.isSel = false;
                  });
                }, builder: (context, candidateData, rejectedData) {
                  return XElencoItem(setState, item, context, widget.view!,
                      funct: widget.rootItemEdited != null ? () => widget.rootItemEdited!(item) : null,
                      showingDetails: item.isShowDetails,
                      liXActions_LEFT: _xActionsLi_LEFT,
                      liXActions_RIGHT: _xActionsLi_RIGHT,
                      liXActions_FAST: _xActionsLi_FAST,
                      xActions_RIGHT_HorizontalAxis: xActions_RIGHT_HorizontalAxis,
                      xActions_LEFT_HorizontalAxis: xActions_LEFT_HorizontalAxis,
                      xActions_LEFT_widthArea: xActions_LEFT_widthArea,
                      xActions_RIGHT_widthArea: xActions_RIGHT_widthArea,
                      widgetOnStackOfItems: xLayout_WidgetOverItems(item),
                      cellIsFlexible: xItem_cellIsFlexible,
                      styleForItemCell: widget.xCells_Item_TextStyle,
                      xLayout_Row_CellWidth: widget.xCells_Item_Width,
                      xLayout_Row_Cell: widget.xCells_Item_Widget ?? (xCol, item) => isWeb || widget.isEditable ? xLayout_CellWidget_Editable(xCol, item, context, item) : xLayout_Item_RowWidgets(xCol, item), //rick
                      paddingOfItem: xItems_Padding,
                      margin: EdgeInsets.symmetric(vertical: 0),
                      decorationBackGroundContainer: widget.xApp!.state.xBox_Decoration(
                        item,
                        backGround_Color: xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : widget.backgroundColor,
                        border: (xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : widget.backgroundColor) == xItems_BackgroundColor ? Border(bottom: BorderSide(color: xItems_BorderColor, width: 2)) : null,
                      ),
                      backGroundColor_ChildMain: xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : (item.isShowDetails && widget.elDettsMode_SchItem == true ? xItems_BackgroundColor : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? xItems_BackgroundColor : widget.appBar_Color!.withAlpha(30))),
                      backGroundColor_ChildDetails: xLayout_XItem_BackgoundColor(item) != null ? xLayout_XItem_BackgoundColor(item) : (item.isShowDetails ? xItems_BackgroundColor : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? xItems_BackgroundColor : widget.appBar_Color!.withAlpha(30))),
                      onDoubleTapItem: widget.onDoubleTapItem,
                      edited: widget.edited ?? ValueNotifier(false),
                      showTrailingArrow: false,
                      childMain: widget.item_Widget != null ? widget.item_Widget!(item) : null,
                      widgets_RightArea: xLayout_WidgetsRightArea_Item(item, setState),
                      widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
                      onLongTapItem: () => xOnLongTapItem(item),
                      onTapItem: () async {
                        await xOnTapItem(item);
                        if (widget.onTapItem != null) {
                          widget.onTapItem!(item);
                        }
                        (widget.schNameToOpen != null && widget.schedaMode == false
                            ? Navigator.pushNamed(context, widget.schNameToOpen!, arguments: item).then((value) {
                                setState(() {
                                  isBusy.value = true;
                                  widget.xOnReturnBack != null ? widget.xOnReturnBack!(setState) : null;
                                  if (widget.edited != null) {
                                    widget.edited!.value;
                                  }
                                });

                                rebuildAllChildren(context);
                              }) //
                            : setState(() => item.isShowDetails = item.isShowDetails.not()));
                      },
                      //Widget che raffigura i dettagli che sono dentro la riga espansa
                      childDetails: Column(mainAxisSize: MainAxisSize.min, children: [(widget.xDettItem_Widget != null ? widget.xDettItem_Widget!(item) ?? Container() : Container())]));
                });
  }

  ///Override per cambiare il Widget di ogni singola Cella dell'Items
  Widget xLayout_Item_RowWidgets(XCol xCol, XFDataItem item, {bool noTextWhenCellValueIsNull = true, String formatDate = "dd/MM/yy", bool flexible = false}) {
    Widget _xContainerOfWidgets;
    Color xColColor = xCol.xmodelXprop.col_Color == Colors.black ? XColors.foregroundLight : xCol.xmodelXprop.col_Color;
    if (xCol.resizeStyle == 0 && (item[xCol.colKey] == null || item[xCol.colKey].toString().length == 0)) {
      // se sono FLEX e il mio value è NULL, torno Container()
      return Container(height: 0);
    }

    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _xContainerOfWidgets = Text(
        item[xCol.colKey] != null ? item[xCol.colKey] : ((noTextWhenCellValueIsNull) ? "<No Text>" : ""),
        maxLines: xCol.multilines
            ? item[xCol.colKey] == ""
                ? 1
                : 3
            : 1,
        style: widget.xCells_Item_TextStyle == null
            ? (item[xCol.colKey] as String).characters.length > 24
                ? XStyles.xStyTextForDescr(textColor: xColColor, fontSize: 15)
                : XStyles.xStyTextForDescr(textColor: xColColor)
            : widget.xCells_Item_TextStyle!(xCol, item, xColColor),
        textAlign: TextAlign.left,
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _xContainerOfWidgets = Text(XUtils.dateToString(item[xCol.colKey] ?? DateTime(1900, 01, 01), format: xCol.format != "" ? xCol.format : formatDate), maxLines: 1, style: widget.xCells_Item_TextStyle == null ? XStyles.xStyTextForDescr(textColor: xColColor) : widget.xCells_Item_TextStyle!(xCol, item, xColColor), textAlign: TextAlign.left);
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      if (xCol.format == "C") {
        _xContainerOfWidgets = Text(XUtils.xFormatToCurrency(context, item[xCol.colKey] ?? 0.0), style: widget.xCells_Item_TextStyle == null ? XStyles.xStyTextForDescr(textColor: item[xCol.colKey] == 0.0 ? Colors.grey[600]! : xColColor) : widget.xCells_Item_TextStyle!(xCol, item, item[xCol.colKey] == 0.0 ? Colors.grey[600]! : xColColor), textAlign: TextAlign.end);
        // Se è un un semplice double
      } else if (xCol.colKey.startsWith("avanz")) {
        if (xCol.readOnly) {
          _xContainerOfWidgets = Stack(alignment: Alignment.center, children: [
            LinearProgressIndicator(
              value: (item[xCol.colKey] / 100) ?? 0.0,
              minHeight: 20.0,
              backgroundColor: Colors.grey[300],
              valueColor: AlwaysStoppedAnimation<Color>(xColColor),
            ),
            Text('${(item[xCol.colKey] as double).roundToDouble()}%', style: XStyles.xStyTextForLabel(textColor: Colors.black, activeBold: true)),
          ]);
        } else {
          _xContainerOfWidgets = StatefulBuilder(builder: (context, setState) {
            return SfLinearGauge(
                animateAxis: false,
                showTicks: false,
                showLabels: false,
                axisTrackStyle: LinearAxisTrackStyle(thickness: 30, color: Colors.grey[700]),
                orientation: LinearGaugeOrientation.horizontal, //
                barPointers: [LinearBarPointer(value: item[xCol.colKey], color: xColColor, thickness: 30, animationDuration: 0)],
                useRangeColorForAxis: true,
                markerPointers: <LinearMarkerPointer>[
                  LinearWidgetPointer(
                      value: item[xCol.colKey],
                      enableAnimation: false,
                      onChangeEnd: (value) {
                        setState(() {
                          if (item is K)
                            widget.rootItemEdited != null ? widget.rootItemEdited!(item) : null;
                          else
                            widget.itemEdited != null ? widget.itemEdited!(item) : null;
                          if (widget.edited != null) widget.edited!.value = true;

                          item[xCol.colKey] = value.roundToDouble();
                        });
                      },
                      onChanged: (dynamic value) => setState(() => item[xCol.colKey] = (value as double).roundToDouble()),
                      child: Container(
                          width: 34,
                          height: 34,
                          decoration: BoxDecoration(color: Colors.grey[900], boxShadow: <BoxShadow>[BoxShadow(color: Colors.black54, offset: Offset(0.0, 1.0), blurRadius: 6.0)], shape: BoxShape.circle),
                          child: Center(
                              child: FittedBox(
                                  child: Text(
                            item[xCol.colKey].toStringAsFixed(0) + "",
                            style: widget.xCells_Item_TextStyle == null
                                ? XStyles.xStyTextForLabel(textColor: xColColor, activeBold: true) //
                                : widget.xCells_Item_TextStyle!(xCol, item, xColColor),
                          )))))
                ]);
          });
        }
      } else {
        _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0.0", style: widget.xCells_Item_TextStyle == null ? XStyles.xStyTextForDescr(textColor: xColColor) : widget.xCells_Item_TextStyle!(xCol, item, xColColor));
      }
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0", style: widget.xCells_Item_TextStyle == null ? XStyles.xStyTextForDescr(textColor: xColColor) : widget.xCells_Item_TextStyle!(xCol, item, xColColor), textAlign: TextAlign.left);

      //Se fosse una lista e voglio prendere la quantità di oggetti dentro
    } else if (xCol.dataType == bool) {
      _xContainerOfWidgets = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: true,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color,
            activeColor: xCol.xmodelXprop.col_Color,
            checkColor: XColors.foregroundDark,
            value: (item[xCol.colKey] ?? false),
            onChanged: (value) async {
              setState(() {
                if (item is K)
                  widget.rootItemEdited != null ? widget.rootItemEdited!(item) : null;
                else
                  widget.itemEdited != null ? widget.itemEdited!(item) : null;
                if (widget.edited != null) widget.edited!.value = true;
                item[xCol.colKey] = value;
              });
            }),
      );
    } else if (xCol.dataType == String && (xCol.colKey.startsWith("li"))) {
      _xContainerOfWidgets = Container();
    } else {
      _xContainerOfWidgets = Text(xCol.headerToolTip + (item[xCol.colKey] != null ? item[xCol.colKey] : ((noTextWhenCellValueIsNull) ? "<No Text>" : "")), style: widget.xCells_Item_TextStyle == null ? XStyles.xStyTextForDescr(textColor: xColColor) : widget.xCells_Item_TextStyle!(xCol, item, xColColor), textAlign: TextAlign.left);
    }
    if (widget.xCells_Item_Widget == null) {
      var wOfCell = xCol.width * XUtils.kforScale;
      return xCol.hidden ? Container() : Container(padding: EdgeInsets.symmetric(horizontal: 2), alignment: Alignment.centerLeft, width: flexible ? null : (widget.xCells_Item_Width == null ? wOfCell : (widget.xCells_Item_Width!(xCol, item, wOfCell))), child: _xContainerOfWidgets);
    } else {
      return widget.xCells_Item_Widget!(xCol, item);
    }
  }

  ///Override per cambiare il Widget che si vede solo se l'Elenco è vuoto
  Widget xLayout_Widget_IfEmptyList() {
    var x = widget.xBL_BTN_EmptyList == null ? Container() : widget.xBL_BTN_EmptyList!();
    return x ?? Container();
  }

  ///Override per cambiare widget per l'elenco, solo l'area sotto la XSearchBar e sotto l'AppBar
  Widget? xLayout_ElencoWidget() {
    return null;
  }

  Widget xLayout_AreaUnderHeader() {
    return Container();
  }

  ///Override per cambiare widget dell'intero Elenco anche la XSearchBar
  Widget xLayout_AreaElenco() {
    return Container(
        color: widget.backgroundColor,
        margin: EdgeInsets.symmetric(horizontal: widget.margin_Horizontal ?? 0),
        child: Column(children: [
          widget.appBar_Custom_Visible ? xLayout_AppBarCustom() : Container(),
          widget.appBar_Custom_Visible ? SizedBox(height: 10) : Container(),
          Container(
              decoration: (widget.searchBar_Active && xFilter_SearchBarXCols.isNotEmpty && list.length > 10 || (widget.liDetts != null && widget.liDetts!.length > 10)) || (widget.view!.cols!.where((xcol) => xcol.colKey.startsWith("li").not()).length > 3 && (widget.schedaMode?.not()))
                  ? BoxDecoration(
                      border: Border(
                      left: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                      right: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                      bottom: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                    ))
                  : null,
              padding: EdgeInsets.only(bottom: 1),
              child: Row(children: [
                Expanded(
                    child: (widget.searchBar_Active && xFilter_SearchBarXCols.isNotEmpty && list.length > 10 || (widget.liDetts != null && widget.liDetts!.length > 10))
                        ? XSearchBar(
                            marginOfSearchBox: EdgeInsets.symmetric(vertical: 2),
                            paddingOfContent: EdgeInsets.only(left: 5),
                            height: 40,
                            hintStyle: searchBar_HintStyleText ?? searchBar_StyleText ?? XStyles.xStyTextForSubLabel(textColor: widget.searchBar_ColorHint ?? XColors.foregroundLight),
                            textStyle: searchBar_StyleText ?? XStyles.xStyTextForSubLabel(textColor: widget.searchBar_ColorText ?? XColors.foregroundLight),
                            colorIconForClear: widget.searchBar_ColorIconClear ?? XColors.foregroundLight,
                            colorIconForSearch: widget.searchBar_ColorIconSearch ?? XColors.foregroundLight,
                            autoFocus: false,
                            onTextChanged: (value) => setState(() {
                                  if (value == "") {
                                    searchController.text = "";
                                    xFilterCurrent = xFilterAll;
                                  } else
                                    xFilterCurrent = value;
                                }),
                            onPressedClear: () => setState(() {
                                  xFilterCurrent = xFilterAll;
                                  searchController.text = "";
                                }),
                            border: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                            disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                            enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                            controller: searchController,
                            colorOfSearchBox: widget.searchBar_Color,
                            hintText: widget.searchBar_hintText ?? "cerca..",
                            iconForSearch: null)
                        : Container()),
                widget.view!.cols!.where((xcol) => xcol.colKey.startsWith("li").not()).length > 3 && (widget.schedaMode?.not())
                    ? XBtnbase(
                        icon: widget.headers_Visible ? Icons.expand_less_outlined : Icons.expand_more_outlined,
                        backGroundColor: Colors.grey[900],
                        width: 40,
                        height: 40,
                        icon_Color: widget.headers_Visible ? Colors.amber : Colors.white,
                        onPressed: () {
                          setState(() {
                            widget.headers_Visible = widget.headers_Visible.not();
                          });
                        })
                    : Container(),
                (widget.schedaMode ?? false)
                    ? Container()
                    : widget.allowAdd
                        ? xLayout_AddBTN_Widget()
                        : Container()
              ])),

          //RENDERIZZA L'HEADER DEL L ELENCO
          (widget.headers_Visible && widget.view!.cols!.where((xcol) => xcol.colKey.startsWith("li").not()).length > 3)
              ? MediaQuery.of(context).size.height < 40
                  ? Container()
                  : Container(
                      margin: xMedia_Active ? EdgeInsets.only(left: 30) : null,
                      padding: EdgeInsets.only(top: 4),
                      decoration: BoxDecoration(
                          border: Border(
                        bottom: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                        left: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                        right: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                      )),
                      child: Row(children: [Expanded(child: SingleChildScrollView(child: Column(children: xLayout_Render_HeadView(widget.view!, border_Visible: widget.borderAree_Header ?? false))))]))
              : Container(),
          //RENDERIZZA L'HEADER DEL L ELENCO
          xLayout_AreaUnderHeader(),
          ((widget.schedaMode ?? false))
              ? Container()
              : widget.title_OnTop_Visible
                  ? Row(children: [
                      Expanded(
                          child: XContainerWithLabel(
                        widget.title_Text,
                        height: widget.title_OnTop_AddBTN_Height,
                        color: widget.title_OnTop_BackgroundColor ?? widget.searchBar_Color ?? XColors.backGroundTitleContainerForElenco,
                        textStyle: widget.title_Style ?? XStyles.xStyTextForTextBase(textColor: XColors.foregroundDark),
                      )),
                      widget.title_OnTop_AddBTN_Visible == true
                          ? Container(
                              margin: widget.title_OnTop_AddBTN_Margin ?? EdgeInsets.only(left: 5),
                              height: widget.title_OnTop_AddBTN_Height ?? 25,
                              width: widget.title_OnTop_AddBTN_Width ?? 70,
                              child: XBtnbase(
                                label: widget.title_OnTop_AddBTN_Label ?? "Add New",
                                onPressed: widget.title_OnTop_AddBTN_OnPressed,
                                decoration: BoxDecoration(color: widget.title_OnTop_AddBTN_Color),
                              ))
                          : Container()
                    ])
                  : Container(),

          ///Da overridare per aggiungere un tuo widget nell'elenco solo se la lista è vuota
          SizedBox(height: 10),
          Expanded(
              flex: widget.xLayout_HeightElArea_Factor ?? 18,
              child: Row(crossAxisAlignment: CrossAxisAlignment.start, children: [
                widget.xWidget_Left ?? Container(),
                Expanded(
                    child: Stack(alignment: widget.xLayout_Stack_Alignment ?? Alignment.topCenter, children: [
                  DragTarget<XFDataItem>(
                    builder: (context, candidateData, rejectedData) {
                      return xLayout_ElencoWidget() != null
                          ? xLayout_ElencoWidget() ?? Container()
                          : widget.isCompexUI_WrapItems
                              ? Scrollbar(
                                  thumbVisibility: true,
                                  controller: scroll_controller,
                                  child: Container(
                                      alignment: Alignment.topCenter,
                                      child: SingleChildScrollView(
                                          controller: scroll_controller,
                                          child: Wrap(
                                              spacing: 10,
                                              runSpacing: 10,
                                              children: (list.isEmpty && (widget.liDetts != null && widget.liDetts!.isEmpty))
                                                  ? [xLayout_Widget_IfEmptyList()]
                                                  : widget.liDetts != null
                                                      ? widget.liDetts!.where((element) => xFilter_FilterItem(element)).map((e) {
                                                          return DragTarget<T>(
                                                              onWillAccept: (data) => xOnDrop_BeforeAccept(data! as XFDataItem, e),
                                                              onAccept: (data) async => await xOnDrop_Accept(data as XFDataItem, e),
                                                              builder: (context, candidateData, rejectedData) {
                                                                return widget.item_Widget != null
                                                                    ? widget.item_Widget!(e) ?? Container() //
                                                                    : xLayout_ItemWidget(e) ?? Container();
                                                              });
                                                        }).toList()
                                                      : list.where((element) => xFilter_FilterItem(element)).map((e) {
                                                          return DragTarget<T>(
                                                              onWillAccept: (data) => xOnDrop_BeforeAccept(data! as XFDataItem, e),
                                                              onAccept: (data) async => await xOnDrop_Accept(data as XFDataItem, e),
                                                              builder: (context, candidateData, rejectedData) {
                                                                return widget.item_Widget != null
                                                                    ? widget.item_Widget!(e) ?? Container() //
                                                                    : xLayout_ItemWidget(e) ?? Container();
                                                              });
                                                        }).toList()))))
                              : isWeb
                                  ? XElGrid(widget.title_Text, widget.view!,
                                      allowEdit: true,
                                      xgds_Origin: () => gds_El((widget.liDetts as List<K>?) ?? list, widget.view!, rootItemEdited: (p0) {
                                            var x = ((widget.liDetts as List<K>?) ?? list).firstWhereOrNull((element) => element.id == p0.id);
                                            if (x != null) {
                                              widget.view!.cols!.forEach((e) {
                                                xOnXCell_Edit_SubmitValue_ToItem(x, e, p0[e.colKey], p0[e.colKey] != x[e.colKey]);
                                              });
                                              widget.rootItemEdited!(x);
                                            }
                                          }))
                                  : ((widget.schedaMode ?? false) && widget.onRefresh_ScrollDownList != null)
                                      ? RefreshIndicator(
                                          triggerMode: RefreshIndicatorTriggerMode.anywhere,
                                          onRefresh: () => widget.onRefresh_ScrollDownList!(context),
                                          child: Scrollbar(
                                              thumbVisibility: true,
                                              controller: scroll_controller,
                                              child: ListView(
                                                  children: (list.isEmpty && (widget.liDetts != null && widget.liDetts!.isEmpty))
                                                      ? [xLayout_Widget_IfEmptyList()]
                                                      : widget.liDetts != null
                                                          ? widget.liDetts!.where((element) => xFilter_FilterItem(element)).map((e) {
                                                              return DragTarget<T>(
                                                                  onWillAccept: (data) => xOnDrop_BeforeAccept(data! as XFDataItem, e),
                                                                  onAccept: (data) async => await xOnDrop_Accept(data as XFDataItem, e),
                                                                  builder: (context, candidateData, rejectedData) {
                                                                    return widget.item_Widget != null
                                                                        ? widget.item_Widget!(e) ?? Container() //
                                                                        : xLayout_ItemWidget(e) ?? Container();
                                                                  });
                                                            }).toList()
                                                          : list.where((element) => xFilter_FilterItem(element)).map((e) {
                                                              return DragTarget<T>(
                                                                  onWillAccept: (data) => xOnDrop_BeforeAccept(data! as XFDataItem, e),
                                                                  onAccept: (data) async => await xOnDrop_Accept(data as XFDataItem, e),
                                                                  builder: (context, candidateData, rejectedData) {
                                                                    return widget.item_Widget != null
                                                                        ? widget.item_Widget!(e) ?? Container() //
                                                                        : xLayout_ItemWidget(e) ?? Container();
                                                                  });
                                                            }).toList(),
                                                  controller: scroll_controller)))
                                      : Scrollbar(
                                          thumbVisibility: true,
                                          controller: scroll_controller,
                                          child: ListView(
                                              children: (list.isEmpty && (widget.liDetts != null && widget.liDetts!.isEmpty))
                                                  ? [xLayout_Widget_IfEmptyList()]
                                                  : widget.liDetts != null
                                                      ? widget.liDetts!.where((element) {
                                                          for (var xProp in xFilter_OrderBy_XProps) {
                                                            widget.liDetts!.orderBy([xProp.col_Name], desc: (widget.view!.cols!.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
                                                          }
                                                          return xFilter_FilterItem(element);
                                                        }).map((e) {
                                                          return DragTarget<T>(
                                                              onWillAccept: (data) => xOnDrop_BeforeAccept(data! as XFDataItem, e),
                                                              onAccept: (data) async => await xOnDrop_Accept(data as XFDataItem, e),
                                                              builder: (context, candidateData, rejectedData) {
                                                                return widget.item_Widget != null
                                                                    ? widget.item_Widget!(e) ?? Container() //
                                                                    : xLayout_ItemWidget(e) ?? Container();
                                                              });
                                                        }).toList()
                                                      : list.where((element) {
                                                          for (var xProp in xFilter_OrderBy_XProps) {
                                                            list.orderBy([xProp.col_Name], desc: (widget.view!.cols!.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
                                                          }
                                                          return xFilter_FilterItem(element);
                                                        }).map((e) {
                                                          return DragTarget<T>(
                                                              onWillAccept: (data) => xOnDrop_BeforeAccept(data! as XFDataItem, e),
                                                              onAccept: (data) async => await xOnDrop_Accept(data as XFDataItem, e),
                                                              builder: (context, candidateData, rejectedData) {
                                                                return widget.item_Widget != null
                                                                    ? widget.item_Widget!(e) ?? Container() //
                                                                    : xLayout_ItemWidget(e) ?? Container();
                                                              });
                                                        }).toList(),
                                              controller: scroll_controller));
                    },
                    onWillAccept: (data) => xOnDrop_BeforeAccept(data!, widget.xObjParent),
                    onAccept: (data) async => await xOnDrop_Accept(data, widget.xObjParent),
                  ),
                  isActive_addDropInElenco
                      ? DragTarget<XFDataItem>(
                          builder: (context, candidateData, rejectedData) {
                            return Container(
                                height: 50,
                                width: MediaQuery.of(context).size.width,
                                color: (widget.title_Color ?? Colors.white).withAlpha(150),
                                child: Row(children: [
                                  Expanded(child: Text("...trascina qui per aggiungere...", textAlign: TextAlign.center, style: XStyles.xStyTextForLabel(textColor: XColors.foregroundDark))),
                                ]));
                          },
                          onWillAccept: (data) => xOnDrop_BeforeAccept(data!, widget.xObjParent),
                          onAccept: (data) async {
                            await xOnDrop_Accept(data, widget.xObjParent);
                          },
                        )
                      : Container(),
                ])),
                widget.xWidget_Right ?? Container(),
              ]))
        ]));
  }

  Widget xLayout_Render_HeadView_Widget_forY(
    MapEntry<int, List<XCol<dynamic>>> e,
    List<Widget> children,
    int lastY,
    bool border_separator, {
    bool border_Visible = true,
    Color? border_color,
  }) {
    return Container(
        child: Column(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.start, children: [
      Container(
          alignment: Alignment.topLeft,
          child: Wrap(
            direction: Axis.horizontal,
            alignment: WrapAlignment.start,
            runAlignment: WrapAlignment.start,
            crossAxisAlignment: WrapCrossAlignment.start,
            children: children,
          ))
    ]));
  }

  ///Override per cambiare widget dell'HeadView dell'Elenco
  List<Widget> xLayout_Render_HeadView(XView xview, {bool border_Visible = true}) {
    xLayout_maxRowLen = 0; //resetto
    var grps = widget.view!.cols!
        . //
        groupListsBy((element) => element.originY)
        .entries
        .toList();
    var lastY = grps.last.key;
    double avgColsInY = 0;
    grps.map((e) => avgColsInY += e.value.length).toList();
    avgColsInY = avgColsInY / grps.length;
    var r = grps.map(
      (e) {
        //x ogni Y
        //x orgni sottoROW/grp
        double rowLen = 0;
        var child = xLayout_Render_HeadView_Widget_forY(
            e,
            e.value.map((xCol) {
              var xwidgt = Container(
                  padding: EdgeInsets.symmetric(horizontal: 2, vertical: widget.pageMode_Active ? 2 : 5),
                  decoration: BoxDecoration(
                    color: (xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight : xCol.xmodelXprop.col_Color).withAlpha(40),
                    border: Border.all(width: 1, color: xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight.withAlpha(150) : xCol.xmodelXprop.col_Color.withAlpha(150)),
                  ),
                  constraints: BoxConstraints(minWidth: xItem_cellIsFlexible ? (xCol.width * XUtils.kforScale) : xCol.width),
                  child: InkWell(
                      onTap: () async {
                        //Tap per gestire il sort delle colonne
                        await xOnTapHeaderCell(xCol);
                      },
                      child: Text(
                        (xCol.sorted == null
                                ? ""
                                : xCol.sorted!.not()
                                    ? " ⇧ "
                                    : " ⇩ ") +
                            xCol.colCaption,
                        style: widget.xCells_Item_TextStyle != null ? widget.xCells_Item_TextStyle!(xCol, null, xCol.xmodelXprop.col_Color) : XStyles.xStyTextForSubLabel(textColor: xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight : xCol.xmodelXprop.col_Color),
                      )));
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
            lastY,
            avgColsInY > 3);
        if (rowLen > xLayout_maxRowLen) xLayout_maxRowLen = rowLen;
        return child;
      },
    ).toList();

    return r;
  }

  ///Override per cambiare widget dell'HeadView dei dettagli degli Items dell'Elenco
  List<Widget> xLayout_RenderDett_HeadDataView(XView xview, dynamic item, {bool border_Visible = true, List<XCol>? liColsToUse}) {
    xLayout_maxRowLen = 0; //resetto
    var grps = (liColsToUse != null ? liColsToUse : widget.view!.cols)!
        . //
        groupListsBy((element) => element.originY)
        .entries
        .toList();
    var lastY = grps.last.key;
    double avgColsInY = 0;
    grps.map((e) => avgColsInY += e.value.length).toList();
    avgColsInY = avgColsInY / grps.length;
    var r = grps.map(
      (e) {
        //x ogni Y
        //x orgni sottoROW/grp
        double rowLen = 0;
        var child = xLayout_Render_HeadView_Widget_forY(
            e,
            e.value.map((xCol) {
              var xwidgt = Container(
                  padding: EdgeInsets.symmetric(horizontal: 2, vertical: widget.pageMode_Active ? 2 : 3),
                  // decoration: BoxDecoration(
                  //   color: (xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight : xCol.xmodelXprop.col_Color).withAlpha(40),
                  //   border: Border.all(width: 1, color: xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight.withAlpha(150) : xCol.xmodelXprop.col_Color.withAlpha(150)),
                  // ),
                  constraints: BoxConstraints(minWidth: xCol.width * XUtils.kforScale),
                  child: xLayout_Item_RowWidgets(xCol, item));
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
            lastY,
            avgColsInY > 3);
        if (rowLen > xLayout_maxRowLen) xLayout_maxRowLen = rowLen;
        return child;
      },
    ).toList();

    return r;
  }

  ///Override per aggiungere dei Widget nelle Actions dell'AppBar
  List<Widget> xLayout_Actions() {
    List<Widget> list = List<Widget>.empty(growable: true);
    list.add(_xFilter_build());
    return list;
  }

  ///Override per cambiare l'AppBar Custom
  Widget xLayout_AppBarCustom() {
    var mcq = MediaQuery.of(context).size;
    return OrientationBuilder(builder: (context, orientation) {
      return Slidable(
          key: ValueKey(0),
          startActionPane: xAppBar_Widgets_LEFT == null || xAppBar_Widgets_LEFT!.isEmpty
              ? null
              : ActionPane(motion: ScrollMotion(), extentRatio: xAppBar_Widgets_LEFT_WidthArea ?? (xAppBar_Widgets_LEFT!.length > 1 ? 0.5 : 0.3), dragDismissible: false, children: [
                  Container(
                      alignment: Alignment.centerRight,
                      padding: EdgeInsets.symmetric(horizontal: 4),
                      child: Wrap(
                        spacing: 7,
                        runSpacing: 7,
                        runAlignment: WrapAlignment.center,
                        alignment: WrapAlignment.center,
                        direction: Axis.vertical,
                        children: xAppBar_Widgets_LEFT!,
                      ))
                ]),
          endActionPane: xAppBar_Widgets_RIGHT == null || xAppBar_Widgets_RIGHT!.isEmpty
              ? null
              : ActionPane(motion: ScrollMotion(), extentRatio: xAppBar_Widgets_RIGHT_WidthArea ?? (xAppBar_Widgets_RIGHT!.length > 1 ? 0.5 : 0.3), dragDismissible: false, children: [
                  Container(
                      alignment: Alignment.centerRight,
                      padding: EdgeInsets.symmetric(horizontal: 4),
                      child: Wrap(
                        spacing: 7,
                        runSpacing: 7,
                        runAlignment: WrapAlignment.center,
                        alignment: WrapAlignment.center,
                        direction: Axis.vertical,
                        children: xAppBar_Widgets_RIGHT!,
                      ))
                ]),
          child: Container(
              padding: EdgeInsets.only(
                  top: kIsWeb.not() && Platform.isAndroid
                      ? mcq.width > 450
                          ? 0
                          : 40
                      : 0),
              width: MediaQuery.of(context).size.width,
              color: XSchedaState.color_AppBar_Background,
              child: Wrap(alignment: WrapAlignment.spaceBetween, runAlignment: WrapAlignment.center, crossAxisAlignment: WrapCrossAlignment.center, children: [
                InkWell(
                    splashColor: Colors.transparent,
                    enableFeedback: false,
                    onTap: (widget.schedaMode ?? false) ? null : () => widget.onTapBack != null ? widget.onTapBack!() : widget.xApp!.state.scaffoldKey_MainMenu.currentState!.openDrawer(),
                    child: Container(
                        child: Row(mainAxisSize: MainAxisSize.min, children: [
                      (widget.schedaMode ?? false) ? Container() : Container(width: 40, child: Icon(Icons.arrow_back, color: widget.title_Color)),
                      Flexible(child: Text(widget.title_Text, style: widget.title_Style ?? XStyles.xStyTextForLabel(textColor: widget.title_Color ?? XColors.foregroundLight), overflow: TextOverflow.ellipsis)),
                    ]))),
                Row(mainAxisSize: MainAxisSize.min, children: [
                  Container(margin: EdgeInsets.symmetric(vertical: 5, horizontal: 5), child: Row(children: xLayout_Actions())),
                  widget.onRefresh_ScrollDownList == null
                      ? Container()
                      : XBtnbase(
                          icon: Icons.replay_outlined,
                          onPressed: widget.onRefresh_ScrollDownList != null ? () => widget.onRefresh_ScrollDownList!(context) : () {},
                          width: 40,
                          height: 40,
                          margin: EdgeInsets.all(5),
                        )
                ])
              ])));
    });
  }

  ///Override per cambiare il Bottone di aggiunta nell'Elenco
  Widget xLayout_AddBTN_Widget() {
    return XBtnbase(
      margin: EdgeInsets.only(left: 5),
      width: 150,
      icon_WidthArea: 30,
      toolTip_Message: "Aggiungi ${widget.title_Text}",
      icon: Icons.add,
      icon_Size: 20,
      label: widget.title_Text,
      label_Style: XStyles.xStyTextForSubLabel(textColor: widget.title_Color ?? widget.searchBar_Color),
      icon_Color: widget.title_Color ?? widget.searchBar_Color,
      backGroundColor: Colors.grey[900],
      onPressed: widget.cmd_Add != null && widget.xCells_EditType!.value != XEnums.editType.scheda.value
          ? () async => await widget.cmd_Add!(setState).then((value) async => initXFilters()).then((value) => onComeBack()) //
          : () async {
              if (widget.xCells_EditType!.value == XEnums.editType.scheda.value) {
                await widget.cmd_Add!(setState).then((value) async => initXFilters()).then((value) => onComeBack());
              } else if (widget.xCells_EditType!.value == XEnums.editType.form.value) {
                var xclObj = XFDataItem(Uuid().v4(), isNew: true);
                var res = await xPreview_Dialog(widget.liCols_EditData.isEmpty ? widget.view ?? widget.viewDetts! : XView("AddView", cols: widget.liCols_EditData), xclObj as K);
                await xOnAfter_AddCMD(res as K?);
                if (res != null) {
                  if (widget.liDetts != null) {
                    widget.liDetts!.add(res);
                  } else {
                    list.add(res);
                  }
                }
              } else {
                var xclObj = XFDataItem(Uuid().v4(), isNew: true);
                var res = await xEditDialog_xOnAddItem(widget.liCols_EditData.isEmpty ? widget.view ?? widget.viewDetts! : XView("AddView", cols: widget.liCols_EditData), xclObj, setState);
                await xOnAfter_AddCMD(res as K?);
                if (res != null) {
                  if (widget.liDetts != null) {
                    widget.liDetts!.add(res);
                  } else {
                    list.add(res);
                  }
                }
              }
            },
    );
  }

  Future xOnAfter_AddCMD(K? res) async {}

  ///Override per cambiare il Bottone di Edit dell'ItemComplex dell'Elenco
  Widget xLayout_EditBTN_Widget(XFDataItem item, bool dett_Active, void Function(void Function()) parentSetState, XView xView_Elenco, {String? title}) {
    return Container(
        child: XBtnbase(
            height: 40,
            width: 40,
            icon_WidthArea: 30,
            label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.yellow),
            icon: Icons.edit,
            icon_Size: 23,
            icon_Color: Colors.yellow,
            toolTip_Message: "Modifica questa riga",
            onPressed: () async {
              var res = await xPreview_Dialog(xView_Elenco, item);
              if (res != null) {
                item = res.getCloneFull();
                if (item is K)
                  widget.rootItemEdited != null ? widget.rootItemEdited!(item as K) : null;
                else
                  widget.itemEdited != null ? widget.itemEdited!(item) : null;
              }
            }));
  }

  ///Override per cambiare il Bottone di Take di un Media sull'ItemComplex dell'Elenco
  Widget xLayout_TakeXMedia_Widget(XFDataItem item) {
    return XBtnbase(
      icon: Icons.photo_camera_outlined,
      icon_Size: 22,
      width: xActionsBTN_Width,
      height: xActionsBTN_Height,
      toolTip_Message: XfxToolTips.BTN_GetXMedia,
      decoration: BoxDecoration(color: xActionsBTN_BackgroundColor, border: Border.all(width: 1, color: xActionsBTN_BorderColor), borderRadius: BorderRadius.all(Radius.circular(10))),
      icon_Color: Colors.orange,
      onPressed: () async => await xCMD_XMedia_GetMedia(setState, item).then((value) => setState(() {})),
    );
  }

  ///Override per cambiare il Widget per la visualizzazione delle Immagini nella Lista degli XMedia
  Widget xLayout_Builder_ImmaginiWidget(XMediaItem xMedia, XFDataItem item, void Function(void Function()) setState, {DateTime? dt, double? width, double? height}) {
    return InkWell(
        onLongPress: () async => xMedia.xDocID != item.id ? null : await xOnDelXMedia_INTERNAL(xMedia, item),
        onTap: () => xCMD_XMedia_OpenPhoto(xMedia, item, dtImage: dt),
        child: Container(
            color: Colors.white,
            width: width ?? 80,
            child: Stack(
                children: xMedia.miniatura == null && xMedia.payload == null
                    ? [Container(width: width ?? 80, height: height ?? 100, color: Colors.grey[800], child: Icon(Icons.block, size: 30, color: Colors.white))]
                    : [
                        Stack(alignment: Alignment.topRight, children: [
                          Container(child: Stack(children: [Image.memory(xMedia.miniatura ?? xMedia.payload!, width: width ?? 80, height: height ?? 100)]))
                        ]),
                      ])));
  }

  ///Override per cambiare il Widget per la visualizzazione dei Video nella Lista degli XMedia
  Widget xLayout_Builder_VideoWidget(XMediaItem video, XFDataItem item, {void Function(void Function())? setState, double? width, double? height}) {
    return InkWell(
        onLongPress: () async => video.xDocID != video.id ? null : await xOnDelXMedia_INTERNAL(video, item),
        onTap: () async => xCMD_XMedia_OpenVideo(video, setState: setState),
        child: Container(
          decoration: BoxDecoration(color: Colors.grey[800], image: DecorationImage(image: MemoryImage(video.miniatura!))),
          width: width ?? 80,
          height: height ?? 100,
          child: Container(child: Icon(Icons.play_arrow, size: 28)),
        ));
  }

  ///Override per cambiare il Widget per la visualizzazione degli Audio nella Lista degli XMedia
  Widget xLayout_Builder_AudioArea(XMediaItem? audio, bool isPreview) {
    if (playerController.waveformData.isEmpty) {
      isPreview ? _preparePlayer_WhenInPreview(audio!) : _preparePlayer(audio!);
    }
    return Align(
        alignment: Alignment.centerLeft,
        child: Container(
            padding: EdgeInsets.only(bottom: 6, right: 10, top: 6),
            margin: EdgeInsets.symmetric(vertical: 8, horizontal: 12),
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(10),
              color: Color(0xFF343145),
            ),
            child: Row(mainAxisSize: MainAxisSize.min, children: [
              // if (!controller.playerState.isStopped)
              IconButton(
                  onPressed: () async {
                    if (playerController.playerState.isPlaying.not())
                      await playerController.startPlayer(finishMode: FinishMode.pause);
                    else
                      await playerController.pausePlayer();
                  },
                  icon: Icon(playerController.playerState.isPlaying ? Icons.stop : Icons.play_arrow),
                  color: Colors.white,
                  splashColor: Colors.transparent,
                  highlightColor: Colors.transparent),
              Expanded(
                  child: AudioFileWaveforms(
                size: Size(MediaQuery.of(context).size.width / 2, 70),
                playerController: playerController,
                enableSeekGesture: true,
                waveformType: WaveformType.fitWidth,
                playerWaveStyle: PlayerWaveStyle(
                  fixedWaveColor: Colors.white54,
                  liveWaveColor: Colors.blueAccent,
                  spacing: 6,
                  showBottom: true,
                  showSeekLine: true,
                  showTop: true,
                ),
              ))
            ])));
  }

  ///Override per cambiare il Dialog di Visualizzazione dell'Audio
  Widget xLayout_Builder_AudioDialogWidget(XMediaItem? audio, XFDataItem xclItem, {double? width, double? height}) {
    return InkWell(
        onLongPress: () async => (audio != null && audio.xDocID != audio.id) ? null : await xOnDelXMedia_INTERNAL(audio!, xclItem),
        child: Container(
          alignment: Alignment.center,
          height: height ?? 100,
          width: width ?? 80,
          color: Colors.grey[800],
          child: Row(
            mainAxisAlignment: MainAxisAlignment.center,
            crossAxisAlignment: CrossAxisAlignment.center,
            mainAxisSize: MainAxisSize.min,
            children: [
              // if (!controller.playerState.isStopped)
              IconButton(
                onPressed: () async {
                  await xOnGetXMedia(audio!).then((x) {
                    if (x != null) {
                      audio.payload = x.payload;
                    }
                  });
                  await showDialog(
                      context: context,
                      builder: (context) {
                        return XAlertDialog(
                            height: 150,
                            actionsBTNarea_Child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                              Expanded(
                                  child: XBtnbase(
                                      label: "Chiudi",
                                      label_Color: Colors.red,
                                      onPressed: () {
                                        playerController.stopPlayer();
                                        playerController.dispose();
                                        Navigator.pop(context);
                                      }))
                            ]),
                            child: xLayout_Builder_AudioArea(audio, false),
                            title_Text: "");
                      });
                },
                icon: Icon(playerController.playerState.isPlaying ? Icons.stop : Icons.mic, size: 24),
                color: Colors.white,
                splashColor: Colors.transparent,
                highlightColor: Colors.transparent,
              ),
            ],
          ),
        ));
  }

  ///Override per aggiungere dei Widget a sinistra in alto dell'ItemComplex
  List<Widget> xLayout_xItemComplex_ListWidgets_TopLeft(XFDataItem item) {
    return [];
  }

  ///Override per cambiare comportamento al Background dell'ItemComplex
  Color? xLayout_XItem_BackgoundColor(XFDataItem obj) {
    return null;
  }

//
//
//
//Build dell'Elenco
//Build dell'Item Complex
//
//
//
//

  @override
  Widget build(BuildContext context) {
    return widget.pageMode_Active
        ? Scaffold(
            // resizeToAvoidBottomInset: false,
            appBar: widget.appBar_Custom_Visible
                ? null
                : widget.appBar_Visible
                    ?
                    // found.kIsWeb.not() && Platform.isAndroid && (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) && (MediaQuery.of(context).orientation == Orientation.portrait)
                    //     ? null
                    //     :
                    AppBar(
                        toolbarHeight: widget.appBar_Height ?? null,
                        automaticallyImplyLeading: (widget.schedaMode ?? false) ? false : true,
                        leadingWidth: widget.appBar_LeadingWidth ?? 200,
                        leading: widget.appBar_LeadingWidget ??
                            InkWell(
                                splashColor: Colors.transparent,
                                enableFeedback: false,
                                onTap: (widget.schedaMode ?? false) ? null : () => widget.onTapBack != null ? widget.onTapBack!() : widget.xApp!.state.scaffoldKey_MainMenu.currentState!.openDrawer(),
                                child: Container(
                                    child: Row(mainAxisSize: MainAxisSize.min, children: [
                                  (widget.schedaMode ?? false) ? Container() : Container(width: 40, child: Icon(Icons.arrow_back, color: widget.title_Color)),
                                  Flexible(child: Text(widget.title_Text, style: widget.title_Style ?? XStyles.xStyTextForLabel(textColor: widget.title_Color ?? XColors.foregroundLight), overflow: TextOverflow.ellipsis)),
                                ]))),
                        backgroundColor: XSchedaState.color_AppBar_Background,
                        actions: [
                            Container(margin: EdgeInsets.symmetric(vertical: 5, horizontal: 5), child: Row(children: xLayout_Actions())),
                            widget.onRefresh_ScrollDownList == null
                                ? Container()
                                : XBtnbase(
                                    icon: Icons.replay_outlined,
                                    onPressed: widget.onRefresh_ScrollDownList != null ? () => widget.onRefresh_ScrollDownList!(context) : () {},
                                    width: 40,
                                    height: 40,
                                    margin: EdgeInsets.all(5),
                                  ),
                          ])
                    : null,
            body: widget.widgetBuild_Override ??
                // Stack(children: [
                ValueListenableBuilder<bool>(
                  valueListenable: isBusy,
                  builder: (_, isBusy, __) {
                    if (isBusy.not()) {
                      return widget.xTab_List != null && widget.xTab_List!.isNotEmpty
                          ? Column(children: [
                              TabBar(
                                controller: tabController,
                                indicator: BoxDecoration(color: widget.title_Color),
                                isScrollable: widget.isScrollableTabs ?? widget.xTab_List!.length > 3 ? true : false,
                                indicatorPadding: EdgeInsets.all(2),
                                indicatorColor: widget.title_Color,
                                indicatorWeight: 4.0,
                                labelPadding: EdgeInsets.all(0),
                                padding: EdgeInsets.all(0),
                                tabs: widget.xTab_List!
                                    .map((x) => tabPagesSch(
                                          x.icon,
                                          x.caption,
                                          x,
                                          iconsColor_Active: x.iconColor_Active,
                                          iconsColor_Disabled: x.iconColor_Disabled,
                                          labelColor_Active: x.labelColor_Active,
                                          labelColor_Disabled: x.labelColor_Disabled,
                                        ) as Widget)
                                    .toList(),
                                onTap: (idx) {
                                  FocusScopeNode currentFocus = FocusScope.of(context);
                                  if (!currentFocus.hasPrimaryFocus && currentFocus.focusedChild != null) {
                                    FocusManager.instance.primaryFocus?.unfocus();
                                  }
                                },
                              ),
                              Expanded(
                                  child: Container(
                                      child: GestureDetector(
                                          child: TabBarView(
                                children: widget.xTab_List!.map((xTab) => xTab.content ?? Container()).toList(),
                                controller: tabController,
                              )))),
                            ])
                          : xLayout_AreaElenco();
                    } else
                      return XStatefulWidgetBase.LoaderIndicator(isBusy, label: xWaiterMessage);
                  },
                ),
            floatingActionButton: isActive_addDropInElenco ? null : widget.floatingActionButton,
            drawer: widget.xDrawerMenu)
        : widget.widgetBuild_Override ??
            Scaffold(
              resizeToAvoidBottomInset: false,
              body: xLayout_AreaElenco(),
            );
  }

  ///Build dell'XItemComplex per la visualizzazione di Media o Dati a Tree nidificati
  buildXItem<T extends XFDataItem, K extends XFDataItem?>(
    T item,
    void Function(void Function()) parentSetState, {
    List<dynamic>? liChildrens,
    Widget Function(dynamic)? dettItem,
    Function(T)? onLongPress_MainItem,
    Function(T)? BTNadd_cmdAdd,
    dynamic Function(T)? BTN_cmdEdit,
    String? BTNadd_label,
    Widget? mainWidget,
    Color? backGround_Color,
    Color? backGround_Color_ItemSel,
    Color? border_Color,
    Widget Function(dynamic)? dettWidget,
    EdgeInsetsGeometry? margin,
    List<XPopUpMenuItem>? liPopUpMenu_Items,
    bool border_Visible = false,
    bool title_InMainWidget_Visible = false,
    XView? xView_Scheda,
    XView? xView_Elenco,
    XView? xViewDett,
    List<Widget>? titleLiWidgets,
    bool viewDett_Data = false,
    bool showXMedia_Always = false,
    bool viewXMediaUI = false,
    bool bottomWidgets_WithMainWidget = false,
    BorderRadiusGeometry? borderRadius_Item,
    List<XAction>? listWidgets_BTNactions,
    List<Widget>? listWidgets_bottomMainWidget,
    List<Widget>? listWidgets_TopLeft,
  }) {
    xRoundedStyle_Active ? borderRadius_Item = BorderRadius.circular(20) : null;
    xLayout_XItem_BackgoundColor(item) != null ? backGround_Color = xLayout_XItem_BackgoundColor(item) : null;
    return StatefulBuilder(
      builder: (context, setState) {
        listWidgets_TopLeft = List<Widget>.empty(growable: true);
        List<XAction>? _xActionsLi_LEFT = List<XAction>.empty(growable: true);
        List<XAction>? _xActionsLi_RIGHT = List<XAction>.empty(growable: true);
        List<XAction>? _xActionsLi_FAST = List<XAction>.empty(growable: true);
        GlobalKey<PopupMenuButtonState> popUp_Key = GlobalKey<PopupMenuButtonState>();
        liPopUpMenu_ActionOnItem.clear();
        if (xActionLi_RIGHT!.any((element) => element.key == "BTN_Edit").not() || xActionLi_LEFT!.any((element) => element.key == "BTN_Edit").not() || xActionLi_LEFT!.any((element) => element.key == "BTN_Edit").not()) {
          liPopUpMenu_ActionOnItem.add(XPopUpMenuItem(
              title: "Modifica",
              color: Colors.yellow,
              icon: Icons.edit,
              toolTip_Message: XfxToolTips.BTN_Modifica,
              onPressed: BTN_cmdEdit != null
                  ? (context, obj) async {
                      var res = await BTN_cmdEdit(obj);
                      return res;
                    }
                  : (context, obj) async {
                      if (xView_Elenco != null) {
                        var res = await xPreview_Dialog(xView_Elenco, obj);
                        if (res != null) {
                          // item = res.getCloneFull() as T;
                          obj.isModified = true;
                          widget.itemEdited != null ? widget.itemEdited!(obj) : null;
                        }
                        return obj;
                      } else
                        return obj;
                    }));
        }

        listWidgets_TopLeft!.addAll(xLayout_xItemComplex_ListWidgets_TopLeft(item));

        if (liPopUpMenu_Items != null) liPopUpMenu_ActionOnItem.addAll(liPopUpMenu_Items);

        if (listWidgets_BTNactions != null) xActionLi_FAST!.addAll(listWidgets_BTNactions);

        //Aggiungo alla lista delle XActionsRight quelle fisse a livello di xelenco
        if (xActionLi_RIGHT != null) _xActionsLi_RIGHT.addAll(xActionLi_RIGHT!.toList());

        if (xActions_RIGHT_ForItem(item) != null) {
          xActions_RIGHT_ForItem(item)!.forEach((xActionRight) {
            if (xActionRight != null) _xActionsLi_RIGHT.add(xActionRight);
          });
        }

        //Aggiungo alla lista delle XActionsLeft quelle fisse a livello di xelenco
        if (xActionLi_LEFT != null) _xActionsLi_LEFT.addAll(xActionLi_LEFT!.toList());

        //Aggiungo le altre XAction Left a livello di Item dell'elenco
        if (xActions_LEFT_ForItem(item) != null) {
          xActions_LEFT_ForItem(item)!.forEach((xActionLeft) {
            if (xActionLeft != null) _xActionsLi_LEFT.add(xActionLeft);
          });
        }

        xActionLi_FAST!.where((element) => element.idx! < 900 && element.fastAction.not()).forEach((element) {
          liPopUpMenu_ActionOnItem.add(XPopUpMenuItem(
            title: element.label ?? "",
            iconImage: element.icon_Image != null ? Image.memory(element.icon_Image!, width: 40, height: 40) : null,
            icon: element.icon,
            color: element.label_Color,
            toolTip_Message: element.toolTip ?? "",
            onPressed: (p0, p1) => element.cmd != null ? element.cmd!(p1, parentSetState, context) : null,
          ));
        });

        if (xActionLi_FAST != null) _xActionsLi_FAST.addAll(xActionLi_FAST!);
        //Aggiungo le altre XAction Left a livello di Item dell'elenco
        if (xActions_FAST_ForItem(item) != null) {
          xActions_FAST_ForItem(item)!.forEach((xActionFast) {
            if (xActionFast != null) _xActionsLi_FAST.add(xActionFast);
          });
        }
        xMedia_Empty(item)
            ? null
            : _xActionsLi_RIGHT.add(XAction(
                XActionsBase.addXMedia.key,
                1,
                "",
                cmd: (p0, parentSetState, context) async => await xCMD_XMedia_GetMedia(parentSetState, item).then((value) => parentSetState(() {})),
                icon_Color: XActionsBase.addXMedia.icon_Color,
                icon: XActionsBase.addXMedia.icon,
              ));
        xActionLi_FAST != null && xActionLi_FAST!.isNotEmpty
            ? _xActionsLi_RIGHT.add(XAction(
                "BTN_Edit",
                2,
                "",
                cmd: BTN_cmdEdit != null
                    ? (p0, parentSetState, context) async {
                        var res = await BTN_cmdEdit(p0 as T);
                        return res;
                      }
                    : (p0, parentSetState, context) async {
                        if (xView_Elenco != null) {
                          var res = await xPreview_Dialog(xView_Elenco, p0);
                          if (res != null) {
                            p0!.isModified = true;
                            widget.itemEdited != null ? widget.itemEdited!(p0) : null;
                          }
                          return p0;
                        } else
                          return p0;
                      },
                icon_Color: Colors.yellow,
                icon: Icons.edit,
              ))
            : null;
        listWidgets_bottomMainWidget = List<Widget>.empty(growable: true);
        if (xView_Elenco != null) {
          xView_Elenco.cols!.where((xcol) => xcol.colKey.startsWith("li").not() && xcol.width >= 350).forEach((element) {
            if (item[element.colKey] is String && item[element.colKey] != "") {
              listWidgets_bottomMainWidget!.add(xLayout_Item_RowWidgets(element, item));
            } else if (item[element.colKey] is double && item[element.colKey] != 0.0 && element.colKey.startsWith("avanz").not()) {
              listWidgets_bottomMainWidget!.add(xLayout_Item_RowWidgets(element, item));
            } else if (item[element.colKey] is int && item[element.colKey] != 0) {
              listWidgets_bottomMainWidget!.add(xLayout_Item_RowWidgets(element, item));
            } else if (item[element.colKey] is DateTime) {
              listWidgets_bottomMainWidget!.add(xLayout_Item_RowWidgets(element, item));
            } else if (item[element.colKey] is bool) {
              listWidgets_bottomMainWidget!.add(xLayout_Item_RowWidgets(element, item));
            } else if (element.colKey.startsWith("avanz")) {
              listWidgets_bottomMainWidget!.add(xLayout_Item_RowWidgets(element, item));
            }
          });
        }
        return Container(
            margin: EdgeInsets.only(bottom: 2),
            padding: EdgeInsets.symmetric(vertical: 0),
            child: DragTarget<XFDataItem>(onWillAccept: (data) {
              var res = xOnDrop_BeforeAccept(data!, item);
              parentSetState(() {
                if (res)
                  item.isSel = true;
                else
                  item.isSel = false;
              });
              return res;
            }, onAccept: (data) async {
              await xOnDrop_Accept(data, item);
              parentSetState(() => item.isSel = false);
            }, onLeave: (data) {
              xOnDrop_Leave(data!);
              parentSetState(() => item.isSel = false);
            }, builder: (context, candidateData, rejectedData) {
              return XElencoItem(setState, item, context, xView_Scheda!,
                  xViewDetts: xViewDett,
                  liXActions_LEFT: _xActionsLi_LEFT,
                  liXActions_RIGHT: _xActionsLi_RIGHT,
                  liXActions_FAST: _xActionsLi_FAST,
                  xActions_RIGHT_HorizontalAxis: xActions_RIGHT_HorizontalAxis,
                  xActions_LEFT_HorizontalAxis: xActions_LEFT_HorizontalAxis,
                  widgetOnStackOfItems: xLayout_WidgetOverItems(item),
                  onLongTapItem: () => onLongPress_MainItem!(item),
                  margin: margin ?? EdgeInsets.only(left: 4, right: 4, bottom: 4),
                  changeStatoWithTap: false,
                  funct: () => widget.itemEdited!(item),
                  onTapItem: () async {
                    if ((liChildrens == null || liChildrens.isEmpty) && xMedia_Empty(item)) {
                    } else {
                      if (dettItem == null) {
                        if (BTN_cmdEdit != null) BTN_cmdEdit(item);
                      } else
                        parentSetState(() => item.isShowDetails = item.isShowDetails.not());
                    }
                  },
                  showTrailingArrow: false,
                  decorationBackGroundContainer: widget.xApp!.state.xBox_Decoration(
                    item,
                    backGround_Color: backGround_Color,
                    border_Color: border_Color,
                    border_Visible: border_Visible,
                    backGround_Color_ItemSel: backGround_Color_ItemSel,
                  ),
                  showingDetails: item.isShowDetails,
                  showMainWithDetails: true,
                  childMain: DragTarget<T>(
                      onWillAccept: (data) => xOnDrop_BeforeAccept(data!, item),
                      onAccept: (data) async => await xOnDrop_Accept(data, item),
                      builder: (context, candidateData, rejectedData) {
                        return Column(mainAxisSize: MainAxisSize.min, children: [
                          InkWell(
                              // onLongPress: () {
                              //   onLongPress_MainItem!(item);
                              // },
                              onTap: () {
                                if (dettItem == null) {
                                  if (BTN_cmdEdit != null) BTN_cmdEdit(item);
                                } else {
                                  setState(() => item.isShowDetails = item.isShowDetails.not());
                                }
                              },
                              child: Row(crossAxisAlignment: CrossAxisAlignment.center, mainAxisAlignment: MainAxisAlignment.start, children: [
                                //Icona di Expand della riga
                                Column(children: [
                                  BTNadd_cmdAdd == null || (mainWidget != null || (liChildrens == null || liChildrens.isEmpty))
                                      ? Container(width: 0, height: 0) //
                                      : Container(
                                          width: 30,
                                          margin: EdgeInsets.only(right: 4),
                                          child: Icon(
                                              (item.isShowDetails)
                                                  ? Icons.arrow_upward_rounded //
                                                  : Icons.account_tree_outlined,
                                              color: XColors.foregroundLight)),
                                  Column(children: listWidgets_TopLeft!.map((e) => e).toList()),
                                ]),

                                //Area della composizione dei dati
                                mainWidget != null
                                    ? Container()
                                    : xView_Elenco != null && widget.showHead
                                        ? Expanded(
                                            child: xView_Elenco.cols!.length == 1
                                                ? widget.isEditable
                                                    ? xLayout_CellWidget_Editable(xView_Elenco.cols!.first, item, context, item) //
                                                    : xLayout_Item_RowWidgets(xView_Elenco.cols!.first, item, flexible: true) //
                                                : Row(children: [
                                                    xView_Elenco.cols!.where((xcol) => xcol.colKey.startsWith("li").not() && xcol.width < 350).length == 1
                                                        ? Expanded(
                                                            child: widget.isEditable
                                                                ? xLayout_CellWidget_Editable(xView_Elenco.cols!.where((xcol) => xcol.colKey.startsWith("li").not() && xcol.width < 350).first, item, context, item) //
                                                                : xLayout_Item_RowWidgets(xView_Elenco.cols!.where((xcol) => xcol.colKey.startsWith("li").not() && xcol.width < 350).first, item)) //
                                                        : Expanded(child: Wrap(children: xLayout_RenderDett_HeadDataView(xView_Elenco, item, border_Visible: false, liColsToUse: xView_Elenco.cols!.where((xcol) => xcol.colKey.startsWith("li").not() && xcol.width < 350).toList())))
                                                  ]),
                                          )
                                        : Container(),
                                mainWidget != null
                                    ? Expanded(
                                        child: Column(children: [
                                        Row(children: [Expanded(child: mainWidget)]),
                                        bottomWidgets_WithMainWidget
                                            ? Row(children: [
                                                listWidgets_bottomMainWidget != null
                                                    ? Expanded(
                                                        child: Column(
                                                        mainAxisSize: MainAxisSize.min,
                                                        children: listWidgets_bottomMainWidget!.map((e) => Row(children: [e])).toList(),
                                                      ))
                                                    : Container()
                                              ])
                                            : Container()
                                      ]))
                                    : Container(),
                                Container(
                                    width: 40,
                                    child: InkWell(
                                        onTap: () {
                                          if (dettItem == null) {
                                            if (BTN_cmdEdit != null) BTN_cmdEdit(item);
                                          } else {
                                            setState(() => item.isShowDetails = item.isShowDetails.not());
                                          }
                                        },
                                        child: Wrap(
                                            direction: Axis.vertical,
                                            children: _xActionsLi_FAST
                                                .where((element) => BTNadd_cmdAdd == null
                                                    ? element.key != XActionsBase.addDett.key &&
                                                        element.key != XActionsBase.popUpActions.key &&
                                                        (xMedia_Empty(item)
                                                            ? element.key != XActionsBase.showXMedia.key //
                                                            : element.key != XActionsBase.addXMedia.key)
                                                    : element.key != XActionsBase.popUpActions.key &&
                                                        (xMedia_Empty(item)
                                                            ? element.key != XActionsBase.showXMedia.key //
                                                            : element.key != XActionsBase.addXMedia.key))
                                                .map((e) {
                                              if (e.key == XActionsBase.popUpActions.key) {
                                                return liPopUpMenu_ActionOnItem.isNotEmpty
                                                    ? liPopUpMenu_ActionOnItem.length == 1
                                                        ? xActionLi_FAST!.any((element) => element.key == "BTN_Edit").not()
                                                            ? XActionWidget(
                                                                e,
                                                                onPressed: () async => setState(() => liPopUpMenu_ActionOnItem.first.onPressed!(context, item)),
                                                                xApp: widget.xApp,
                                                                icon_Color: liPopUpMenu_ActionOnItem.first.color,
                                                                icon: liPopUpMenu_ActionOnItem.first.icon,
                                                              )
                                                            : Container()
                                                        : Container(
                                                            height: xActionsBTN_Height,
                                                            width: xActionsBTN_Width,
                                                            margin: EdgeInsets.only(top: 3, bottom: 3),
                                                            decoration: BoxDecoration(color: xActionsBTN_BackgroundColor, border: Border.all(width: 1, color: xActionsBTN_BorderColor), borderRadius: BorderRadius.all(Radius.circular(10))),
                                                            child: PopupMenuButton(
                                                                padding: EdgeInsets.all(0),
                                                                key: popUp_Key,
                                                                tooltip: "Vedi azioni",
                                                                icon: Icon(Icons.more_vert_outlined),
                                                                itemBuilder: (context) {
                                                                  return liPopUpMenu_ActionOnItem
                                                                      .map((e) => PopupMenuItem(
                                                                          height: 40,
                                                                          child: XBtnbase(
                                                                              decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                                                                              height: 40,
                                                                              width: (e.iconImage != null || e.icon != null) ? 250 : 150,
                                                                              label: e.title,
                                                                              icon_WidthArea: 50,
                                                                              label_Style: XStyles.xStyTextForSubLabel(textColor: e.color),
                                                                              icon_Widget: e.icon != null ? null : Container(width: 50, child: e.iconImage),
                                                                              icon: e.iconImage != null ? null : e.icon,
                                                                              icon_Size: 23,
                                                                              icon_Color: e.iconImage != null ? null : e.color,
                                                                              toolTip_Message: e.toolTip_Message,
                                                                              onPressed: () {
                                                                                Navigator.pop(context);
                                                                                e.onPressed!(context, item);
                                                                              })))
                                                                      .toList();
                                                                },
                                                                iconSize: 22))
                                                    : Container();
                                              } else {
                                                return XActionWidget(
                                                  e,
                                                  xApp: widget.xApp,
                                                  onPressed: () async {
                                                    if (e.cmd != null) {
                                                      setState(() => e.cmd!(item, setState, context));
                                                    } else {
                                                      if (e.key == XActionsBase.showXMedia.key) {
                                                        if (xMedia_Empty(item).not()) {
                                                          FocusScope.of(context).unfocus();
                                                          setState(() {
                                                            item.showXMedia = item.showXMedia.not();
                                                          });
                                                        }
                                                      } else if (e.key == XActionsBase.addXMedia.key) {
                                                        await xCMD_XMedia_GetMedia(setState, item).then((value) => setState(() {}));
                                                      } else if (e.key == XActionsBase.addDett.key) {
                                                        setState(() {
                                                          FocusScope.of(context).unfocus();
                                                          BTNadd_cmdAdd!(item);
                                                          item.isShowDetails = true;
                                                        });
                                                      } //
                                                    }
                                                  },
                                                  icon: e.key == XActionsBase.showXMedia.key
                                                      ? xMedia_Empty(item).not()
                                                          ? (showXMedia_Always || item.showXMedia)
                                                              ? Icons.visibility_off
                                                              : Icons.visibility
                                                          : Icons.visibility_off
                                                      : null,
                                                  icon_Color: e.key == XActionsBase.showXMedia.key ? (xMedia_Empty(item) ? Colors.grey[800] : Colors.purple[600]) : null,
                                                );
                                              }
                                            }).toList())))
                              ])),
                          bottomWidgets_WithMainWidget.not()
                              ? listWidgets_bottomMainWidget != null
                                  ? InkWell(
                                      onTap: () {
                                        if (dettItem == null) {
                                          if (BTN_cmdEdit != null) BTN_cmdEdit(item);
                                        } else
                                          setState(() => item.isShowDetails = item.isShowDetails.not());
                                      },
                                      child: Column(
                                        mainAxisSize: MainAxisSize.min,
                                        children: listWidgets_bottomMainWidget!.map((e) => Container(margin: EdgeInsets.symmetric(vertical: 4), child: Row(children: [e]))).toList(),
                                      ))
                                  : Container()
                              : Container(),
                          xMedia_Active && (showXMedia_Always || item.showXMedia)
                              ? Container(
                                  child: Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
                                  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA
                                  xMedia_Empty(item).not()
                                      ? Container(
                                          margin: EdgeInsets.all(3),
                                          decoration: BoxDecoration(border: Border.all(color: Colors.grey[700]!)),
                                          child: Column(children: [
                                            Row(children: [
                                              Expanded(
                                                  child: Wrap(
                                                      alignment: WrapAlignment.center,
                                                      runAlignment: WrapAlignment.center,
                                                      spacing: 5,
                                                      runSpacing: 5,
                                                      children: xMediaListOfMine(item).map((e) {
                                                        if (e.mediaType == XEnums.mediaType.audio.value) {
                                                          return xLayout_Builder_AudioDialogWidget(e, item);
                                                        } else if (e.mediaType == XEnums.mediaType.video.value) {
                                                          return xLayout_Builder_VideoWidget(e, item, setState: setState);
                                                        } else {
                                                          return xLayout_Builder_ImmaginiWidget(e, item, setState);
                                                        }
                                                      }).toList()))
                                            ])
                                          ]))
                                      : Container(),
                                  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA
                                ]))
                              : Container()
                        ]);
                      }),
                  childDetails: Column(
                    children: [
                      dettWidget != null
                          ? dettWidget(item)
                          : dettItem != null
                              ? liChildrens != null
                                  ? Wrap(
                                      spacing: 5,
                                      runSpacing: 5,
                                      children: liChildrens.map((xclVoce) {
                                        return dettItem(xclVoce);
                                      }).toList())
                                  : Container()
                              : Container(),
                    ],
                  ));
            }));
      },
    );
  }

//
//
//
//Metodi da spostare o da sistemare
//Metodi da spostare o da sistemare
//Metodi da spostare o da sistemare
//
//
//

  _xFilter_build() {
    if (xFilter_XFilters.isEmpty) return Container();
    return InkWell(
        onTap: () => _menuController.open(),
        child: Row(
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            /// LABELS    /// LABELS /// LABELS    /// LABELS /// LABELS    /// LABELS
            xFilter_XFilters.length == 1
                // SINGOLO
                ? Container()
                // MULTI XFILTER
                : Container(
                    alignment: Alignment.center,
                    width: 170,
                    child: Column(mainAxisAlignment: MainAxisAlignment.center, children: [
                      Wrap(
                        runAlignment: WrapAlignment.center,
                        alignment: WrapAlignment.center,
                        children: xFilter_XFilters
                            .map((e) => Container(
                                  alignment: Alignment.center,
                                  width: 170,
                                  child: Row(
                                    crossAxisAlignment: CrossAxisAlignment.center,
                                    children: [
                                      Text(
                                        e.xPropOfItemToFilter.col_Label,
                                        style: XStyles.xStyTextForSubDescr(textColor: e.xPropOfItemToFilter.col_Color == Colors.black ? XColors.foregroundLight : e.xPropOfItemToFilter.col_Color),
                                      ),
                                      SizedBox(width: 10),
                                      Expanded(
                                          child: Container(
                                              padding: EdgeInsets.symmetric(horizontal: 4),
                                              color: (e.Value is XEnumDef ? (e.Value as XEnumDef).backColor : null),
                                              child: Text(
                                                XfxUtils.xddValueToString(e.Value, e.ColsOfXFdataItemToShow),
                                                style: XStyles.xStyTextForSubDescr(textColor: (e.Value is XEnumDef ? (e.Value as XEnumDef).textColor : XColors.foregroundLight)),
                                              ))),
                                    ],
                                  ),
                                ))
                            .toList(),
                      )
                    ]),
                  ),
            // UI XFILTER con VALUE
            // UI XFILTER con VALUE
            // UI XFILTER con VALUE
            // UI XFILTER con VALUE
            // UI XFILTER con VALUE
            xFilter_XFilters.length == 1
                // SINGOLO XFILTER
                ? Container(
                    width: ((xFilter_XFilters.first.width ?? 200) * widget.xApp!.KforScale) < 170 ? 170 : (xFilter_XFilters.first.width ?? 200) * widget.xApp!.KforScale,
                    child: XfxDropDown<dynamic>(
                      xFilter_XFilters.first.ColsOfXFdataItemToShow,
                      label: "",
                      menu_SearchBoxBorderANDtitle_Color: ThemeData.estimateBrightnessForColor(xFilter_XFilters.first.backgroundMenuColor ?? xFilter_XFilters.first.xPropOfItemToFilter.col_Color) == Brightness.dark ? XColors.foregroundLight : XColors.foregroundDark,
                      menu_height: xFilter_XFilters.first.menu_height,
                      background_Color: (value) => xFilter_XFilters.first.backgroundMenuColor ?? xFilter_XFilters.first.xPropOfItemToFilter.col_Color,
                      liItems: xFilter_XFilters.first.Items,
                      itemSelected: xFilter_XFilters.first.Value,
                      label_Behavior: FloatingLabelBehavior.auto,
                      item_TextStyle: (p0) => xFilter_XFilters.first.textStyle != null
                          ? xFilter_XFilters.first.textStyle!(p0) //
                          : xFilter_XFilters.first.Value is XEnumDef
                              ? XStyles.xStyTextForTitle(textColor: ThemeData.estimateBrightnessForColor((xFilter_XFilters.first.Value as XEnumDef).backColor) == Brightness.dark ? XColors.foregroundLight : XColors.foregroundDark)
                              : XStyles.xStyTextForTitle(textColor: XColors.foregroundLight),
                      item_LabelStyle: (p0) => xFilter_XFilters.first.textStyle != null ? xFilter_XFilters.first.textStyle!(p0) : XStyles.xStyTextForTitle(textColor: p0),
                      clearBTN_Active: xFilter_XFilters.first.All != null && xFilter_XFilters.first.Value != xFilter_XFilters.first.All,
                      onChanged_ItemOfDD: (value) {
                        setState(() {
                          xFilter_XFilters.first.Value = value == null ? xFilter_XFilters.first.All : value;
                          print(xFilter_XFilters.first.Value);
                        });
                      },
                    ))
                //MULTI XFILTER
                : PopupMenuButton(
                    itemBuilder: (context) {
                      return xFilter_XFilters.map((e) => PopupMenuItem(child: xLayout_xFilter_Builder_XFilterEl(e))).toList();
                    },
                    icon: Icon(Icons.filter_alt_outlined),
                    tooltip: "Vedi Filtri",
                  )
            //   MenuAnchor(
            // // key: UniqueKey(),
            // controller: _menuController,
            // builder: (BuildContext context, MenuController controller, Widget? child) {
            //   return IconButton(
            //     onPressed: () {
            //       if (controller.isOpen) {
            //         controller.close();
            //       } else {
            //         controller.open();
            //       }
            //     },
            //     icon: Icon(Icons.filter_alt_outlined),
            //     tooltip: 'Vedi Filtri',
            //   );
            // },
            // menuChildren: xFilter_XFilters.map((e) => xLayout_xFilter_Builder_XFilterEl(e)).toList()),
          ],
        ));
  }

  tabPagesSch(
    IconData? icon,
    String? label,
    XTabItem? item, {
    TextStyle? labelStyle_ALL,
    Color? labelColor_ALL,
    Color? labelColor_Active,
    Color? labelColor_Disabled,
    Color? iconsColor_ALL,
    Color? iconsColor_Active,
    Color? iconsColor_Disabled,
    Color? color_backGroundTab_Activate,
    Color? color_backGroundTab,
  }) {
    Color getTabItem_IconColor(XTabItem item, int idx) {
      if (tabController.index == item.idx) {
        return item.iconColor_Active ?? iconsColor_Active ?? iconsColor_ALL ?? XColors.foregroundLight;
      } else {
        return item.iconColor_Disabled ?? iconsColor_Disabled ?? iconsColor_ALL ?? XColors.foregroundLight;
      }
    }

    Color getTabItem_LabelColor(XTabItem item, int idx) {
      if (tabController.index == item.idx) {
        return item.labelColor_Active ?? labelColor_Active ?? iconsColor_Active ?? labelColor_ALL ?? iconsColor_ALL ?? XColors.foregroundLight;
      } else {
        return item.labelColor_Disabled ?? labelColor_Disabled ?? labelColor_ALL ?? iconsColor_Disabled ?? iconsColor_ALL ?? XColors.foregroundLight;
      }
    }

    return Container(
        margin: EdgeInsets.symmetric(horizontal: 2),
        constraints: BoxConstraints(minWidth: 80),
        color: tabController.index == item!.idx ? (item.color_backGroundTab_Activate ?? Colors.grey[900]!) : (item.color_backGroundTab ?? Colors.grey[900]!),
        child: Tab(
            height: 50,
            iconMargin: EdgeInsets.only(bottom: 2),
            icon: icon != null ? Icon(icon, color: iconsColor_ALL ?? getTabItem_IconColor(item, tabController.index)) : null,
            child: Row(children: [
              widget.xTab_List!.length > 3
                  ? Container(
                      padding: EdgeInsets.symmetric(horizontal: 10),
                      child: Text(
                        label ?? "",
                        textAlign: TextAlign.center,
                        style: labelStyle_ALL ?? XStyles.xStyTextForDescr(textColor: getTabItem_LabelColor(item, tabController.index)),
                      ))
                  : Expanded(
                      child: Container(
                          padding: EdgeInsets.symmetric(horizontal: 10),
                          child: Text(
                            label ?? "",
                            textAlign: TextAlign.center,
                            style: labelStyle_ALL ?? XStyles.xStyTextForDescr(textColor: getTabItem_LabelColor(item, tabController.index)),
                          )))
            ])));
  }

  void _preparePlayer(XMediaItem item) async {
    final playerWaveStyle = const PlayerWaveStyle(
      fixedWaveColor: Colors.white54,
      liveWaveColor: Colors.white,
      spacing: 6,
    );
    var dir = Directory("${XLibStorage.filePath}/XMEDIAS/");
    if (dir.existsSync()) {
      var liFiles = dir.listSync();
      var rawFile = liFiles.firstWhereOrNull((e) => e.path.split(".")[0].contains(item.id));
      //Se il file non esiste lo creo e lo riempo con quello che mi ritorna dalle API
      if (rawFile == null) {
        file = await File("${XLibStorage.filePath}/XMEDIAS/${item.id}_.${extForMediaType(item.mediaType!)}").create();
        await xOnGetXMedia(item).then((x) {
          if (x != null) item.payload = x.payload;
        });
        await file?.writeAsBytes(item.payload!);
      } else {
        //Se esiste gia fillo solo la variabile che uso come appoggio
        file = File(rawFile.path);
      }
    } else {
      //Se invece non esiste ancora la cartella XMedia creo la cartella, prendo il payload e lo riempo
      file = await File("${XLibStorage.filePath}/XMEDIAS/${item.id}_.${extForMediaType(item.mediaType!)}").create();
      await xOnGetXMedia(item).then((x) {
        if (x != null) item.payload = x.payload;
      });
      await file?.writeAsBytes(item.payload!);
    }
    await playerController.preparePlayer(path: file!.path, shouldExtractWaveform: true);
    await playerController.extractWaveformData(path: file!.path, noOfSamples: playerWaveStyle.getSamplesForWidth(200)).then((waveformData) => debugPrint(waveformData.toString()));
  }

  void _preparePlayer_WhenInPreview(XMediaItem item) async {
    final playerWaveStyle = const PlayerWaveStyle(
      fixedWaveColor: Colors.white54,
      liveWaveColor: Colors.white,
      spacing: 6,
    );
    // Opening file from assets folder
    var liFiles = Directory("${XLibStorage.filePath}/XMEDIAS/").listSync();
    var rawFile = liFiles.firstWhereOrNull((e) => e.path.split(".")[0].contains(item.id));
    file = File(rawFile!.path);
    await file?.writeAsBytes(file!.readAsBytesSync());
    // Prepare player with extracting waveform if index is even.
    await playerController.preparePlayer(path: file!.path, shouldExtractWaveform: true);
    // Extracting waveform separately if index is odd.
    await playerController.extractWaveformData(path: file!.path, noOfSamples: playerWaveStyle.getSamplesForWidth(200)).then((waveformData) => debugPrint(waveformData.toString()));
  }

  Future _getImages_FromGallery() async {
    var pickedFiles = await picker.pickMultiImage();
    setState(() {
      if (pickedFiles.isNotEmpty) {
        _images.clear();
        for (var pickedFile in pickedFiles) {
          _images.add(XFile(pickedFile.path));
        }
      } else {
        print('No images selected.');
      }
    });
  }

  // Funzione per ruotare l'immagine in base all'orientamento
  Future<Uint8List> _rotateImageFromBytes(Uint8List bytes) async {
    img.Image image = img.decodeImage(bytes)!;
    // Ottieni l'orientamento dell'immagine (può essere implementato in base alla tua necessità)
    int orientation = _getOrientation(bytes);

    // Ruota l'immagine in base all'orientamento
    img.Image rotatedImage = _rotateImage(image, orientation);

    // Converte l'immagine ruotata in bytes
    Uint8List rotatedImageBytes = img.encodePng(rotatedImage);

    return rotatedImageBytes;
  }

  int _getOrientation(Uint8List bytes) {
    if (bytes.length < 2) {
      // Non ci sono abbastanza bytes per determinare l'orientamento
      return 1; // Orientamento di default
    }

    if (bytes[0] == 0xFF && bytes[1] == 0xD8) {
      // I primi due bytes indicano l'inizio di un file JPEG
      int offset = 2;

      while (offset + 1 < bytes.length) {
        int marker = (bytes[offset] << 8) | bytes[offset + 1];

        if ((marker & 0xFF00) != 0xFF00) {
          // Non è un marker valido, esci dal ciclo
          break;
        }

        offset += 2;

        if (marker == 0xFFE1 && offset + 2 < bytes.length) {
          // Trovato un marker di App1 (contiene dati Exif)
          int length = (bytes[offset] << 8) | bytes[offset + 1];

          if (offset + length > bytes.length) {
            // I dati Exif vanno oltre la fine dei bytes disponibili
            break;
          }

          // I dati Exif iniziano dopo gli 8 bytes dell'intestazione
          offset += 8;

          if (offset + 2 < bytes.length) {
            // Verifica se c'è la stringa "Exif" (45 78 69 66)
            if (bytes[offset] == 0x45 && bytes[offset + 1] == 0x78 && bytes[offset + 2] == 0x69 && bytes[offset + 3] == 0x66) {
              // Trovato l'header Exif
              offset += 6;

              if (offset + 2 < bytes.length) {
                // Ottieni l'orientamento (tag 0x0112)
                int orientationTag = (bytes[offset] << 8) | bytes[offset + 1];

                if (orientationTag == 0x0112 && offset + 10 < bytes.length) {
                  int orientation = bytes[offset + 8];
                  return orientation;
                }
              }
            }
          }
        }

        // Vai al prossimo marker
        offset += 2;

        // Salta la lunghezza del segmento
        if (offset + 2 < bytes.length) {
          int length = (bytes[offset] << 8) | bytes[offset + 1];
          offset += length;
        }
      }
    } else if (bytes.length >= 33 && bytes[12] == 0x70 && bytes[13] == 0x48 && bytes[14] == 0x59 && bytes[15] == 0x73) {
      // Trovato il chunk IHDR (Header Chunk) con il nome "pHYs"
      int width = (bytes[16] << 24) | (bytes[17] << 16) | (bytes[18] << 8) | bytes[19];
      int height = (bytes[20] << 24) | (bytes[21] << 16) | (bytes[22] << 8) | bytes[23];

      if (width > height) {
        return 6; // Orientamento orizzontale
      } else {
        return 1; // Orientamento verticale
      }
    }

    // Nessuna informazione Exif trovata, restituisci l'orientamento di default
    return 1;
  }

// Funzione per ruotare l'immagine in base all'orientamento
  img.Image _rotateImage(img.Image image, int orientation) {
    switch (orientation) {
      case 3:
        return img.copyRotate(image, angle: 180);
      case 6:
        return img.copyRotate(image, angle: -90);
      case 8:
        return img.copyRotate(image, angle: 90);
      default:
        return image;
    }
  }

  static String extForMediaType(int mediatype) => mediatype == XEnums.mediaType.video.value
      ? "mp4"
      : mediatype == XEnums.mediaType.image.value
          ? "jpg"
          : "aac";
}

class gds_El extends XGridDataSource<XFDataItem> {
  gds_El(List<XFDataItem> items, XView view, {this.rootItemEdited}) : super(items, view);
  Function(XFDataItem)? rootItemEdited;

  @override
  Widget xBuilder_XCell(DataGridCell<dynamic> item, XDataGridRow xGridDataRow) {
    return super.xBuilder_XCell(item, xGridDataRow)!;
  }

  @override
  void xOnCellSubmit(XDataGridRow dataGridRow, RowColumnIndex rowColumnIndex, GridColumn column) {
    rootItemEdited!(dataGridRow.item);
  }
}

abstract class AutocompleteItem {
  String? nickName;
  String? nome;
  String? cognome;
  String? cell;
  String? email;
}

class DynamicCli extends XFDataItem implements AutocompleteItem {
  DynamicCli(super.id, this.nickName, this.nome, this.cognome, this.cell, this.email);

  @override
  String? cognome;
  @override
  String? nickName;
  @override
  String? email;
  @override
  String? nome;
  @override
  String? cell;
}
